/**
 * Copyright (C) 2003-2019, Foxit Software Inc..
 * All Rights Reserved.
 *
 * http://www.foxitsoftware.com
 *
 * The following code is copyrighted and contains proprietary information and trade secrets of Foxit Software Inc..
 * You cannot distribute any part of Foxit PDF SDK to any third party or general public, 
 * unless there is a separate license agreement with Foxit Software Inc. which explicitly grants you such rights.
 *
 * @file	fpdf.h
 * @brief	Header file involves all other related header files of PDF module.
 * @details	For application, just include fsdk.h directly.
 *
 * @note	If you want to purchase Foxit PDF SDK license and use ANY features of PDF module, please request for enabling PDF modules explicitly.
 */

#ifndef _FSPDF_H_
#define _FSPDF_H_

#ifndef _FSPDF_BASE_R_H_
	#include "fpdf_base_r.h"
#endif
#ifndef _FSPDF_OBJECTS_R_H_
	#include "fpdf_objects_r.h"
#endif
#ifndef _FSPDF_OBJECTS_W_H_
	#include "fpdf_objects_w.h"
#endif
#ifndef _FSPDF_DOCUMENT_R_H_
	#include "fpdf_document_r.h"
#endif
#ifndef _FSPDF_DOCUMENT_W_H_
	#include "fpdf_document_w.h"
#endif
#ifndef _FSPDF_ASYNC_R_H_
	#include "fpdf_async_r.h"
#endif
#ifndef _FSPDF_PAGE_R_H_
	#include "fpdf_page_r.h"
#endif
#ifndef _FSPDF_PAGE_W_H_
	#include "fpdf_page_w.h"
#endif
#ifndef _FSPDF_PAGEOBJECTS_R_H_
	#include "fpdf_pageobjects_r.h"
#endif
#ifndef _FSPDF_PAGEOBJECTS_W_H_
	#include "fpdf_pageobjects_w.h"
#endif
#ifndef _FSPDF_FORM_R_H_
	#include "fpdf_form_r.h"
#endif
#ifndef _FSPDF_FORM_W_H_
	#include "fpdf_form_w.h"
#endif
#ifndef _FSPDF_LAYER_R_H_
#include "fpdf_layer_r.h"
#endif
#ifndef _FSPDF_LAYER_W_H_
#include "fpdf_layer_w.h"
#endif
#ifndef _FSPDF_TEXTPAGE_R_H_
#include "fpdf_textpage_r.h"
#endif
#ifndef _FSPDF_ANNOT_R_H_
	#include "fpdf_annot_r.h"
#endif
#ifndef _FSPDF_ANNOT_W_H_
	#include "fpdf_annot_w.h"
#endif
#ifndef _FSFDF_DOCUMENT_R_H_
	#include "ffdf_document_r.h"
#endif
#ifndef _FSFDF_DOCUMENT_W_H_
	#include "ffdf_document_w.h"
#endif
#ifndef _FSPDF_SECURITY_R_H_
	#include "fpdf_security_r.h"
#endif
#ifndef _FSPDF_SECURITY_W_H_
	#include "fpdf_security_w.h"
#endif
#ifndef _FSPDF_WATERMARK_R_H_
	#include "fpdf_watermark_r.h"
#endif
#ifndef _FSPDF_WATERMARK_W_H_
	#include "fpdf_watermark_w.h"
#endif
#ifndef _FSPDF_REFLOW_R_H_
	#include "fpdf_reflow_r.h"
#endif
#ifndef _FSPDF_MARKEDCONTENT_R_H_
	#include "fpdf_markedcontent_r.h"
#endif
#ifndef _FSPDF_MARKEDCONTENT_W_H_
	#include "fpdf_markedcontent_w.h"
#endif
#ifndef _FSPDF_SIGNATURE_R_H_
	#include "fpdf_signature_r.h"
#endif
#ifndef _FSPDF_SIGNATURE_W_H_
	#include "fpdf_signature_w.h"
#endif
#endif /* _FSPDF_H_ */
