#ifndef _FSDK_PDFANNOT_H_
#define _FSDK_PDFANNOT_H_


class CPDFAnnot
{
public:
	CPDFAnnot();
	~CPDFAnnot();

	FS_RESULT	AddAnnotToPDFFile(string strFileName);
	void		BrowerFolder(void* folder);
	void		AddAnnotsToPDFFile(string strpdfFile);
	//Layout annotations 
	void		LayoutAnnots(FSCRT_ANNOT annot, const char* sAnnotType, const FS_FLOAT x, const FS_FLOAT y);

	FSCRT_ANNOT	AddAnnotToPDFPage(const FSCRT_PAGE pdfPage, const char* sAnnotType,string inputFile);

	//Set Annot  properties
	void		SetAnnotBorder(FSCRT_ANNOT annot);
	void		SetStampAnnotProperties(FSCRT_ANNOT annot, const char* sAnnotType, string inputFile);
	void		SetHighlightAnnotProperties(FSCRT_ANNOT annot, const char* sAnnotType);
	void		SetUnderLineAnnotProperties(FSCRT_ANNOT annot, const char* sAnnotType);
	void		SetSquigglyAnnotProperties(FSCRT_ANNOT annot, const char* sAnnotType);
	void		SetStrikeOutAnnotProperties(FSCRT_ANNOT annot, const char* sAnnotType);
	void		SetLineAnnotProperties(FSCRT_ANNOT annot, const char* sAnnotType);
	void		SetPolygonAnnotProperties(FSCRT_ANNOT annot, const char* sAnnotType);
	void		SetPolylineAnnotProperties(FSCRT_ANNOT annot, const char* sAnnotType);
	void		SetInkAnnotProperties(FSCRT_ANNOT annot, const char* sAnnotType);
	void		SetFreeTextAnnotProperties(FSCRT_ANNOT annot, const char* sAnnotType);
	void		SetLinkAnnotProperties(FSCRT_ANNOT annot, const char* sAnnotType);
	void		SetAnnotProperties(FSCRT_ANNOT annot, const char* sAnnotType);



public:
	string	m_inputSrcFile;
	string	m_outputFolder;
	string	m_PageRange;
	string  m_inputFolder;
};

#endif
