#ifndef _TREEVIEW_H_
#define _TREEVIEW_H_

#include <afxcmn.h>

#define  ID_BOOKMARKPANELTOOL_TREEVIEW 65003
class CBookmark_TreeCtrl;
class CBookmark_TreeView;

class CBookmark_TreeCtrl : public CTreeCtrl
{
public:
	CBookmark_TreeCtrl(){m_pPage = NULL;}
	void	SetTreeView(CBookmark_TreeView* pPage){m_pPage = pPage;}
	
	DECLARE_MESSAGE_MAP()
protected:
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	afx_msg void OnPaint();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
private:
	CBookmark_TreeView* m_pPage;
};

class CBookmark_TreeView : public CWnd
{
	friend class CBookmark_TreeCtrl;
public:
	CBookmark_TreeView(IReader_App* pApp, FSCRT_DOCUMENT doc);
	virtual ~CBookmark_TreeView();
	
	FSCRT_DOCUMENT GetPDFDocument(){return m_pPDFDoc;}
	void		 BuildBookmark(HTREEITEM hParent);
	void		 BuildPageTree();
	BOOL		 PDDocHasBookmark();
	
	DECLARE_MESSAGE_MAP()
		//	virtual BOOL DestroyWindow();
		//	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
		//	virtual void OnDraw(CDC* pDC){}
protected:
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	afx_msg void OnPaint();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
public:
	IReader_App* m_pApp;
private:
	FSCRT_DOCUMENT m_pPDFDoc;
	FSPDF_BOOKMARK_ITERATOR m_iteratorBookmark;
	CBookmark_TreeCtrl	*m_pTreeCtrl;
};

#endif