#include "stdafx.h"
#include "PanelToolHandler.h"
#include "PanelView.h"
#include "../PDFReader/resource.h"

CLayer_PanelToolHandler::CLayer_PanelToolHandler(HMODULE hModule, IReader_App* pApp)
{
	m_pApp = pApp;
	m_hModule = hModule;
}

CLayer_PanelToolHandler::~CLayer_PanelToolHandler()
{
	FS_INT32 iSize = m_arrayPanelView.GetSize();
	for(int i=0; i<iSize; i++)
	{
		CLayer_PanelView* pPanelView = m_arrayPanelView.GetAt(i);
		delete pPanelView;
		pPanelView = NULL;
	}
	m_arrayPanelView.RemoveAll();
}

// Initialization
BOOL CLayer_PanelToolHandler::Tool_OnInit()
{
	return TRUE;
}
// Destory
BOOL CLayer_PanelToolHandler::Tool_Destroy()
{
	return TRUE;
}

CString CLayer_PanelToolHandler::Tool_GetName()
{
	return L"LayerPanelTool";
}

CString	CLayer_PanelToolHandler::Tool_GetLabel()
{
	return L"LayerPanelTool";
}

CString	CLayer_PanelToolHandler::Tool_GetToolTip()
{
	return L"LayerPanelTool";
}

// View operation
IReader_PanelView* CLayer_PanelToolHandler::Tool_CreateNewView(FSCRT_DOCUMENT pDocument, HWND hOwner)
{
	CLayer_PanelView* pPanelView = new CLayer_PanelView(m_pApp, pDocument);
	BOOL bCreate = pPanelView->CreateTreeView(hOwner);
	if (!bCreate)
	{
		return NULL;
	}

	m_arrayPanelView.Add(pPanelView);
	return pPanelView;
}

IReader_PanelView* CLayer_PanelToolHandler::Tool_GetView(FSCRT_DOCUMENT pDocument, HWND hOwner)
{
	FS_INT32 iSize = m_arrayPanelView.GetSize();
	for(int i=0; i<iSize; i++)
	{
		CLayer_PanelView* pPanelView = m_arrayPanelView.GetAt(i);
		if(pPanelView->GetPDFDocument() == pDocument)
		{
			return pPanelView;
		}
	}
	return NULL;
}

void CLayer_PanelToolHandler::Tool_CloseView(FSCRT_DOCUMENT pDocument, HWND hOwner)
{
	FS_INT32 iSize = m_arrayPanelView.GetSize();
	for(int i=0; i<iSize; i++)
	{
		CLayer_PanelView* pPanelView = m_arrayPanelView.GetAt(i);
		if(pPanelView->GetPDFDocument() == pDocument)
		{
			pPanelView->DestroyTreeView();
			delete pPanelView;
			m_arrayPanelView.RemoveAt(i);
			return;
		}
	}
}

void CLayer_PanelToolHandler::Tool_SetActiveView(FSCRT_DOCUMENT pDocument, HWND hOwner)
{

}

// Get tool Icon 24
HBITMAP CLayer_PanelToolHandler::Tool_GetIcon()
{
	HBITMAP hBitmap = ::LoadBitmap(m_hModule, MAKEINTRESOURCE(IDB_LAYERPANEL));	
	CBitmap* bmpLayer = CBitmap::FromHandle(hBitmap);
	BITMAP bmpInfo;
	memset(&bmpInfo, 0, sizeof(BITMAP));
	int nGet = bmpLayer->GetBitmap(&bmpInfo);
	return hBitmap;
}