#ifndef _TREEVIEW_H_
#define _TREEVIEW_H_

#include <afxcmn.h>

#define  ID_LayerPANELTOOL_TREEVIEW 65003
class CLayer_TreeCtrl;
class CLayer_TreeView;

class CLayer_TreeCtrl : public CTreeCtrl
{
public:
	CLayer_TreeCtrl(){m_pPage = NULL;}
	void	SetTreeView(CLayer_TreeView* pPage){m_pPage = pPage;}
	
	DECLARE_MESSAGE_MAP()
protected:
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	afx_msg void OnPaint();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
private:
	CLayer_TreeView* m_pPage;
};

class CLayer_TreeView : public CWnd
{
	friend class CLayer_TreeCtrl;
public:
	CLayer_TreeView(IReader_App* pApp, FSCRT_DOCUMENT doc);
	virtual ~CLayer_TreeView();
	
	FSCRT_DOCUMENT GetPDFDocument(){return m_pPDFDoc;}
	void		 BuildLayer(FSPDF_LAYERNODE *pLayer,HTREEITEM hParent,FS_BOOL bParentLayer);
	void		 BuildPageTree();
	BOOL		 PDDocHasLayer();
	void		 AddLayer(FSPDF_LAYERNODE *pLayer, HTREEITEM hParent,FS_BOOL bParentLayer ,FS_BOOL bParentVisable);
	FS_BOOL		 IsDesign(FSPDF_LAYER layer);
	FS_BOOL		 CheckParentItem(HTREEITEM hItem);
	void		 SetChildItem(HTREEITEM hItem, FS_BOOL bParentCheck);
	void		 SetItemImageStatus(HTREEITEM hItem, int nStatus);
	void		 ShowLayerSetup(CPoint point);
	void		 ResetItemState(HTREEITEM hItem);
	
	DECLARE_MESSAGE_MAP()

protected:
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	afx_msg void OnPaint();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
public:
	IReader_App* m_pApp;
private:
	FSCRT_DOCUMENT m_pPDFDoc;
	FSPDF_LAYERNODE m_Layers;
	FSPDF_LAYERCONTEXT m_ViewContext;
	CLayer_TreeCtrl	*m_pTreeCtrl;
	CImageList *m_pImageList4Tree;
};

#endif