// AnnotPropertyDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PDFReader.h"
#include "AnnotPropertyDlg.h"
#include "afxdialogex.h"

#include "PDFReader.h"
#include "FrameworkImpl/PDFReaderApp.h"

// CAnnotPropertyDlg dialog

IMPLEMENT_DYNAMIC(CAnnotPropertyDlg, CDialog)

CAnnotPropertyDlg::CAnnotPropertyDlg(CWnd* pParent /* = NULL*/)
	: CDialog(CAnnotPropertyDlg::IDD, pParent)
	, m_bLock(FALSE)
{
	m_nSelectTab = 0;
	m_strAnnotType = _T("");
	m_SelectAnnot = NULL;
}

CAnnotPropertyDlg::~CAnnotPropertyDlg()
{
}

void CAnnotPropertyDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_ANNOT_TAB, m_AnnotPropertyTab);
	DDX_Check(pDX, IDC_ANNOT_LOCKED_CHECK, m_bLock);
}

BEGIN_MESSAGE_MAP(CAnnotPropertyDlg, CDialog)
	ON_NOTIFY(NM_THEMECHANGED, IDC_ANNOT_TAB, &CAnnotPropertyDlg::OnNMThemeChangedAnnotTab)
	ON_NOTIFY(TCN_SELCHANGE, IDC_ANNOT_TAB, &CAnnotPropertyDlg::OnTcnSelchangeAnnotTab)
	ON_BN_CLICKED(IDC_ANNOT_CLOSE_BUTTON, &CAnnotPropertyDlg::OnBnClickedAnnotCloseButton)
	ON_BN_CLICKED(IDC_ANNOT_LOCKED_CHECK, &CAnnotPropertyDlg::OnBnClickedAnnotLockedCheck)
END_MESSAGE_MAP()

// CAnnotPropertyDlg message handlers

BOOL CAnnotPropertyDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_CallOutAnnotAPDlg.Create(IDD_ANNOT_CALLOUT_AP, GetDlgItem(IDC_ANNOT_TAB));
	m_NotesAPDlg.Create(IDD_ANNOT_TEXT_AP, GetDlgItem(IDC_ANNOT_TAB));
	m_CallOutAnnotGEDlg.Create(IDD_ANNOT_CALLOUT_GENERAL, GetDlgItem(IDC_ANNOT_TAB));

	m_AnnotPropertyTab.InsertItem(0, _T("Appearance"));
	m_AnnotPropertyTab.InsertItem(1, _T("General"));

	CRect rc;
	m_AnnotPropertyTab.GetClientRect(&rc);
	rc.left += 4;
	rc.top += 23;
	rc.right -= 4;
	rc.bottom -= 4;
	m_NotesAPDlg.MoveWindow(&rc);
	m_CallOutAnnotGEDlg.MoveWindow(&rc);
	m_CallOutAnnotAPDlg.MoveWindow(&rc);

	m_AnnotPropertyTab.SetCurSel(0);

	m_CallOutAnnotAPDlg.ShowWindow(TRUE);

	return TRUE; // return TRUE unless you set the focus to a control
	// TODO: Add extra initialization here
}

void CAnnotPropertyDlg::UpdateDialog(IReader_Annot* pAnnot, CWnd* pWnd)
{
	FSCRT_BSTR TypeBstr;
	FSCRT_BStr_Init(&TypeBstr);

	m_SelectAnnot = pAnnot;
	if (!pAnnot)
	{
		EnableWindowDlg(FALSE);
		GetDlgItem(IDC_ANNOT_LOCKED_CHECK)->EnableWindow(FALSE);
		return;
	}
	else
	{
		GetDlgItem(IDC_ANNOT_LOCKED_CHECK)->EnableWindow(TRUE);
	}

	FSPDF_Annot_GetType(pAnnot->GetPDFAnnot(), &TypeBstr);
	HideAllPropertyDlg();
	if ( 0 == strcmp(FSPDF_ANNOTTYPE_FREETEXT, TypeBstr.str))
	{
		int nItem = m_AnnotPropertyTab.GetCurSel();
		m_pAnnotProperty[0] = &m_CallOutAnnotAPDlg;
		m_pAnnotProperty[1] = &m_CallOutAnnotGEDlg;
		m_AnnotPropertyTab.SetCurSel(0);
		m_nSelectTab = m_AnnotPropertyTab.GetCurSel();
		m_pAnnotProperty[0]->ShowWindow(SW_SHOW);	
 		m_CallOutAnnotAPDlg.UpdateDialog(pAnnot, pWnd);
 		m_CallOutAnnotGEDlg.UpdateDialog(pAnnot, pWnd);
	}
	else if (0 == strcmp(FSPDF_ANNOTTYPE_TEXT, TypeBstr.str)
		|| 0 == strcmp(FSPDF_ANNOTTYPE_HIGHLIGHT, TypeBstr.str) 
		|| 0 == strcmp(FSPDF_ANNOTTYPE_UNDERLINE, TypeBstr.str)
		|| 0 == strcmp(FSPDF_ANNOTTYPE_LINK, TypeBstr.str))
	{
		int nItem = m_AnnotPropertyTab.GetCurSel();
		m_pAnnotProperty[0] = &m_NotesAPDlg;
		m_pAnnotProperty[1] = &m_CallOutAnnotGEDlg;
		m_AnnotPropertyTab.SetCurSel(0);
		m_nSelectTab = m_AnnotPropertyTab.GetCurSel();
		m_pAnnotProperty[0]->ShowWindow(SW_SHOW);
		m_NotesAPDlg.UpdateDialog(pAnnot, pWnd);
		m_CallOutAnnotGEDlg.UpdateDialog(pAnnot, pWnd);
	}
	m_strAnnotType = TypeBstr.str;
	FS_DWORD dwFlags = 0;
	FSPDF_Annot_GetFlags(pAnnot->GetPDFAnnot(), &dwFlags);

	m_bLock = dwFlags & FSPDF_ANNOTFLAG_LOCKED? TRUE:FALSE;
	EnableWindowDlg(!m_bLock);
	
	CString strCapture;
	strCapture = TypeBstr.str;
	strCapture = strCapture + _T(" Property");
	FSCRT_BStr_Clear(&TypeBstr);
	SetWindowText(strCapture);
	UpdateData(FALSE);
}

void CAnnotPropertyDlg::OnNMThemeChangedAnnotTab(NMHDR *pNMHDR, LRESULT *pResult)
{
	// This feature requires Windows XP or greater.
	// The symbol _WIN32_WINNT must be >= 0x0501.
	// TODO: Add your control notification handler code here
	*pResult = 0;
	int Item = m_AnnotPropertyTab.GetCurSel();
	m_pAnnotProperty[Item]->ShowWindow(TRUE);
}

void CAnnotPropertyDlg::OnTcnSelchangeAnnotTab(NMHDR *pNMHDR, LRESULT *pResult)
{
	// TODO: Add your control notification handler code here
	*pResult = 0;
	m_pAnnotProperty[m_nSelectTab]->ShowWindow(SW_HIDE);
	m_nSelectTab = m_AnnotPropertyTab.GetCurSel();
	m_pAnnotProperty[m_nSelectTab]->ShowWindow(SW_SHOW);
}

void CAnnotPropertyDlg::OnBnClickedAnnotCloseButton()
{
	// TODO: Add your control notification handler code here
	ShowWindow(SW_HIDE);
}

void CAnnotPropertyDlg::HideAllPropertyDlg()
{
	m_CallOutAnnotAPDlg.ShowWindow(SW_HIDE);
	m_NotesAPDlg.ShowWindow(SW_HIDE);
	m_CallOutAnnotGEDlg.ShowWindow(SW_HIDE);
	//m_NotesAnnotGEdlg.ShowWindow(SW_HIDE);
}

void CAnnotPropertyDlg::OnBnClickedAnnotLockedCheck()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	EnableWindowDlg(!m_bLock);

	FS_DWORD dwOldFlags;
	FS_DWORD dwFlags;
	FSPDF_Annot_GetFlags(m_SelectAnnot->GetPDFAnnot(), &dwFlags);
	dwOldFlags = dwFlags;
	if(m_bLock)
	{
		dwFlags |= FSPDF_ANNOTFLAG_LOCKED;
	}
	else
	{
		dwFlags &= ~FSPDF_ANNOTFLAG_LOCKED;
	}
	FSPDF_Annot_SetFlags(m_SelectAnnot->GetPDFAnnot(), dwFlags);

	if (dwOldFlags != dwFlags)
	{
		IReader_Document* pReaderDocument = theApp.m_pReaderApp->GetCurrentDocument();
		if (NULL != pReaderDocument)
		{
			pReaderDocument->SetChangeMark();
		}
	}
}

void CAnnotPropertyDlg::EnableWindowDlg(BOOL bEnable)
{
	if (m_strAnnotType.IsEmpty())
	{
		return;
	}

	if (FSPDF_ANNOTTYPE_FREETEXT == m_strAnnotType)
	{
		m_CallOutAnnotAPDlg.EnableWindowDlg(bEnable);
		m_CallOutAnnotGEDlg.EnableWindowDlg(bEnable);
	}
	else
	{
		m_NotesAPDlg.EnableWindowDlg(bEnable);
		m_CallOutAnnotGEDlg.EnableWindowDlg(bEnable);
	}
}

