// CallOutAnnotAp.cpp : implementation file
//

#include "stdafx.h"
#include "PDFReader.h"
#include "CallOutAnnotAp.h"
#include "afxdialogex.h"

#include "PDFReader.h"
#include "FrameworkImpl/PDFReaderApp.h"
// CCallOutAnnotAp dialog

IMPLEMENT_DYNAMIC(CCallOutAnnotAp, CDialogEx)

CCallOutAnnotAp::CCallOutAnnotAp(CWnd* pParent /* = NULL*/)
	: CDialogEx(CCallOutAnnotAp::IDD, pParent)
	, m_nThickness(0)
	, m_pWnd(NULL)
	, m_nOpacity(-1)
{

}

CCallOutAnnotAp::~CCallOutAnnotAp()
{
}

void CCallOutAnnotAp::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_CALLOUT_THICKNESS, m_nThickness);
	DDX_Control(pDX, IDC_CALLOUT_OPACITY_SLIDER, m_OpacitySplider);
	DDX_Text(pDX, IDC_CALLOUT_OPACITY, m_nOpacity);
	DDX_Control(pDX, IDC_CALLOUT_COLOR, m_Color);
	DDX_Control(pDX, IDC_CALLOUT_FILLCOLOR, m_FillColor);
	DDX_Control(pDX, IDC_CALLOUT_STARTLINE, m_StartLineCtl);
	DDX_Control(pDX, IDC_CALLOUT_BORDERSTYLE, m_BorderStyleCtl);
}

BEGIN_MESSAGE_MAP(CCallOutAnnotAp, CDialogEx)
	ON_NOTIFY(UDN_DELTAPOS, IDC_CALLOUT_THICNNESS_SPIN, &CCallOutAnnotAp::OnDeltaposCalloutThicnnessSpin)
	ON_EN_CHANGE(IDC_CALLOUT_THICKNESS, &CCallOutAnnotAp::OnEnChangeCalloutThickness)
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_CALLOUT_OPACITY_SLIDER, &CCallOutAnnotAp::OnNMCustomdrawCalloutOpacitySlider)
	ON_EN_CHANGE(IDC_CALLOUT_OPACITY, &CCallOutAnnotAp::OnEnChangeCalloutOpacity)
	ON_CBN_SELCHANGE(IDC_CALLOUT_STARTLINE, &CCallOutAnnotAp::OnCbnSelchangeCalloutStartline)
	ON_BN_CLICKED(IDC_CALLOUT_COLOR, &CCallOutAnnotAp::OnBnClickedCalloutColor)
	ON_BN_CLICKED(IDC_CALLOUT_FILLCOLOR, &CCallOutAnnotAp::OnBnClickedCalloutFillcolor)
	ON_CBN_SELCHANGE(IDC_CALLOUT_BORDERSTYLE, &CCallOutAnnotAp::OnCbnSelchangeCalloutBorderstyle)
END_MESSAGE_MAP()

// CCallOutAnnotAp message handlers

void CCallOutAnnotAp::ChangeSaveMark()
{
	IReader_Document* pReaderDocument = theApp.m_pReaderApp->GetCurrentDocument();
	if (NULL != pReaderDocument)
	{
		pReaderDocument->SetChangeMark();
	}
}

void CCallOutAnnotAp::OnDeltaposCalloutThicnnessSpin(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	// TODO: Add your control notification handler code here
	if (pNMUpDown->iDelta == 1) //down
	{
		m_nThickness --;
		if (m_nThickness < 1)
		{
			m_nThickness = 1;
		}
		
	}
	else if (pNMUpDown->iDelta == -1) //up
	{
		m_nThickness ++;
	}
	if (m_nThickness > 12)
	{
		m_nThickness = 1;
	}

	FSPDF_ANNOTBORDER AnnotBorder;
	FSPDF_Annot_GetBorder(m_pAnnot->GetPDFAnnot(), &AnnotBorder);

	if (AnnotBorder.borderWidth != m_nThickness)
	{

		AnnotBorder.borderWidth = (FS_FLOAT)m_nThickness;

		FSPDF_Annot_SetBorder(m_pAnnot->GetPDFAnnot(), &AnnotBorder);
		FSPDF_Annot_ResetAppearance(m_pAnnot->GetPDFAnnot());
		m_pWnd->Invalidate();

		ChangeSaveMark();
	}
	
	UpdateData(FALSE);
	*pResult = 0;
}

void CCallOutAnnotAp::UpdateDialog(IReader_Annot* pAnnot, CWnd* pWnd)
{
	m_pAnnot = pAnnot;
	m_pWnd = pWnd;

	if (!pAnnot)
	{	
		return;
	}
	//BorderWidth
	FSPDF_ANNOTBORDER AnnotBorder;
	FSPDF_Annot_GetBorder(pAnnot->GetPDFAnnot(), &AnnotBorder);
	m_nThickness = (int)AnnotBorder.borderWidth;

	//BorderStyle
	m_BorderStyleCtl.SetCurSel(AnnotBorder.borderStyle);

	//Color
	FS_ARGB crArgb;
	FS_RESULT ret = FSPDF_Annot_GetColor(m_pAnnot->GetPDFAnnot(), FALSE, &crArgb);
	if (FSCRT_ERRCODE_SUCCESS == ret)
	{
		COLORREF crRGB = RGB((crArgb >>16) &0xff, (crArgb >>8) &0xff, (crArgb) &0xff);
		m_Color.SetFaceColor(crRGB);
	}

	//FillColor
	FS_ARGB crFillArgb;
	ret = FSPDF_Annot_GetColor(m_pAnnot->GetPDFAnnot(), TRUE, &crFillArgb);
	if (FSCRT_ERRCODE_SUCCESS == ret)
	{
		COLORREF crRGB = RGB((crFillArgb >>16) &0xff, (crFillArgb >>8) &0xff, (crFillArgb) &0xff);
		m_FillColor.SetFaceColor(crRGB);
	}

	//opacity
	FS_FLOAT fOpacity;
	ret = FSPDF_Annot_GetOpacity(m_pAnnot->GetPDFAnnot(), &fOpacity);
	if (FSCRT_ERRCODE_SUCCESS == ret)
		m_nOpacity = (int)(fOpacity * 100.0f + 0.5);	
	if (ret == FSCRT_ERRCODE_NOTFOUND)
		m_nOpacity = 100;
	if (m_nOpacity != -1)
	{
		m_bIsFirstSet = TRUE;
		m_OpacitySplider.SetPos(m_nOpacity);
	}

	//Start of line
	FSCRT_BSTR startStyle;
	FSCRT_BSTR endStyle;
	int nSel = 0;
	FSCRT_BStr_Init(&startStyle);
	FSCRT_BStr_Init(&endStyle);
	ret = FSPDF_Annot_GetLineEndingStyles(m_pAnnot->GetPDFAnnot(), &startStyle, &endStyle);
	if (FSCRT_ERRCODE_SUCCESS == ret)
	{
		GetSelFromLineStyle(&startStyle, &nSel);
		m_StartLineCtl.SetCurSel(nSel);
	}
	
	UpdateData(FALSE);
}

void CCallOutAnnotAp::OnEnChangeCalloutThickness()
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialogEx::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	UpdateData(TRUE);

	if (m_nThickness > 12)
	{
		m_nThickness = 12;

		UpdateData(FALSE);
	}

	FSPDF_ANNOTBORDER AnnotBorder;
	FSPDF_Annot_GetBorder(m_pAnnot->GetPDFAnnot(), &AnnotBorder);

	if (AnnotBorder.borderWidth != m_nThickness)
	{
		AnnotBorder.borderWidth = (FS_FLOAT)m_nThickness;
		FSPDF_Annot_SetBorder(m_pAnnot->GetPDFAnnot(), &AnnotBorder);
		FSPDF_Annot_ResetAppearance(m_pAnnot->GetPDFAnnot());

		m_pWnd->Invalidate();

		ChangeSaveMark();
	}


	// TODO: Add your control notification handler code here
}

void CCallOutAnnotAp::OnNMCustomdrawCalloutOpacitySlider(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);
	// TODO: Add your control notification handler code here

	int nPos = m_OpacitySplider.GetPos();
	if (!m_bIsFirstSet)
	{
		if(m_nOpacity != nPos){
			m_nOpacity = nPos;
			UpdateData(FALSE);
			OnEnChangeCalloutOpacity();
		}
	}
	else 
		m_bIsFirstSet = FALSE;


	*pResult = 0;
}

void CCallOutAnnotAp::OnEnChangeCalloutOpacity()
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialogEx::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	UpdateData(TRUE);

	if (m_nOpacity > 100)
	{
		m_nOpacity = 100;
		UpdateData(FALSE);
	}

	FS_FLOAT fOpacity = (FS_FLOAT)m_nOpacity;

	fOpacity = fOpacity / 100;

	FS_RESULT ret = FSPDF_Annot_SetOpacity(m_pAnnot->GetPDFAnnot(), fOpacity);
	if (FSCRT_ERRCODE_SUCCESS == ret)
	{
		FSPDF_Annot_ResetAppearance(m_pAnnot->GetPDFAnnot());
		m_pWnd->Invalidate();
		m_OpacitySplider.SetPos(m_nOpacity);

		ChangeSaveMark();
	}

	// TODO: Add your control notification handler code here
}


void CCallOutAnnotAp::OnCbnSelchangeCalloutStartline()
{
	// TODO: Add your control notification handler code here
	FSCRT_BSTR LineStyle;
	FSCRT_BStr_Init(&LineStyle);
	FSCRT_BSTR EndLineStyle;
	FSCRT_BStr_Init(&EndLineStyle);
	FSCRT_BStr_Set(&EndLineStyle, "None", strlen("None"));
	int nSel = m_StartLineCtl.GetCurSel();
	GetLineStyleFromSel(nSel, LineStyle);

	FS_RESULT ret = FSPDF_Annot_SetLineEndingStyles(m_pAnnot->GetPDFAnnot(), &LineStyle, &EndLineStyle);
	if (FSCRT_ERRCODE_SUCCESS == ret)
	{
		FSPDF_Annot_ResetAppearance(m_pAnnot->GetPDFAnnot());
		m_pWnd->Invalidate();

		ChangeSaveMark();
	}
}


void CCallOutAnnotAp::GetSelFromLineStyle(FSCRT_BSTR * LineStyle, int *nSel)
{
	if ( 0 == strcmp(FSPDF_ANNOT_LINEENDINGSTYLE_NONE, LineStyle->str))
	{
		*nSel = 0;
	}
	else if ( 0 == strcmp(FSPDF_ANNOT_LINEENDINGSTYLE_SQUARE , LineStyle->str))
	{
		*nSel = 1;
	}
	else if ( 0 == strcmp(FSPDF_ANNOT_LINEENDINGSTYLE_CIRCLE , LineStyle->str))
	{
		*nSel = 2;
	}
	else if ( 0 == strcmp(FSPDF_ANNOT_LINEENDINGSTYLE_DIAMOND , LineStyle->str))
	{
		*nSel = 3;
	}
	else if ( 0 == strcmp(FSPDF_ANNOT_LINEENDINGSTYLE_OPENARROW , LineStyle->str))
	{
		*nSel = 4;
	}
	else if ( 0 == strcmp(FSPDF_ANNOT_LINEENDINGSTYLE_CLOSEDARROW , LineStyle->str))
	{
		*nSel = 5;
	}
	else if ( 0 == strcmp(FSPDF_ANNOT_LINEENDINGSTYLE_BUTT , LineStyle->str))
	{
		*nSel = 6;
	}
	else if ( 0 == strcmp(FSPDF_ANNOT_LINEENDINGSTYLE_REVERSEOPENARROW , LineStyle->str))
	{
		*nSel = 7;
	}
	else if ( 0 == strcmp(FSPDF_ANNOT_LINEENDINGSTYLE_REVERSECLOSEDARROW , LineStyle->str))
	{
		*nSel = 8;
	}
	else if ( 0 == strcmp(FSPDF_ANNOT_LINEENDINGSTYLE_SLASH , LineStyle->str))
	{
		*nSel = 9;
	}
}

void CCallOutAnnotAp::GetLineStyleFromSel(int nSel, FSCRT_BSTR& LineStyle)
{
	switch(nSel)
	{
	case 0:
		FSCRT_BStr_Set(&LineStyle, FSPDF_ANNOT_LINEENDINGSTYLE_NONE, strlen(FSPDF_ANNOT_LINEENDINGSTYLE_NONE));
		break;
	case 1:
		FSCRT_BStr_Set(&LineStyle, FSPDF_ANNOT_LINEENDINGSTYLE_SQUARE, strlen(FSPDF_ANNOT_LINEENDINGSTYLE_SQUARE));
		break;
	case 2:
		FSCRT_BStr_Set(&LineStyle, FSPDF_ANNOT_LINEENDINGSTYLE_CIRCLE, strlen(FSPDF_ANNOT_LINEENDINGSTYLE_CIRCLE));
		break;
	case 3:
		FSCRT_BStr_Set(&LineStyle, FSPDF_ANNOT_LINEENDINGSTYLE_DIAMOND, strlen(FSPDF_ANNOT_LINEENDINGSTYLE_DIAMOND));
		break;
	case 4:
		FSCRT_BStr_Set(&LineStyle, FSPDF_ANNOT_LINEENDINGSTYLE_OPENARROW, strlen(FSPDF_ANNOT_LINEENDINGSTYLE_OPENARROW));
		break;
	case 5:
		FSCRT_BStr_Set(&LineStyle, FSPDF_ANNOT_LINEENDINGSTYLE_CLOSEDARROW, strlen(FSPDF_ANNOT_LINEENDINGSTYLE_CLOSEDARROW));
		break;
	case 6:
		FSCRT_BStr_Set(&LineStyle, FSPDF_ANNOT_LINEENDINGSTYLE_BUTT, strlen(FSPDF_ANNOT_LINEENDINGSTYLE_BUTT));
		break;
	case 7:
		FSCRT_BStr_Set(&LineStyle, FSPDF_ANNOT_LINEENDINGSTYLE_REVERSEOPENARROW, strlen(FSPDF_ANNOT_LINEENDINGSTYLE_REVERSEOPENARROW));
		break;
	case 8:
		FSCRT_BStr_Set(&LineStyle, FSPDF_ANNOT_LINEENDINGSTYLE_REVERSECLOSEDARROW, strlen(FSPDF_ANNOT_LINEENDINGSTYLE_REVERSECLOSEDARROW));
		break;
	case 9:
		FSCRT_BStr_Set(&LineStyle, FSPDF_ANNOT_LINEENDINGSTYLE_SLASH, strlen(FSPDF_ANNOT_LINEENDINGSTYLE_SLASH));
		break;
	}
}


void CCallOutAnnotAp::OnBnClickedCalloutColor()
{
	// TODO: Add your control notification handler code here
	CColorDialog colorDlg;
	if( colorDlg.DoModal() == IDOK )
	{
		COLORREF crRGB;
		FS_ARGB crArgb;

		crRGB = colorDlg.GetColor();

		FS_RESULT ret = FSPDF_Annot_GetColor(m_pAnnot->GetPDFAnnot(), FALSE, &crArgb);

		if (FSCRT_ERRCODE_SUCCESS == ret)
		{
			BYTE R = GetRValue(crRGB);
			BYTE G = GetGValue(crRGB);
			BYTE B = GetBValue(crRGB);
			crArgb = crArgb & 0xff000000;
			COLORREF temp = RGB(B, G, R);
			temp = temp | 0xff000000;
			crArgb = temp | crArgb;
		}

		ret = FSPDF_Annot_SetColor(m_pAnnot->GetPDFAnnot(), FALSE, crArgb);
		if (FSCRT_ERRCODE_SUCCESS == ret)
		{
			FSPDF_Annot_ResetAppearance(m_pAnnot->GetPDFAnnot());
			m_Color.SetFaceColor(crRGB);
			m_pWnd->Invalidate();

			ChangeSaveMark();
		}
	}
}

void CCallOutAnnotAp::OnBnClickedCalloutFillcolor()
{
	// TODO: Add your control notification handler code here
	CColorDialog colorDlg;
	if( colorDlg.DoModal() == IDOK )
	{
		COLORREF crRGB;
		FS_ARGB crArgb;

		crRGB = colorDlg.GetColor();

		FS_RESULT ret = FSPDF_Annot_GetColor(m_pAnnot->GetPDFAnnot(), TRUE, &crArgb);

		if (FSCRT_ERRCODE_SUCCESS == ret)
		{
			BYTE R = GetRValue(crRGB);
			BYTE G = GetGValue(crRGB);
			BYTE B = GetBValue(crRGB);
			crArgb = crArgb & 0xff000000;
			COLORREF temp = RGB(B, G, R);
			temp = temp | 0xff000000;
			crArgb = temp | crArgb;
		}

		ret = FSPDF_Annot_SetColor(m_pAnnot->GetPDFAnnot(), TRUE, crArgb);
		if (FSCRT_ERRCODE_SUCCESS == ret)
		{
			FSPDF_Annot_ResetAppearance(m_pAnnot->GetPDFAnnot());
			m_FillColor.SetFaceColor(crRGB);
			m_pWnd->Invalidate();

			ChangeSaveMark();
		}
	}
}

void CCallOutAnnotAp::OnCbnSelchangeCalloutBorderstyle()
{
	// TODO: Add your control notification handler code here
	FSPDF_ANNOTBORDER AnnotBorder;
	FS_RESULT ret = FSPDF_Annot_GetBorder(m_pAnnot->GetPDFAnnot(), &AnnotBorder);
	if (FSCRT_ERRCODE_SUCCESS != ret )
	{
		return;
	}

	AnnotBorder.cloudIntensity = 1;

	//BorderStyle
	
	int nSel = m_BorderStyleCtl.GetCurSel();
	if (AnnotBorder.borderStyle != nSel)
	{
		AnnotBorder.borderStyle = nSel;
		InitCalloutBorderstyle(nSel, AnnotBorder);
		ret = FSPDF_Annot_SetBorder(m_pAnnot->GetPDFAnnot(), &AnnotBorder);
		if (FSCRT_ERRCODE_SUCCESS == ret )
		{
			FSPDF_Annot_ResetAppearance(m_pAnnot->GetPDFAnnot());
			m_pWnd->Invalidate();

			ChangeSaveMark();
		}
	}
}

void CCallOutAnnotAp::InitCalloutBorderstyle(int nSel, FSPDF_ANNOTBORDER &AnnotBorder)
{
	AnnotBorder.cloudIntensity = -1;
	AnnotBorder.dashCount = 0;
	AnnotBorder.dashPhase = 0;
	AnnotBorder.dashPattern[0] = AnnotBorder.dashPattern[1] = 0;
	switch (nSel)
	{
	case FSPDF_ANNOT_BORDERSTYLE_SOLID:
		break;
	case FSPDF_ANNOT_BORDERSTYLE_DASHED:
		AnnotBorder.dashPhase = 5;
		AnnotBorder.dashCount = 2;
		AnnotBorder.dashPattern[0] = AnnotBorder.dashPattern[1] = 3;
		break;
	case FSPDF_ANNOT_BORDERSTYLE_CLOUDY:
		AnnotBorder.cloudIntensity = 1;
		break;;
	}
}

void CCallOutAnnotAp::EnableWindowDlg(BOOL bEnable)
{
	GetDlgItem(IDC_CALLOUT_THICKNESS)->EnableWindow(bEnable);
	GetDlgItem(IDC_CALLOUT_BORDERSTYLE)->EnableWindow(bEnable);
	GetDlgItem(IDC_CALLOUT_COLOR)->EnableWindow(bEnable);
	GetDlgItem(IDC_CALLOUT_FILLCOLOR)->EnableWindow(bEnable);
	GetDlgItem(IDC_CALLOUT_STARTLINE)->EnableWindow(bEnable);
	GetDlgItem(IDC_CALLOUT_OPACITY)->EnableWindow(bEnable);
	GetDlgItem(IDC_CALLOUT_OPACITY_SLIDER)->EnableWindow(bEnable);
}

