// CalloutAnnotGeneral.cpp : implementation file
//

#include "stdafx.h"
#include "PDFReader.h"
#include "CalloutAnnotGeneral.h"
#include "afxdialogex.h"

#include "PDFReader.h"
#include "FrameworkImpl/PDFReaderApp.h"

// CCalloutAnnotGeneral dialog

IMPLEMENT_DYNAMIC(CCalloutAnnotGeneral, CDialogEx)

CCalloutAnnotGeneral::CCalloutAnnotGeneral(CWnd* pParent /* = NULL*/)
	: CDialogEx(CCalloutAnnotGeneral::IDD, pParent)
	, m_pAnnot(NULL)
	, m_pWnd(NULL)
	, m_strCalloutSubject(_T(""))
	, m_strCalloutAuthor(_T(""))
{
}

CCalloutAnnotGeneral::~CCalloutAnnotGeneral()
{
}

void CCalloutAnnotGeneral::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_CALLOUT_SUBJECT_EDIT, m_strCalloutSubject);
	DDX_Text(pDX, IDC_CALLOUT_AUTHOR_EDIT, m_strCalloutAuthor);
}


void CCalloutAnnotGeneral::UpdateDialog(IReader_Annot* pAnnot, CWnd* pWnd)
{
	m_pAnnot = pAnnot;
	FSCRT_BSTR Subject;
	FSCRT_BStr_Init(&Subject);
	FSPDF_Annot_GetSubject(pAnnot->GetPDFAnnot(), &Subject);
	m_strCalloutSubject = Subject.str;
	FSCRT_BStr_Clear(&Subject);

	m_strOriginalSubject = m_strCalloutSubject;

	FSCRT_BSTR Author;
	FSCRT_BStr_Init(&Author);
	FSPDF_Annot_GetTitle(pAnnot->GetPDFAnnot(), &Author);
	m_strCalloutAuthor = Author.str;
	FSCRT_BStr_Clear(&Author);

	m_strOriginalAuthor = m_strCalloutAuthor;

	FSCRT_DATETIMEZONE createTime;
	FSPDF_Annot_GetCreationDateTime(pAnnot->GetPDFAnnot(), &createTime);
	CString strCreateTime;
	strCreateTime.Format(_T("%d/%02d/%02d %02d:%02d:%02d"), 
		createTime.year, createTime.month, createTime.day, createTime.hour, createTime.minute, createTime.second);
	GetDlgItem(IDC_CALLOUT_CREATE)->SetWindowTextW(strCreateTime);

	FSCRT_BSTR name;
	FSCRT_BStr_Init(&name);

	FSPDF_Annot_GetName(pAnnot->GetPDFAnnot(), &name);
	FSCRT_BStr_Clear(&name);


	FSCRT_DATETIMEZONE modifyTime;
	FSPDF_Annot_GetModifiedDateTime(pAnnot->GetPDFAnnot(), &modifyTime);
	CString strModifyTime;
	strModifyTime.Format(_T("%d/%02d/%02d %02d:%02d:%02d"), 
		modifyTime.year, modifyTime.month, modifyTime.day, modifyTime.hour, modifyTime.minute, createTime.second);
	GetDlgItem(IDC_CALLOUT_MODIFY)->SetWindowTextW(strModifyTime);
	UpdateData(FALSE);
}

BEGIN_MESSAGE_MAP(CCalloutAnnotGeneral, CDialogEx)
	ON_EN_KILLFOCUS(IDC_CALLOUT_SUBJECT_EDIT, &CCalloutAnnotGeneral::OnEnKillfocusCalloutSubjectEdit)
	ON_EN_KILLFOCUS(IDC_CALLOUT_AUTHOR_EDIT, &CCalloutAnnotGeneral::OnEnKillfocusCalloutAuthorEdit)
END_MESSAGE_MAP()

// CCalloutAnnotGeneral message handlers

void CCalloutAnnotGeneral::OnEnKillfocusCalloutSubjectEdit()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	FSCRT_BSTR subJect;
	FSCRT_BStr_Init(&subJect);
	FS_RESULT ret = FSCRT_UTF8_FromUTF16LE(&subJect, (FS_WORD*)(LPCWSTR)(m_strCalloutSubject.GetBuffer()), (FS_DWORD)m_strCalloutSubject.GetLength());
	if (FSCRT_ERRCODE_SUCCESS == ret)
	{
		FSPDF_Annot_SetSubject(m_pAnnot->GetPDFAnnot(), &subJect);

		if (m_strOriginalSubject != m_strCalloutSubject)
		{
			ChangeSaveMark();
		}
	}
	
	FSCRT_BStr_Clear(&subJect);
}

void CCalloutAnnotGeneral::OnEnKillfocusCalloutAuthorEdit()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	FSCRT_BSTR Author;
	FSCRT_BStr_Init(&Author);
	FS_RESULT ret = FSCRT_UTF8_FromUTF16LE(&Author, (FS_WORD*)(LPCWSTR)(m_strCalloutAuthor.GetBuffer()), (FS_DWORD)m_strCalloutAuthor.GetLength());
	if (FSCRT_ERRCODE_SUCCESS == ret)
	{
		FSPDF_Annot_SetTitle(m_pAnnot->GetPDFAnnot(), &Author);

		if (m_strOriginalAuthor != m_strCalloutAuthor)
		{
			ChangeSaveMark();
		}
	}

	FSCRT_BStr_Clear(&Author);
}

void CCalloutAnnotGeneral::EnableWindowDlg(BOOL bEnable)
{
	GetDlgItem(IDC_CALLOUT_AUTHOR_EDIT)->EnableWindow(bEnable);
	GetDlgItem(IDC_CALLOUT_SUBJECT_EDIT)->EnableWindow(bEnable);
}

void CCalloutAnnotGeneral::ChangeSaveMark()
{
	IReader_Document* pReaderDocument = theApp.m_pReaderApp->GetCurrentDocument();
	if (NULL != pReaderDocument)
	{
		pReaderDocument->SetChangeMark();
	}
}
