// FindDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PDFReader.h"
#include "FindDlg.h"
#include "afxdialogex.h"
#include "MainFrm.h"
#include "ChildFrm.h"
#include "PDFDisplayView.h"
// FindDlg dialog

IMPLEMENT_DYNAMIC(FindDlg, CDialog)

FindDlg::FindDlg(CWnd* pParent /* = NULL*/)
	: CDialog(FindDlg::IDD, pParent)
{
	m_bMatchCase = FALSE;
	m_bWholeWord = FALSE;
	m_strFindWhat = _T("");
	m_nDirection = -1;

}

FindDlg::~FindDlg()
{
}

void FindDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_FINDTEXT, m_strFindWhat);
	DDX_Radio(pDX, IDC_RADIO_DOWN, m_nDirection);
	DDX_Check(pDX, IDC_CHECK_MATCHWHOLE, m_bWholeWord);
	DDX_Check(pDX, IDC_CHECK_MATCHCASE, m_bMatchCase);
}


BEGIN_MESSAGE_MAP(FindDlg, CDialog)
	ON_COMMAND(IDC_BUTTON_CANCLE, OnCancel)
	ON_EN_CHANGE(IDC_EDIT_FINDTEXT, &FindDlg::OnEnChangeEditFindtext)
	ON_BN_CLICKED(IDC_BUTTON_FIND_NEXT, &FindDlg::OnBnClickedButtonFindNext)
END_MESSAGE_MAP()

// FindDlg message handlers
void FindDlg::OnOk()
{
	// TODO: Add extra validation here
	UpdateData(TRUE);
	m_pPDFDisplayView->SearchText(m_strFindWhat, m_bMatchCase, m_bWholeWord, m_nDirection);
}

BOOL FindDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	SetWindowText(_T("Find"));
	m_pPDFDisplayView = (CPDFDisplayView*)(((CChildFrame *)((CMainFrame *)AfxGetMainWnd())->GetActiveFrame())->GetActiveView());
	((CButton *)GetDlgItem(IDC_RADIO_DOWN))->SetCheck(1);
	((CButton *)GetDlgItem(IDC_CHECK_MATCHWHOLE))->SetCheck(1);
	GetDlgItem(IDC_BUTTON_FIND_NEXT)->SetFocus();
	return TRUE;
}

void FindDlg::OnCancel()
{
	CDialog::OnCancel();
}

void FindDlg::OnEnChangeEditFindtext()
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO: Add your control notification handler code here

	UpdateData(TRUE);
	if ( -1 != m_strFindWhat.Find(_T("\r\n")))
	{
		m_strFindWhat.Replace(_T("\r\n"), _T(""));
		UpdateData(FALSE);
		OnBnClickedButtonFindNext();
		((CEdit *)GetDlgItem(IDC_EDIT_FINDTEXT))->SetSel(-1,-1);
	}
}

void FindDlg::OnBnClickedButtonFindNext()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_pPDFDisplayView->SearchText(m_strFindWhat, m_bMatchCase, m_bWholeWord, m_nDirection);
}
