#ifndef _ANNOTHANDLER_MGR_H_
#define _ANNOTHANDLER_MGR_H_

#include "../../FrameworkInterface/include/IAnnot.h"
#include "../AnnotPropertyDlg.h"


enum AnnotMenuItem
{
	Annot_Item_Properties = 1,
	Annot_Item_Delete,
};

class CReader_AnnotHandlerMgr : public IReader_AnnotHandlerMgr
{
public:
	CReader_AnnotHandlerMgr();
	virtual ~CReader_AnnotHandlerMgr();

	virtual IReader_Annot* NewAnnot(FSCRT_ANNOT pdfAnnot, IReader_Page* pPage);

	virtual void Annot_OnLoad(IReader_Annot* pAnnot);

	virtual CRect Annot_OnGetViewBBox(IReader_Page* pPage, IReader_Annot* pAnnot);

	// Mouse events
	virtual BOOL Annot_OnHitTest(IReader_Page* pPage, IReader_Annot* pAnnot, const CPoint& point);

	virtual void Annot_OnDraw(IReader_Page* pPage, HDC hDC, IReader_Annot* pAnnot, FSCRT_MATRIX matrix, const CRect& rcPage);
	virtual BOOL Annot_OnLButtonDown(IReader_Page* pPage, IReader_Annot* pAnnot, UINT nFlags, const CPoint& point);
	virtual BOOL Annot_OnLButtonUp(IReader_Page* pPage, IReader_Annot* pAnnot, UINT nFlags, const CPoint& point);
	virtual BOOL Annot_OnLButtonDblClk(IReader_Page* pPage, IReader_Annot* pAnnot, UINT nFlags, const CPoint& point);

	virtual BOOL Annot_OnMouseMove(IReader_Page* pPage, IReader_Annot* pAnnot, UINT nFlags, const CPoint& point);

	virtual BOOL Annot_OnRButtonUp(IReader_Page* pPage, IReader_Annot* pAnnot, UINT nFlags, const CPoint& point);

	virtual void RegisterAnnotHandler(IReader_AnnotHandler* pAnnotHandler);

	virtual IReader_AnnotHandler* GetAnnotHandler(CString csType);
	virtual IReader_AnnotHandler* GetAnnotHandler(IReader_Annot* pAnnot);

	CAnnotPropertyDlg* m_pAnnotPropertyDlg;
public:
	void ValidAnnotPropertyDlg();

protected:
	CMapStringToPtr m_mapType2Handler;
	CPoint m_curPos;
	BOOL m_bLButtonDown;
};

#endif