#ifndef _PDFREADERAPP_H
#define _PDFREADERAPP_H

#include "../../FrameworkInterface/include/IApp.h"
class CReader_AnnotHandlerMgr;

class CReader_App : public IReader_App
{	
public:	
	CReader_App();
	virtual ~CReader_App();

public:
	// Register a tool handler
	virtual BOOL RegisterToolHandler(IReader_ToolHandler* pToolHandler);

	// Register a Panel Tool handler
	virtual BOOL RegisterPanelToolHandler(IReader_PanelToolHandler* pPanelToolHandler);
 
	// Register a App Event handle
	virtual BOOL RegisterAppEventHandler(IReader_AppEventHandler* pAppEventHandler);

	// Register A Doc Event handle
	virtual	BOOL RegisterDocEventHandler(IReader_DocEventHandler* pDocEventHandler);

	//Page Event handle
	virtual	BOOL RegisterPageEventHandler(IReader_PageEventHandler* pPageEventHandler);

	virtual BOOL RegisterMenuToolbarCommandHandler(IReader_MenuToolbarCommandHandler* pCommandHandler);
	virtual IReader_MenuToolbarCommandHandler* GetMenuToolbarCommandHandler(UINT nID);

	// Get a panel tool handler from name
	virtual IReader_PanelToolHandler* GetPanelToolHandler(LPCWSTR  pToolName);
	virtual int GetPanelToolHandlerSize();
	virtual IReader_PanelToolHandler* GetPanelToolHandler(int nIndex);


	virtual int CountToolHandlers();
	
	virtual IReader_ToolHandler* GetToolHandlerByIndex(int index);

	virtual IReader_ToolHandler* GetToolHandlerByName(LPCWSTR pToolName);

	virtual IReader_ToolHandler* GetCurrentToolHandler();

	virtual void SetCurrentToolHandler(IReader_ToolHandler* pToolHandler, BOOL bPersistent, BOOL bDelay =FALSE);

	virtual void SetCurrentToolHandler(LPCWSTR csToolname, BOOL bPersistent);

	virtual IReader_Document* GetCurrentDocument();

	virtual BOOL SetCurrentDocument(IReader_Document* pDocument);

	virtual IReader_Document* OpenDocument(LPCWSTR wsFilePath,  BOOL bAttachment, BOOL bMakeVisible = TRUE, LPCWSTR wsPassword = L"", BOOL bAddToMRU = TRUE);

	virtual BOOL CloseDocument(IReader_Document* pDocument, BOOL bPromptToSave = TRUE, BOOL bDelay = TRUE);

	virtual IReader_Document* GetReaderDocument(FSCRT_DOCUMENT pDoc);

	virtual int CountDocuments();

	virtual IReader_Document* GetReaderDocument(int index);

	virtual void AddDocument(IReader_Document* pDocument);
	virtual void RemoveDocument(IReader_Document* pDocument);
	
	//HandlerMgr
	virtual	IReader_AnnotHandlerMgr* GetAnnotHandlerMgr();

	// MainFrame/Menu Operator
	virtual HWND GetMainFrameWnd();

	//Get Module
	virtual IReader_Module*	GetModuleByName(LPCWSTR wsName);
	BOOL LoadLibrarys();
protected:
	CTypedPtrArray<CPtrArray, IReader_Document*> m_pDocumentList;
	CTypedPtrArray<CPtrArray, IReader_PanelToolHandler*> m_pPaneHandlerList;
	CTypedPtrArray<CPtrArray, IReader_ToolHandler*> m_pToolHandlerList;
	CTypedPtrArray<CPtrArray, IReader_MenuToolbarCommandHandler*> m_pMenuToolbarCommandHandlerList;

	IReader_Document*  m_pCurrentDocument;
	IReader_ToolHandler* m_pCurrentTool;
	CMapStringToPtr m_mapModuleList;

public:
	BOOL m_bSetDocument;
	CReader_AnnotHandlerMgr* m_pAnnotHandlerMgr;
};

#endif