#ifndef _PDFREADERTOOL_H
#define _PDFREADERTOOL_H

#include "../../FrameworkInterface/include/ITool.h"

#define TOOLHANDLER_NAME_HAND L"Hand"

class CReader_HandToolHandler : public IReader_ToolHandler
{
public:
	CReader_HandToolHandler();
	virtual ~CReader_HandToolHandler();

	// Initialization
	virtual void Tool_OnInit(IReader_App* pApp);

	// Destory
	virtual void Tool_Destroy();

	// Get tool basic info. Note: all strings should be in host encoding
	virtual CString Tool_GetName();

	virtual BOOL Tool_IsProcessing();

	// UI Events
	virtual void Tool_OnActivate(BOOL bPersistent);

	virtual void Tool_OnDeactivate();

	// Mouse events
	virtual BOOL Tool_OnLButtonDown(IReader_Page* pPage, UINT nFlags,const CPoint& point);

	virtual BOOL Tool_OnLButtonUp(IReader_Page* pPage, UINT nFlags, const CPoint& point);

	virtual BOOL Tool_OnLButtonDblClk(IReader_Page* pPage, UINT nFlags, const CPoint& point);

	virtual BOOL Tool_OnMouseMove(IReader_Page* pPage, UINT nFlags, const CPoint& point);

	virtual BOOL Tool_OnRButtonDown(IReader_Page* pPage, UINT nFlags, const CPoint& point);

	virtual BOOL Tool_OnRButtonUp(IReader_Page* pPage, UINT nFlags, const CPoint& point);

	virtual BOOL Tool_OnRButtonDblClk(IReader_Page* pPage, UINT nFlags, const CPoint& point);

	virtual BOOL Tool_OnMouseWheel(IReader_Page* pPage, UINT nFlags, short zDelta, const CPoint& point);

	//[Draw]
	virtual BOOL Tool_OnDraw(IReader_Document* pDoc, HDC hDC);

protected:
	BOOL m_bLButtonDown;
	CPoint m_curPos;
	IReader_App* m_pApp;

	FS_INT32	m_nTextLink; 


protected:
	BOOL IsInTextLinkRect(IReader_Page* pPage, const CPoint& point);

};

#endif