#ifndef _TEXTANNOTHANDLER_H_
#define _TEXTANNOTHANDLER_H_


#include "../../FrameworkInterface/include/IAnnot.h"

class CReader_FreeTextAnnot :public IReader_Annot
{
public:
	CReader_FreeTextAnnot(FSCRT_ANNOT Annot,IReader_Page* pPgae);
	~CReader_FreeTextAnnot();

	virtual FSCRT_ANNOT GetPDFAnnot();

	virtual	CString	GetType();

	virtual CString	GetSubType();

	virtual BOOL IsSelected();

	virtual void SetSelected(BOOL bSelected);

	virtual BOOL IsCaptured() ;

	virtual void SetCaptured(BOOL bCaptured) ;

	virtual CRect GetViewBBox() ;

	virtual CRect GetInnerRectMargin();

	virtual BOOL IsLock();

protected:
	FSCRT_ANNOT m_FreeTextAnnot;
	IReader_Page* m_pPage;

	BOOL m_bSelect;
	BOOL m_bLButtonDown;
	BOOL m_bCapture;
};


class CReader_FreeTextAnnotHandler :public IReader_AnnotHandler
{
public:
	CReader_FreeTextAnnotHandler(void);
	~CReader_FreeTextAnnotHandler(void);

	virtual IReader_Annot* NewAnnot(FSCRT_ANNOT pdfAnnot, IReader_Page* pPage) ;

	//return  annotation type name,for example: "Line"
	virtual CString	GetType() ;

	//return AnnotHandler unique identification,for example:"LineAnnotHandler"
	virtual CString GetName();

	//get position of annotation,it can be real position,also can be zoomed in properly,this position is also UpdateAllViews's reference position.
	virtual CRect GetViewBBox(IReader_Page *pPage, IReader_Annot* pAnnot) ;

	virtual BOOL HitTest(IReader_Page *pPage, IReader_Annot* pAnnot, const CPoint& point);

	//return TRUE means have done,framework doesn't deal with .
	virtual BOOL OnLButtonDown(IReader_Page *pPage, IReader_Annot* pAnnot, UINT nFlags, const CPoint& point) ;
	virtual BOOL OnLButtonUp(IReader_Page *pPage, IReader_Annot* pAnnot, UINT nFlags, const CPoint& point) ;
	virtual BOOL OnLButtonDblClk(IReader_Page *pPage, IReader_Annot* pAnnot, UINT nFlags, const CPoint& point);
	virtual BOOL OnMouseMove(IReader_Page *pPage, IReader_Annot* pAnnot, UINT nFlags, const CPoint& point);
	virtual BOOL OnMouseWheel(IReader_Page *pPage, IReader_Annot* pAnnot, UINT nFlags, short zDelta, const CPoint& point);
	virtual BOOL OnRButtonDown(IReader_Page *pPage, IReader_Annot* pAnnot, UINT nFlags, const CPoint& point) ;
	virtual BOOL OnRButtonUp(IReader_Page *pPage, IReader_Annot* pAnnot, UINT nFlags, const CPoint& point) ;
	virtual BOOL OnRButtonDblClk(IReader_Page *pPage, IReader_Annot* pAnnot, UINT nFlags, const CPoint& point);

	virtual void Annot_OnDraw(IReader_Page* pPage, HDC hDC, IReader_Annot* pAnnot, FSCRT_MATRIX matrix, const CRect& rcPage);

	void  DrawSelectRect(IReader_Page* pPage, HDC hDC, IReader_Annot* pAnnot, const CRect& winRect, DWORD crBorder, DWORD crRect, BOOL bCorner);
	void  GetSelectRects(CRect winRect, CRect* rcArray);
	void  GetCalloutLinePoints(IReader_Page* pPage,IReader_Annot* pAnnot,CRect* rcArray);

protected:
	BOOL m_bLButtonDown;
	CPoint m_StartPoint;
	CPoint m_EndPoint;
};

#endif
