
// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "PDFReader.h"
#include "resource.h"
#include "MainFrm.h"
#include "./FrameworkImpl/PDFReaderApp.h"
#include "./FrameworkImpl/PDFReaderTool.h"
#include "PDFDisplayView.h"
#include "ChildFrm.h"
#include "./FrameworkImpl/PDFReaderDocument.h"
#include "PDFReaderDoc.h"
#include "PDFReaderView.h"
#include "RenderDlg.h"
#include "PropertyDlg.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	ON_WM_CREATE()
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_FILE_CLOSE, OnFileClose)
	ON_COMMAND(ID_PAGEBOX_CLEARBOX, OnClearBox)
	ON_COMMAND(ID_RENDEROPTION_SETOPTIONS, OnSetOption)
	ON_COMMAND(ID_DOCUMENT_PROPERTY, OnProperty)
	ON_COMMAND(ID_FILE_SAVEAS, OnFileSaveAs)
	ON_UPDATE_COMMAND_UI(ID_DOCUMENT_PROPERTY, OnUpdateProperty)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE, OnUpdateFileSave)
	ON_UPDATE_COMMAND_UI(ID_FILE_NEW, OnUpdateFileNew)
	ON_UPDATE_COMMAND_UI(ID_FILE_PRINT, OnUpdateFilePrint)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVEAS, OnUpdateFileSaveAs)
	ON_UPDATE_COMMAND_UI(ID_FILE_PRINT_SETUP, OnUpdateFilePrintSetup)
	ON_UPDATE_COMMAND_UI(ID_FILE_PRINT_PREVIEW, OnUpdateFilePrintPreview)
	ON_UPDATE_COMMAND_UI(ID_FILE_CLOSE, OnUpdateFileClose)
	ON_UPDATE_COMMAND_UI(ID_PAGEBOX_MEDIABOX, OnUpdateMediaBox)
	ON_UPDATE_COMMAND_UI(ID_PAGEBOX_CROPBOX, OnUpdateCropBox)
	ON_UPDATE_COMMAND_UI(ID_PAGEBOX_TRIMBOX, OnUpdateTrimBox)
	ON_UPDATE_COMMAND_UI(ID_PAGEBOX_ARTBOX, OnUpdateArtBox)
	ON_UPDATE_COMMAND_UI(ID_PAGEBOX_BLEEDBOX, OnUpdateBleedBox)
	ON_UPDATE_COMMAND_UI(ID_PAGEBOX_CONTENTBOX_OBJECT, OnUpdateContentBoxForObject)
	ON_UPDATE_COMMAND_UI(ID_PAGEBOX_CONTENTBOX_IMAGE, OnUpdateContentBoxForImage)
	ON_UPDATE_COMMAND_UI(ID_PAGEBOX_CLEARBOX, OnUpdateClearBox)
	ON_UPDATE_COMMAND_UI(ID_RENDEROPTION_SETOPTIONS, OnUpdateSetOption)
	ON_COMMAND_RANGE(MODULE_TOOLBAR_MENU_ID_FROM, MODULE_TOOLBAR_MENU_ID_TO, OnModuleMenusToolbars)
	ON_UPDATE_COMMAND_UI_RANGE(MODULE_TOOLBAR_MENU_ID_FROM, MODULE_TOOLBAR_MENU_ID_TO, OnUpdateModuleMenusToolbars)
	ON_COMMAND_RANGE(ID_PAGEBOX_MEDIABOX, ID_PAGEBOX_CONTENTBOX_IMAGE, OnMenusPageBox)
END_MESSAGE_MAP()

static UINT indicators[] = 
{
	ID_SEPARATOR,   // status line indicator
	ID_INDICATOR_CAPS, 
	ID_INDICATOR_NUM, 
	ID_INDICATOR_SCRL, 
};

// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	m_nLastID = 0;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP | CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;  // fail to create
	}

	if (!m_wndStatusBar.Create(this))
	{
		TRACE0("Failed to create status bar\n");
		return -1;  // fail to create
	}
	m_wndStatusBar.SetIndicators(indicators, sizeof(indicators)/sizeof(UINT));

	LoadToolBarImageList();

	theApp.m_pReaderApp->LoadLibrarys();

	// TODO: Delete these three lines if you don't want the toolbar to be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	// the CREATESTRUCT cs

	return TRUE;
}

BOOL CMainFrame::LoadToolBarImageList()
{
	//set ToolBar's picture lists	
	BOOL bCreate = m_ilTB.Create(24, 24, TRUE | ILC_COLOR32, 30, 0);
	CBitmap bm;
	bm.LoadBitmap(IDB_FILE_OPEN);
	int nAdd = m_ilTB.Add(&bm, RGB(0, 255, 0));
	bm.DeleteObject();
	bm.LoadBitmap(IDB_FILE_SAVE);
	nAdd = m_ilTB.Add(&bm, RGB(0, 255, 0));
	bm.DeleteObject();
	bm.LoadBitmap(IDB_FILE_PRINT);
	nAdd = m_ilTB.Add(&bm, RGB(0, 255, 0));
	bm.DeleteObject();
	bm.LoadBitmap(IDB_TOOL_HAND);
	nAdd = m_ilTB.Add(&bm, RGB(0, 255, 0));
	bm.DeleteObject();
	bm.LoadBitmap(IDB_TOOL_SEARCH);
	nAdd = m_ilTB.Add(&bm, RGB(0, 255, 0));
	bm.DeleteObject();
	bm.LoadBitmap(IDB_TOOL_SELECT);
	nAdd = m_ilTB.Add(&bm, RGB(0, 255, 0));
	bm.DeleteObject();
	bm.LoadBitmap(IDB_TOOL_PSI);
	nAdd = m_ilTB.Add(&bm, RGB(0, 255, 0));
	bm.DeleteObject();
	bm.LoadBitmap(IDB_TOOL_ZOOMIN);
	nAdd = m_ilTB.Add(&bm, RGB(0, 255, 0));
	bm.DeleteObject();
	bm.LoadBitmap(IDB_TOOL_ZOOMOUT);
	nAdd = m_ilTB.Add(&bm, RGB(0, 255, 0));
	bm.DeleteObject();
	bm.LoadBitmap(IDB_BITMAP_ROTATION_RIGHT);
	nAdd = m_ilTB.Add(&bm, RGB(0, 255, 0));
	bm.DeleteObject();
	bm.LoadBitmap(IDB_BITMAP_ROTATION_LEFT);
	nAdd = m_ilTB.Add(&bm, RGB(0, 255, 0));
	bm.DeleteObject();
	m_wndToolBar.GetToolBarCtrl().SetImageList(&m_ilTB);

	bCreate = m_ilTBGray.Create(24, 24, TRUE | ILC_COLOR32, 30, 0);
	bm.LoadBitmap(IDB_FILE_OPEN_GRAY);
	nAdd = m_ilTBGray.Add(&bm, RGB(0, 255, 0));
	bm.DeleteObject();
	bm.LoadBitmap(IDB_FILE_SAVE_GRAY);
	nAdd = m_ilTBGray.Add(&bm, RGB(0, 255, 0));
	bm.DeleteObject();
	bm.LoadBitmap(IDB_FILE_PRINT_GRAY);
	nAdd = m_ilTBGray.Add(&bm, RGB(0, 255, 0));
	bm.DeleteObject();
	bm.LoadBitmap(IDB_TOOL_HAND_GRAY);
	nAdd = m_ilTBGray.Add(&bm, RGB(0, 255, 0));
	bm.DeleteObject();
	bm.LoadBitmap(IDB_TOOL_SEARCH_GRAY);
	nAdd = m_ilTBGray.Add(&bm, RGB(0, 255, 0));
	bm.DeleteObject();
	bm.LoadBitmap(IDB_TOOL_SELECT_GRAY);
	nAdd = m_ilTBGray.Add(&bm, RGB(0, 255, 0));
	bm.DeleteObject();
	bm.LoadBitmap(IDB_TOOL_PSI_GRAY);
	nAdd = m_ilTBGray.Add(&bm, RGB(0, 255, 0));
	bm.DeleteObject();
	bm.LoadBitmap(IDB_TOOL_ZOOMOUT_GRAY);
	nAdd = m_ilTBGray.Add(&bm, RGB(0, 255, 0));
	bm.DeleteObject();
	bm.LoadBitmap(IDB_TOOL_ZOOMIN_GRAY);
	nAdd = m_ilTBGray.Add(&bm, RGB(0, 255, 0));
	bm.DeleteObject();
	bm.LoadBitmap(IDB_BITMAP_ROTATION_RIGHT);
	nAdd = m_ilTBGray.Add(&bm, RGB(0, 255, 0));
	bm.DeleteObject();
	bm.LoadBitmap(IDB_BITMAP_ROTATION_LEFT);
	nAdd = m_ilTBGray.Add(&bm, RGB(0, 255, 0));
	bm.DeleteObject();
	m_wndToolBar.GetToolBarCtrl().SetDisabledImageList(&m_ilTBGray);
	return TRUE;
}

// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}
#endif //_DEBUG

void CMainFrame::FloatControlBar(CControlBar* pBar, CPoint point, DWORD dwStyle)
{
	ASSERT(pBar != NULL);

	// if the bar is already floating and the dock bar only contains this
	// bar and same orientation then move the window rather than recreating
	// the frame
	if (pBar->m_pDockSite != NULL && pBar->m_pDockBar != NULL)
	{
		CDockBar* pDockBar = (CDockBar*)pBar->m_pDockBar;
		if (pDockBar->m_bFloating && pDockBar->GetDockedCount() == 1 && 
			(dwStyle & pDockBar->m_dwStyle & CBRS_ALIGN_ANY) != 0)
		{
			CMiniDockFrameWnd* pDockFrame = (CMiniDockFrameWnd*)pDockBar->GetParent();
			ASSERT(pDockFrame != NULL);
			ASSERT_KINDOF(CMiniDockFrameWnd, pDockFrame);
			pDockFrame->SetWindowPos(NULL, point.x, point.y, 0, 0, 
				SWP_NOSIZE|SWP_NOZORDER|SWP_NOACTIVATE);
			pDockFrame->RecalcLayout(TRUE);
			pDockFrame->UpdateWindow();
			return;
		}
	}

	if (pBar->m_dwStyle & CBRS_SIZE_DYNAMIC)
	{
		dwStyle |= CBRS_SIZE_DYNAMIC;
		if (dwStyle & CBRS_ORIENT_VERT)
		{
			dwStyle &= ~CBRS_ALIGN_ANY;
			dwStyle |= CBRS_ALIGN_TOP;
		}
	}

	CMiniDockFrameWnd* pDockFrame = CreateFloatingFrame(dwStyle);
	ASSERT(pDockFrame != NULL);
	pDockFrame->SetWindowPos(NULL, point.x, point.y, 0, 0, 
		SWP_NOSIZE|SWP_NOZORDER|SWP_NOACTIVATE);
	if (pDockFrame->m_hWndOwner == NULL)
		pDockFrame->m_hWndOwner = pBar->m_hWnd;

	CDockBar* pDockBar = (CDockBar*)pDockFrame->GetDlgItem(AFX_IDW_DOCKBAR_FLOAT);
	ASSERT(pDockBar != NULL);
	ASSERT_KINDOF(CDockBar, pDockBar);

	ASSERT(pBar->m_pDockSite == this);
	// if this assertion occurred it is because the parent of pBar was not
	// initially this CFrameWnd when pBar's OnCreate was called
	// (this control bar should have been created with a different
	// parent initially)

	pDockBar->DockControlBar(pBar, NULL);
	pDockFrame->RecalcLayout(TRUE);
	if (GetWindowLong(pBar->m_hWnd, GWL_STYLE) & WS_VISIBLE)
	{
		pDockFrame->ShowWindow(SW_SHOWNA);
		pDockFrame->UpdateWindow();
	}
}

// CMainFrame message handlers
void CMainFrame::OnFileSave() 
{
	IReader_Document* pReaderDocument = theApp.m_pReaderApp->GetCurrentDocument();
	if (pReaderDocument)
	{
		pReaderDocument->Save();
		pReaderDocument->ClearChangeMark();
	}
}

void CMainFrame::OnFileSaveAs() 
{
	IReader_Document* pReaderDocument = theApp.m_pReaderApp->GetCurrentDocument();
	if (pReaderDocument)
	{
		pReaderDocument->SaveAs();
	}
}

void CMainFrame::OnFileClose() 
{
	IReader_Document* pReaderDocument = theApp.m_pReaderApp->GetCurrentDocument();
	if (pReaderDocument)
	{
		BOOL bChange = pReaderDocument->GetChangeMark();
		if (bChange)
		{
			CString szSaveFile = ((CReader_Document*)pReaderDocument)->GetFilePathStr();
			int ret = szSaveFile.ReverseFind(L'\\');
			CString szTem = szSaveFile.Right(szSaveFile.GetLength() - ret - 1);
			szTem = _T("Do you want to save changes to '") + szTem + _T("' before closing?");
			int bRet = MessageBox(szTem, _T("Save"), MB_YESNOCANCEL);
			if ( IDYES == bRet)
			{
				pReaderDocument->Save();
				pReaderDocument->ClearChangeMark();
			}
			else if (IDCANCEL == bRet)
			{
				return;
			}
			else if (IDNO == bRet)
			{
				pReaderDocument->ClearChangeMark();
			}
		}
		 
		CReader_Document* pReaderDoc = (CReader_Document*)pReaderDocument;
		
		CPDFDisplayView *pDisplayView = pReaderDoc->GetPDFDisplayView();
		if (pDisplayView)
		{
			//avoid crash.
			pDisplayView->KillFormfillerFocus();
			CPDFReaderView *pReaderView = (CPDFReaderView *)pDisplayView->GetPDFReaderView();
			if (pReaderView)
			{
				CPDFReaderDoc *pDoc = pReaderView->GetDocument();
				if (pDoc)
				{
					pDoc->OnCloseDocument();
				}
			}
		}
	}
}



void CMainFrame::OnUpdateFileClose(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	IReader_Document* pReaderDocument = theApp.m_pReaderApp->GetCurrentDocument();
	if (!pReaderDocument)
	{
		pCmdUI->Enable(FALSE);
	}

}

void CMainFrame::OnUpdateFileSave(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	IReader_Document* pReaderDocument = theApp.m_pReaderApp->GetCurrentDocument();
	if (pReaderDocument)
	{
		BOOL bChange = pReaderDocument->GetChangeMark();
		if (bChange)
		{
			pCmdUI->Enable(TRUE);
		}
		else
		{
			pCmdUI->Enable(FALSE);
		}
	}
	else
	{
		pCmdUI->Enable(FALSE);
	}
}

void CMainFrame::OnUpdateFileNew(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(FALSE);
}

void CMainFrame::OnUpdateFilePrint(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	IReader_Document* pReaderDocument = theApp.m_pReaderApp->GetCurrentDocument();
	if(!pReaderDocument)
	{
		pCmdUI->Enable(FALSE);
	}
}

void CMainFrame::OnUpdateFileSaveAs(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	IReader_Document* pReaderDocument = theApp.m_pReaderApp->GetCurrentDocument();
	if(!pReaderDocument)
	{
		pCmdUI->Enable(FALSE);
	}
}

void CMainFrame::OnUpdateFilePrintSetup(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(FALSE);
}

void CMainFrame::OnUpdateFilePrintPreview(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(FALSE);
}
void CMainFrame::OnModuleMenusToolbars(UINT nID)
{
	IReader_MenuToolbarCommandHandler* pMenuToolbarCommandHandler = theApp.m_pReaderApp->GetMenuToolbarCommandHandler(nID);
	if (pMenuToolbarCommandHandler)
	{
		pMenuToolbarCommandHandler->OnCommand();
		return;
	}

	switch(nID)
	{
	case ID_TOOL_HAND:
		{
			IReader_ToolHandler* pToolHandler = theApp.m_pReaderApp->GetToolHandlerByName(TOOLHANDLER_NAME_HAND);
			theApp.m_pReaderApp->SetCurrentToolHandler(pToolHandler, TRUE, FALSE);
			((CPDFDisplayView*)(((CChildFrame *)((CMainFrame *)AfxGetMainWnd())->GetActiveFrame())->GetActiveView()))->ChangeTool(HAND_TOOL);
			((CPDFDisplayView*)(((CChildFrame *)((CMainFrame *)AfxGetMainWnd())->GetActiveFrame())->GetActiveView()))->HideCaret();
		}
		break;
	}
}

void CMainFrame::OnUpdateModuleMenusToolbars(CCmdUI * pCmdUI)
{	
	IReader_MenuToolbarCommandHandler* pMenuToolbarCommandHandler = theApp.m_pReaderApp->GetMenuToolbarCommandHandler(pCmdUI->m_nID);
	if (pMenuToolbarCommandHandler)
	{
		pMenuToolbarCommandHandler->OnUpdateCommandUI(pCmdUI);
		return;
	}

	switch(pCmdUI->m_nID)
	{
	case ID_TOOL_HAND:
		{
			CReader_Document* pReaderDocument = (CReader_Document*)theApp.m_pReaderApp->GetCurrentDocument();
			if(!pReaderDocument)
			{
				pCmdUI->Enable(FALSE);
				return;
			}
			else
			{
				CPDFDisplayView* pDisplayView = pReaderDocument->GetPDFDisplayView();
				if (pDisplayView != NULL && pReaderDocument->GetDocument() != NULL)
				{
					pCmdUI->Enable(TRUE);
					pCmdUI->SetCheck(pDisplayView->m_bHand);	
				}
			}
		}
		break;

	case ID_TOOL_SEARCH:
		{
			IReader_Document* pReaderDocument = theApp.m_pReaderApp->GetCurrentDocument();
			if(!pReaderDocument)
			{
				pCmdUI->Enable(FALSE);
				return;
			}
		}
		break;

	case ID_TOOL_SELECT:
		{
			CReader_Document* pReaderDocument = (CReader_Document*)theApp.m_pReaderApp->GetCurrentDocument();
			if(!pReaderDocument)
			{
				pCmdUI->Enable(FALSE);
				return;
			}
			else
			{
				CPDFDisplayView* pDisplayView = pReaderDocument->GetPDFDisplayView();
				if (pDisplayView != NULL && pReaderDocument->GetDocument() != NULL)
				{
					pCmdUI->Enable(TRUE);
					pCmdUI->SetCheck(pDisplayView->m_bSelect);	
				}
			}
		}
		break;

	case ID_TOOL_PSI:
		{
			CReader_Document* pReaderDocument = (CReader_Document*)theApp.m_pReaderApp->GetCurrentDocument();
			if (!pReaderDocument)
			{
				pCmdUI->Enable(FALSE);
				return;
			}
			else
			{
				CPDFDisplayView* pDisplayView = pReaderDocument->GetPDFDisplayView();
				if (pDisplayView != NULL && pReaderDocument->GetDocument() != NULL)
				{
					pCmdUI->Enable(TRUE);
					pCmdUI->SetCheck(pDisplayView->m_bPSI);	
				}
			}
		}
		break;
	case ID_FILE_SAVE:
		{
			IReader_Document* pReaderDocument = theApp.m_pReaderApp->GetCurrentDocument();
			if (!pReaderDocument)
			{
				pCmdUI->Enable(FALSE);
				return;
			}
		}
		break;

	case ID_FILE_SAVE_AS:
		{
			IReader_Document* pReaderDocument = theApp.m_pReaderApp->GetCurrentDocument();
			if (!pReaderDocument)
			{
				pCmdUI->Enable(FALSE);
				return;
			}
		}
		break;
	case ID_TOOL_ZOOMOUT:
		{
			IReader_Document* pReaderDocument = theApp.m_pReaderApp->GetCurrentDocument();
			if (!pReaderDocument)
			{
				pCmdUI->Enable(FALSE);
				return;
			}
		}
		break;
	case ID_TOOL_ZOOMIN:
		{
			IReader_Document* pReaderDocument = theApp.m_pReaderApp->GetCurrentDocument();
			if (!pReaderDocument)
			{
				pCmdUI->Enable(FALSE);
				return;
			}
		}
		break;
	case ID_TOOL_ANNOTSELECT:
		{
			CReader_Document* pReaderDocument = (CReader_Document*)theApp.m_pReaderApp->GetCurrentDocument();
			if (!pReaderDocument)
			{
				pCmdUI->Enable(FALSE);
				return;
			}
			else
			{
				CPDFDisplayView* pDisplayView = pReaderDocument->GetPDFDisplayView();
				if (pDisplayView != NULL && pReaderDocument->GetDocument() != NULL)
				{
					pCmdUI->Enable(TRUE);
					pCmdUI->SetCheck(pDisplayView->m_bAnnotTool);	
				}
			}
		}
		break;
	}
	
	pCmdUI->Enable(TRUE);
}

void CMainFrame::OnUpdateMediaBox(CCmdUI* pCmdUI)
{
	CView *pView = GetActiveView();
	if (pView)
	{
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnUpdateCropBox(CCmdUI* pCmdUI)
{
	CView *pView = GetActiveView();
	if (pView)
	{
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnUpdateTrimBox(CCmdUI* pCmdUI)
{
	CView *pView = GetActiveView();
	if (pView)
	{
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnUpdateArtBox(CCmdUI* pCmdUI)
{
	CView *pView = GetActiveView();
	if (pView)
	{
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnUpdateBleedBox(CCmdUI* pCmdUI)
{
	CView *pView = GetActiveView();
	if (pView)
	{
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnUpdateContentBoxForObject(CCmdUI* pCmdUI)
{
	CView *pView = GetActiveView();
	if (pView)
	{
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnUpdateContentBoxForImage(CCmdUI* pCmdUI)
{
	CView *pView = GetActiveView();
	if (pView)
	{
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnUpdateClearBox(CCmdUI* pCmdUI)
{
	CReader_Document* pReaderDocument = (CReader_Document*)theApp.m_pReaderApp->GetCurrentDocument();
	CPDFDisplayView* pDisplayView = pReaderDocument->GetPDFDisplayView();
	if (pDisplayView->m_bDrawBox)
	{
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnClearBox()
{
	CReader_Document* pReaderDocument = (CReader_Document*)theApp.m_pReaderApp->GetCurrentDocument();
	CPDFDisplayView* pDisplayView = pReaderDocument->GetPDFDisplayView();
	pDisplayView->ClearBox();
}

void CMainFrame::OnUpdateSetOption(CCmdUI* pCmdUI)
{
	CView* view = GetActiveView();
	if (view)
	{
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnSetOption()
{
	RenderDlg dlg;
	dlg.DoModal();
}

void CMainFrame::OnUpdateProperty(CCmdUI* pCmdUI)
{
	CView* view = GetActiveView();
	if (view)
	{
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnProperty()
{
	PropertyDlg dlg;
	dlg.DoModal();
}


void CMainFrame::OnMenusPageBox(UINT nID)
{
	if (m_nLastID!= 0)
	{
		if (GetMenu()->GetMenuState(m_nLastID, MF_CHECKED))
		{
			GetMenu()->CheckMenuItem(m_nLastID, MF_UNCHECKED);
		}
		else
		{
			GetMenu()->CheckMenuItem(m_nLastID, MF_CHECKED);
		}
	}
	switch(nID)
	{
	case ID_PAGEBOX_MEDIABOX:
		{
			CReader_Document* pReaderDocument = (CReader_Document*)theApp.m_pReaderApp->GetCurrentDocument();
			CPDFDisplayView* pDisplayView = pReaderDocument->GetPDFDisplayView();
			if (GetMenu()->GetMenuState(ID_PAGEBOX_MEDIABOX, MF_CHECKED))
			{
				GetMenu()->CheckMenuItem(ID_PAGEBOX_MEDIABOX, MF_UNCHECKED);
			}
			else
			{
				GetMenu()->CheckMenuItem(ID_PAGEBOX_MEDIABOX, MF_CHECKED);
			}
			pDisplayView->m_BoxColor = RGB(0, 255, 255);
			pDisplayView->GetBox(FSPDF_PAGEBOX_MEDIABOX);
			m_nLastID = nID;
		}
		break;
	case ID_PAGEBOX_CROPBOX:
		{
			CReader_Document* pReaderDocument = (CReader_Document*)theApp.m_pReaderApp->GetCurrentDocument();
			CPDFDisplayView* pDisplayView = pReaderDocument->GetPDFDisplayView();
			if (GetMenu()->GetMenuState(ID_PAGEBOX_CROPBOX, MF_CHECKED))
			{
				GetMenu()->CheckMenuItem(ID_PAGEBOX_CROPBOX, MF_UNCHECKED);
			}
			else
			{
				GetMenu()->CheckMenuItem(ID_PAGEBOX_CROPBOX, MF_CHECKED);
			}
			pDisplayView->m_BoxColor = RGB(0, 255, 125);
			pDisplayView->GetBox(FSPDF_PAGEBOX_CROPBOX);
			m_nLastID = nID;
		}
		break;
	case ID_PAGEBOX_TRIMBOX:
		{
			CReader_Document* pReaderDocument = (CReader_Document*)theApp.m_pReaderApp->GetCurrentDocument();
			CPDFDisplayView* pDisplayView = pReaderDocument->GetPDFDisplayView();
			if (GetMenu()->GetMenuState(ID_PAGEBOX_TRIMBOX, MF_CHECKED))
			{
				GetMenu()->CheckMenuItem(ID_PAGEBOX_TRIMBOX, MF_UNCHECKED);
			}
			else
			{
				GetMenu()->CheckMenuItem(ID_PAGEBOX_TRIMBOX, MF_CHECKED);
			}
			pDisplayView->m_BoxColor = RGB(0, 0, 255);
			pDisplayView->GetBox(FSPDF_PAGEBOX_TRIMBOX);
			m_nLastID = nID;
		}
		break;
	case ID_PAGEBOX_ARTBOX:
		{
			CReader_Document* pReaderDocument = (CReader_Document*)theApp.m_pReaderApp->GetCurrentDocument();
			CPDFDisplayView* pDisplayView = pReaderDocument->GetPDFDisplayView();
			if (GetMenu()->GetMenuState(ID_PAGEBOX_ARTBOX, MF_CHECKED))
			{
				GetMenu()->CheckMenuItem(ID_PAGEBOX_ARTBOX, MF_UNCHECKED);
			}
			else
			{
				GetMenu()->CheckMenuItem(ID_PAGEBOX_ARTBOX, MF_CHECKED);
			}
			pDisplayView->m_BoxColor = RGB(0, 125, 255);
			pDisplayView->GetBox(FSPDF_PAGEBOX_ARTBOX);
			m_nLastID = nID;
		}
		break;

	case ID_PAGEBOX_BLEEDBOX:
		{
			CReader_Document* pReaderDocument = (CReader_Document*)theApp.m_pReaderApp->GetCurrentDocument();
			CPDFDisplayView* pDisplayView = pReaderDocument->GetPDFDisplayView();
			if (GetMenu()->GetMenuState(ID_PAGEBOX_BLEEDBOX, MF_CHECKED))
			{
				GetMenu()->CheckMenuItem(ID_PAGEBOX_BLEEDBOX, MF_UNCHECKED);
			}
			else
			{
				GetMenu()->CheckMenuItem(ID_PAGEBOX_BLEEDBOX, MF_CHECKED);
			}
			pDisplayView->m_BoxColor = RGB(0, 125, 125);
			pDisplayView->GetBox(FSPDF_PAGEBOX_BLEEDBOX);
			m_nLastID = nID;
		}
		break;
	case ID_PAGEBOX_CONTENTBOX_OBJECT:
		{
			CReader_Document* pReaderDocument = (CReader_Document*)theApp.m_pReaderApp->GetCurrentDocument();
			CPDFDisplayView* pDisplayView = pReaderDocument->GetPDFDisplayView();
			if (GetMenu()->GetMenuState(ID_PAGEBOX_CONTENTBOX_OBJECT, MF_CHECKED))
			{
				GetMenu()->CheckMenuItem(ID_PAGEBOX_CONTENTBOX_OBJECT, MF_UNCHECKED);
			}
			else
			{
				GetMenu()->CheckMenuItem(ID_PAGEBOX_CONTENTBOX_OBJECT, MF_CHECKED);
			}
			pDisplayView->m_BoxColor = RGB(125, 0, 255);
			pDisplayView->GetContentBBox(FSPDF_PAGEMARGIN_CONTENTSBBOX);
			m_nLastID = nID;
		}
		break;
	case ID_PAGEBOX_CONTENTBOX_IMAGE:
		{
			CReader_Document* pReaderDocument = (CReader_Document*)theApp.m_pReaderApp->GetCurrentDocument();
			CPDFDisplayView* pDisplayView = pReaderDocument->GetPDFDisplayView();
			if (GetMenu()->GetMenuState(ID_PAGEBOX_CONTENTBOX_IMAGE, MF_CHECKED))
			{
				GetMenu()->CheckMenuItem(ID_PAGEBOX_CONTENTBOX_IMAGE, MF_UNCHECKED);
			}
			else
			{
				GetMenu()->CheckMenuItem(ID_PAGEBOX_CONTENTBOX_IMAGE, MF_CHECKED);
			}
			pDisplayView->m_BoxColor = RGB(125, 255, 125);
			pDisplayView->GetContentBBox(FSPDF_PAGEMARGIN_DETECTION);
			m_nLastID = nID;
		}
		break;
	}
}
