// FX_DockContainer.cpp: implementation of the CFX_DockContainer class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "../MainFrm.h"
#include "FX_DockContainer.h"
#include "../../FrameworkInterface/include/IPanelTool.h"
#include "../resource.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif


///////////////////////////////////////////////////////////////////////////
// The title bar button

CFX_TitleBarBtn::CFX_TitleBarBtn()
{
	m_bPushed = FALSE;
	m_bRaised = FALSE;
}
void CFX_TitleBarBtn::Paint(CDC* pDC, BOOL bActive)
{
	CRect rc = GetRect();
	if (m_bPushed)
	{
		pDC->Draw3dRect(rc, ::GetSysColor(COLOR_BTNSHADOW), ::GetSysColor(COLOR_BTNHIGHLIGHT));
	}
	else
	{
		if(m_bRaised)
			pDC->Draw3dRect(rc, ::GetSysColor(COLOR_BTNHIGHLIGHT), ::GetSysColor(COLOR_BTNSHADOW));		
	}

}

// ///////////////////////////////////////////////////////////////////////////
// //close button
// 
void CFX_CloseBtn::Paint(CDC* pDC, BOOL bActive)
{
	CFX_TitleBarBtn::Paint(pDC, bActive);
	COLORREF clrOldTextColor = pDC->GetTextColor();
	
	pDC->SetTextColor(GetSysColor(COLOR_3DDKSHADOW));
	int nPrevBkMode = pDC->SetBkMode(TRANSPARENT);
	CFont Font;
	int nPpi = pDC->GetDeviceCaps(LOGPIXELSX);
	int nPointSize = MulDiv(75, 96, nPpi); 
	Font.CreatePointFont(nPointSize, L"Marlett");
	CFont* OldFont = pDC->SelectObject(&Font);	

	pDC->TextOut(m_ptOrg.x + 2, m_ptOrg.y +2, CString(L"r")); //like - x
	pDC->SelectObject(OldFont);
	pDC->SetBkMode(nPrevBkMode);
	pDC->SetTextColor(clrOldTextColor);
	Font.DeleteObject();
}

//////////////////////////////////////////////////////////////////////////////
CFX_StudBtn::CFX_StudBtn()
{
}

// draw stud
void CFX_StudBtn::Paint(CDC* pDC, BOOL isActive)
{
	CFX_TitleBarBtn::Paint(pDC, isActive);
	CPoint point[3];
	if(isActive)
	{
		point[0] = CPoint(m_ptOrg.x+6, m_ptOrg.y+6);
		point[1] = CPoint(m_ptOrg.x+2, m_ptOrg.y+2);
		point[2] = CPoint(m_ptOrg.x+2, m_ptOrg.y+10);

		CRgn rgnArrow;
		CBrush brush(RGB(0, 0, 0));
		rgnArrow.CreatePolygonRgn(point, 3, ALTERNATE);
		pDC->FillRgn(&rgnArrow, &brush);
		rgnArrow.DeleteObject();
		
		point[0] = CPoint(m_ptOrg.x+10, m_ptOrg.y+6);
		point[1] = CPoint(m_ptOrg.x+6, m_ptOrg.y+2);
		point[2] = CPoint(m_ptOrg.x+6, m_ptOrg.y+10);
		
		CRgn rgnArrow2;
		rgnArrow2.CreatePolygonRgn(point, 3, ALTERNATE);
		pDC->FillRgn(&rgnArrow2, &brush);
		rgnArrow2.DeleteObject();
		brush.DeleteObject();
	}
	else
	{
		point[0] = CPoint(m_ptOrg.x+2, m_ptOrg.y+6);
		point[1] = CPoint(m_ptOrg.x+6, m_ptOrg.y+2);
		point[2] = CPoint(m_ptOrg.x+6, m_ptOrg.y+10);

		CRgn rgnArrow;
		CBrush brush(RGB(0, 0, 0));
		rgnArrow.CreatePolygonRgn(point, 3, ALTERNATE);
		pDC->FillRgn(&rgnArrow, &brush);
		rgnArrow.DeleteObject();
		
		point[0] = CPoint(m_ptOrg.x+6, m_ptOrg.y+6);
		point[1] = CPoint(m_ptOrg.x+10, m_ptOrg.y+2);
		point[2] = CPoint(m_ptOrg.x+10, m_ptOrg.y+10);
		
		CRgn rgnArrow2;
		rgnArrow2.CreatePolygonRgn(point, 3, ALTERNATE);
		pDC->FillRgn(&rgnArrow2, &brush);
		rgnArrow2.DeleteObject();
		brush.DeleteObject();
	}
}

///////////////////////////////////////////////////////////////////////////
// The Tab Page

CFX_TabPage::CFX_TabPage(int iTabStyle) 
{
	m_csText = L"";
	m_rect.SetRectEmpty();
	m_nTabWidth = 0;
	m_pWnd = NULL; 
	m_iTabStyle = iTabStyle; 
	m_bDockBottom = FALSE;
	m_hBitmap = NULL;
	m_bShowTab = TRUE;
}
CFX_TabPage::~CFX_TabPage()
{
	Delete();
}
void CFX_TabPage::Delete()
{
	m_pWnd = NULL;		
	m_csText = L"";
	m_rect = NULL;
	m_nTabWidth = 0;
	if (m_hBitmap != NULL)
	{
		::DeleteObject(m_hBitmap);
		m_hBitmap = NULL;
	}
}

int CFX_TabPage::GetTabWidth(BOOL bShowTabText)
{
	int nTextWidth = 0;
	int nIconWidth = 0;
	if(bShowTabText)
	{
		CDC dc;
		dc.CreateCompatibleDC(NULL);
		nTextWidth = dc.GetTextExtent(m_csText, m_csText.GetLength()).cx;
		dc.DeleteDC();
	}
	if(m_hBitmap != 0 )
	{
		int width = 0;
		CBitmap* pBitmap = CBitmap::FromHandle(m_hBitmap);
		BITMAP bmpInfo;
		memset(&bmpInfo, 0, sizeof(BITMAP));
		int nGet = pBitmap->GetBitmap(&bmpInfo);
		width = bmpInfo.bmWidth;

		m_IconWidth = width;
		nIconWidth = m_IconWidth;
	}
	m_nTabWidth = nIconWidth + nTextWidth + 20;
	return m_nTabWidth;
}
void CFX_TabPage::Draw(CDC *pDC, BOOL bActive, BOOL bShowText)
{
	CRect rect = m_rect;
	rect.top += 2;
	this->DrawTabRect(pDC, rect, bActive, m_iTabStyle);
	rect.left -= 2;
	// draw Icon
	if(m_nTabWidth> 28 && NULL != m_hBitmap)
	{	
		CBitmap hbmp;
		hbmp.Attach(m_hBitmap);
		// Get the bitmap format
		BITMAP bm;
		hbmp.GetBitmap(&bm);
		CDC dcMem;
		dcMem.CreateCompatibleDC(pDC);
		CBitmap* poldBitmap = (CBitmap*)dcMem.SelectObject(hbmp);
		pDC->StretchBlt(rect.left+2, rect.top +5, bm.bmWidth, bm.bmWidth, &dcMem, 0, 0, bm.bmWidth, bm.bmHeight, SRCCOPY);
		dcMem.SelectObject(&poldBitmap);
		hbmp.Detach();
		rect.top = rect.top + m_IconWidth;// m_pbm->bmWidth;
	}
	rect.top += 2;
	rect.bottom = rect.top + GetTabWidth(bShowText);
	rect.left += 6;
	if(bShowText)
		this->DrawTabText(pDC, m_csText, rect, bActive, m_iTabStyle);
}
void CFX_TabPage::DrawTabRect(CDC *pDC, CRect rect, BOOL bActive, int iTabStyle)
{
	COLORREF crOldText;
	if(bActive)
	{
		COLORREF colRGB = ::GetSysColor(COLOR_3DHIGHLIGHT);
		int colR = GetRValue(colRGB)-15;
		int colG = GetGValue(colRGB)-15;
		int colB = GetBValue(colRGB)-15;
		int colUnit = TITLEBARHIGHT+10;
		
		if (m_iTabStyle!= TAB_TOP)
		{
			int width = 0;
			rect.InflateRect(1, 4, 10, -2);
			
			CPen pen(PS_SOLID, 0, RGB(colR, colG, colB));
			HPEN oldPen = (HPEN)pDC->SelectObject (&pen);

			CBrush Brush(RGB(colR, colG, colB));
			CBrush *pOldBrush = pDC->SelectObject(&Brush);
			pDC->RoundRect(&rect, CPoint(5, 5));
			pDC->SelectObject(pOldBrush);
			Brush.DeleteObject();
			pDC->SelectObject (oldPen);	
			pen.DeleteObject();
		}
		else
		{
			rect.DeflateRect(-2, 6, -2, -2);
			for(int cy = rect.top; cy < rect.bottom; cy++)
			{
				colUnit-= 2;
				for(int cx = rect.left; cx<rect.right; cx++)
				{
					pDC->SetPixel(CPoint(cx, cy), RGB(colR-colUnit, colG-colUnit, colB-colUnit));
				}
			}
		}

		CPen pen(PS_SOLID, 1, GetSysColor(COLOR_3DDKSHADOW));
		HPEN oldPen = (HPEN)pDC->SelectObject (&pen);

		crOldText = pDC->SetTextColor(GetSysColor(COLOR_3DDKSHADOW));
		m_pWnd->ShowWindow(SW_SHOW);
		m_bShow = TRUE;
		pDC->SelectObject (oldPen);	
		pen.DeleteObject();
	}
	else
	{
 		CPen pen(PS_SOLID, 1, GetSysColor(COLOR_3DDKSHADOW));
		HPEN oldPen = (HPEN)pDC->SelectObject(&pen);	
 		crOldText = pDC->SetTextColor(GetSysColor(COLOR_3DDKSHADOW));
		if(m_pWnd->IsWindowVisible())
		{
			m_pWnd->ShowWindow(SW_HIDE);
			m_bShow = FALSE;
		}
		pDC->SelectObject (oldPen);
		pen.DeleteObject();
	}
	pDC->SetTextColor (crOldText);	
}

void CFX_TabPage::DrawTabText(CDC *pDC, CString csText, CRect rect, BOOL bActive, int iTabStyle)
{
	if (!csText.IsEmpty())
	{
		int l = csText.GetLength();
		int i;
		
		for(i = 0;i<10 && pDC->GetTextExtent(csText, csText.GetLength()).cx > (long)m_nTabWidth;i++, l-= 2)
			csText = csText.Left(l-2);
		if(i > 0)
		{
			csText = csText.Left(l-2);
			csText += L"...";
		}
		int nPrevBkMode = pDC->SetBkMode(TRANSPARENT);
		if(iTabStyle == TAB_TOP)
			pDC->DrawText(csText, csText.GetLength(), &rect, DT_LEFT | DT_VCENTER | DT_SINGLELINE);
		else
		{
			LOGFONT lf;	
			CFont Font, *pOldFont;
			pDC->GetCurrentFont()->GetLogFont(&lf);
			lf.lfEscapement = 900;
			lf.lfQuality = 4;
			Font.CreateFontIndirect(&lf);
			pOldFont = pDC->SelectObject(&Font);
			pDC->TextOut(rect.left-3, (rect.top+l*6+10), csText, csText.GetLength());
			pDC->SelectObject(pOldFont);
			pDC->SetBkMode(nPrevBkMode);
			Font.DeleteObject();
		}
	}
}

//////////////////////////////////////////////////////////////////////
// CFX_DockContainer
//////////////////////////////////////////////////////////////////////
IMPLEMENT_DYNAMIC(CFX_DockContainer, CFX_ControlBar);

BEGIN_MESSAGE_MAP(CFX_DockContainer, CFX_ControlBar)
//{{AFX_MSG_MAP(CFX_DockContainer)
ON_WM_CREATE()
ON_WM_NCHITTEST()
ON_WM_MOUSEMOVE()
ON_WM_NCLBUTTONUP()
ON_WM_LBUTTONDOWN()
ON_WM_RBUTTONUP()
ON_WM_LBUTTONDBLCLK()
ON_WM_SIZE()
ON_WM_PAINT()
ON_WM_DESTROY()
ON_WM_ERASEBKGND()
ON_MESSAGE(WM_GETOBJECT, OnGetObject)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

#define ID_TIMER_WAIT 0xE000 // timer while waiting to show status
#define ID_TIMER_CHECK 0xE001 // timer to check for removal of status

CFX_DockContainer::CFX_DockContainer()
{
	m_bUsedDocHistory = FALSE;
	m_szMinHorzBar = CSize(DOCKEDGE, DOCKEDGE);
	m_szMinVertBar = CSize(ITEMBUTTON_HEIGHT+8, ITEMBUTTON_HEIGHT+8);
	m_szMinFloatBar = CSize(150, 150);
	m_OriginalVertSize = m_szVertBar;
	m_OriginalHorzSize = m_szHorzBar;
	m_bActive = FALSE;
	m_nActivePage = -1;
	m_bHideHandle = FALSE;
	m_pCreateDockWnd = NULL;
	m_hHandCursor = NULL;
	m_nBtnDownPage = -1;
	m_bShowTitleText = TRUE;
	m_bShowTabText = FALSE;
	m_pFristContainer = NULL;
	m_ShowContainer = TRUE;	 
	m_bShow = TRUE;
	m_bCanfloat = TRUE;
	m_bShowTitle = TRUE;
	m_bShowFloat = TRUE;
	m_bNeedUpdate = FALSE;
	m_nTipCount = 0;
	m_arrPagePos.RemoveAll();
	m_rtHideHdlArea.SetRectEmpty();
}

CFX_DockContainer::CFX_DockContainer(CSize szFloatBar, CSize szMinFloatBar )
{
	m_bUsedDocHistory = FALSE;
	m_szMinHorzBar = m_szMinVertBar = m_szMinFloatBar = m_szMinFloatBar;
	m_szHorzBar = m_szVertBar = m_szFloatBar = szFloatBar;
	m_bTracking = FALSE;
	m_bKeepSize = FALSE;
	m_bParentSizing = FALSE;
	m_ncxEdge = 5;
	m_nDockBarState = 0;
	m_dwBarStyle = 0;
	m_nBtnDownPage = -1;
	m_bShowTitleText = TRUE;
	m_bShowTabText = FALSE;
	m_pFristContainer = NULL;
	m_ShowContainer = TRUE;
	m_bShow = TRUE;
	m_bCanfloat = TRUE;
	m_bShowTitle = TRUE;
	m_bShowFloat = TRUE;
	m_bNeedUpdate = FALSE;
	m_nTipCount = 0;
	m_arrPagePos.RemoveAll();
	m_rtHideHdlArea.SetRectEmpty();
}

void CFX_DockContainer::OnStudClick()
{
}
void CFX_DockContainer::EnableDocking(DWORD dwDockStyle)
{	
	// must be CBRS_ALIGN_XXX or CBRS_FLOAT_MULTI only
	ASSERT((dwDockStyle & ~(CBRS_ALIGN_ANY|CBRS_FLOAT_MULTI)) == 0);
	// cannot have the CBRS_FLOAT_MULTI style
	ASSERT((dwDockStyle & CBRS_FLOAT_MULTI) == 0);
	// the bar must have CBRS_SIZE_DYNAMIC style
	ASSERT((m_dwStyle & CBRS_SIZE_DYNAMIC) != 0);
	
	m_dwDockStyle = dwDockStyle;
	if (m_pDockContext == NULL)
	{
		m_pDockContext = new CFX_DockPageContext(this, m_pCreateDockWnd);
		m_PtrlDPBContext.AddTail(m_pDockContext);	
	}
	
	// permanently wire the bar's owner to its current parent
	if (m_hWndOwner == NULL)
	m_hWndOwner = ::GetParent(m_hWnd);
}

BOOL CFX_DockContainer::DeletePage(CFX_TabPage* pTabPage)
{
	pTabPage->m_pWnd->ShowWindow(SW_HIDE);
	POSITION pos = NULL;
	int index = GetIndex(pTabPage->m_csName);
	pos = m_PtrlPage.FindIndex(index);
	if(pos)
	{	
		m_PtrlPage.RemoveAt(pos);
		UpdateWindow();
		return TRUE;
	}
	return FALSE;
}
CFX_TabPage* CFX_DockContainer::DeletePage()
{
	CFX_TabPage *pTabPage = NULL;
	int Count = m_PtrlPage.GetCount();
	if(Count<= 1)
	{
		return NULL;
	}
	POSITION pos = m_PtrlPage.FindIndex(m_nActivePage);
	pTabPage = m_PtrlPage.GetAt(pos);
	pTabPage->m_pWnd->ShowWindow(SW_HIDE);
	pTabPage->m_bShow = FALSE;
	m_PtrlPage.RemoveAt (pos);
	UpdateSize();

	if(GetDlgCtrlID() == pTabPage->m_pWnd->GetDlgCtrlID())
	{	
		CFX_TabPage * pItem = NULL;
		pItem = GetTabPage(0);
		if(NULL != pItem)
			this->SetDlgCtrlID(pItem->m_pWnd->GetDlgCtrlID());
	}

	if(m_nActivePage > m_PtrlPage.GetCount()-1)
		 SelectItemChange( m_PtrlPage.GetCount()-1);
	else
	{
		SelectItemChange(m_nActivePage);		
		SendMessage(WM_NCPAINT);
		Invalidate();
	}
	return pTabPage;
}

CFX_TabPage* CFX_DockContainer::DeletePage(int nPageNam)
{
	if (-1 == nPageNam)
	{
		return DeletePage();
	}
	CFX_TabPage *pTabPage = NULL;

	int Count = m_PtrlPage.GetCount();
	if(Count<= 1 || nPageNam > (Count-1))
	{
		return NULL;
	}
	int nActive = -1;
	if(AFX_IDW_DOCKBAR_BOTTOM == this->m_nDockBarState || this->IsFloating())
	{
		nActive = (nPageNam+Count-1)%Count;
	}	
	POSITION pos = m_PtrlPage.FindIndex(nPageNam);
	pTabPage = m_PtrlPage.GetAt(pos);

	pTabPage->m_pWnd->ShowWindow(SW_HIDE);
	pTabPage->m_bShow = FALSE;
	m_PtrlPage.RemoveAt (pos);
	UpdateSize();
	setActivePage(nActive);
	if(GetDlgCtrlID() == pTabPage->m_pWnd->GetDlgCtrlID())
	{	
		CFX_TabPage * pItem = NULL;
		pItem = GetTabPage(0);
		if(NULL != pItem)
			this->SetDlgCtrlID(pItem->m_pWnd->GetDlgCtrlID());
	}
	if(this->IsFloating())
	{
		CFX_TabPage *pTabPage = GetTabPage(GetActivePage());
		if(pTabPage)
			SetWindowText(pTabPage->m_csText);
	}
	SendMessage(WM_NCPAINT);
	Invalidate();
	
	return pTabPage;
}

BOOL CFX_DockContainer::AddPage(CFX_DockContainer* pDockContainer/*, BOOL bDockBottom*/)
{
	POSITION	pos;
	CFX_TabPage* pTabPage = NULL;

	CString strTapName;
	if(NULL == pDockContainer->m_pFristContainer && pDockContainer == this->m_pFristContainer)
	{
		if(!pDockContainer->IsFloating() && !this->IsFloating()) return TRUE;
		this->GetActivePage(&strTapName);
		int nIndex = 0;
		for(pos = this->m_PtrlPage.GetHeadPosition();pos!= NULL;)
		{
			pTabPage = this->m_PtrlPage.GetNext(pos);
			if(pTabPage)
			{
				pDockContainer->AddPageBefore(pTabPage, nIndex);
				nIndex++;
			}
			else
			{
				 return FALSE;
			}
		}
		if(this->IsFloating() && pDockContainer->IsFloating())
		{
			CRect rect;
			this->GetWindowRect(&rect);
			this->ShowBar(FALSE, FALSE);
			pDockContainer->GetParent()->GetParent()->MoveWindow(rect);
		}
		else if (this->IsFloating() && !pDockContainer->IsFloating())
		{
			m_pDockSite->FloatControlBar(pDockContainer, CPoint(0, 0), CBRS_ALIGN_LEFT );
			CRect rect;
			this->GetWindowRect(&rect);
			this->ShowBar(FALSE, FALSE);
			pDockContainer->GetParent()->GetParent()->MoveWindow(rect);
		}
		else if(!this->IsFloating() && pDockContainer->IsFloating())
		{
			int nThisBarState = this->m_nDockBarState;
			m_pDockSite->FloatControlBar(this, CPoint(0, 0), CBRS_ALIGN_LEFT );
			this->ShowBar(FALSE, FALSE);
			CRect rect;
			rect = pDockContainer->m_pDockContext->m_rectDragVert;
			rect.top = 0;
			pDockContainer->m_pDockSite->DockControlBar(pDockContainer, nThisBarState);
			if(nThisBarState == AFX_IDW_DOCKBAR_BOTTOM)
			{
				pDockContainer->DockBottomAdjustment();
			}
			else if(nThisBarState == AFX_IDW_DOCKBAR_LEFT)
			{
				pDockContainer->DockLeftAdjustment();
			}
		}
		else
		{
			int nThisBarState = this->m_nDockBarState;
			m_pDockSite->FloatControlBar(this, CPoint(0, 0), CBRS_ALIGN_LEFT );
			m_pDockSite->DockControlBar(pDockContainer, nThisBarState);	
			if(nThisBarState == AFX_IDW_DOCKBAR_BOTTOM)
			{
				pDockContainer->DockLeftAdjustment();
			}
			else if(nThisBarState == AFX_IDW_DOCKBAR_LEFT)
			{
				pDockContainer->DockBottomAdjustment();
			}
		}
		pDockContainer->SelectItemChange(strTapName);
		this->m_PtrlPage.RemoveAll();
		pDockContainer->UpdateWindow();		
		this->DestroyWindow();
		return TRUE;
	}
	else
	{
		pDockContainer->GetActivePage(&strTapName);
		for(pos = pDockContainer->m_PtrlPage.GetHeadPosition();pos!= NULL;)
		{
			POSITION posPrev = pos;
			pTabPage = pDockContainer->m_PtrlPage.GetNext(pos);
			if(pTabPage && NULL != pTabPage->m_pWnd)
			{
				if(pTabPage->m_bDockBottom && 1 == pDockContainer->m_PtrlPage.GetCount()
					 && AFX_IDW_DOCKBAR_BOTTOM != pDockContainer->m_nDockBarState 
					 && AFX_IDW_DOCKBAR_FLOAT != this->m_nDockBarState
					 && AFX_IDW_DOCKBAR_BOTTOM != this->m_nDockBarState)
				{
					 CFX_DockContainer* pDockedBar = SearchDockContainer(AFX_IDW_DOCKBAR_BOTTOM);
					if(pDockedBar)
					{
						return pDockedBar->AddPage(pDockContainer);
					}
				}			
 				else if( (pTabPage->m_bDockBottom && pDockContainer->IsFloating())
					||(!pTabPage->m_bDockBottom && AFX_IDW_DOCKBAR_BOTTOM == this->m_nDockBarState))
 				{
					if(!pTabPage->m_bDockBottom && AFX_IDW_DOCKBAR_LEFT == pDockContainer->m_nDockBarState)
					{
						return TRUE;
					}
					if(this->AddPage(pTabPage))
					{
						pDockContainer->m_PtrlPage.RemoveAt(posPrev);
					}
					else if(!pTabPage->m_bDockBottom)
					{
						m_pDockSite->DockControlBar(pDockContainer, AFX_IDW_DOCKBAR_LEFT);
						pDockContainer->DockLeftAdjustment();
						return TRUE;
					}
					continue;
 				}
				pTabPage->m_pWnd->SetParent(this);
				m_PtrlPage.AddTail(pTabPage);
				if(GetStyle() & WS_VISIBLE && pDockContainer->m_nDockBarState != AFX_IDW_DOCKBAR_BOTTOM)
				{
					pTabPage->m_bShow = TRUE;
					if(!(this->m_nDockBarState == AFX_IDW_DOCKBAR_LEFT && pTabPage->m_bDockBottom == TRUE))
						setActivePage(pTabPage->m_csName);
				}
				else
					pTabPage->m_bShow = FALSE;
			}
			else
			{
				return FALSE;
			}
		}
		pDockContainer->ShowWindow(SW_HIDE);
		m_pDockSite->FloatControlBar(pDockContainer, CPoint(0, 0), CBRS_ALIGN_LEFT);
		pDockContainer->m_PtrlPage.RemoveAll();
		UpdateWindow();
		return pDockContainer->DestroyWindow();
	}
}

BOOL CFX_DockContainer::AddPageBefore(CFX_TabPage* pTabPage, int nIndex)
{
	if(NULL == pTabPage) return FALSE;
	
	pTabPage->m_pWnd->SetParent(this);
	if(GetStyle() & WS_VISIBLE)
		pTabPage->m_bShow = TRUE;
	else
		pTabPage->m_bShow = FALSE;
	m_PtrlPage.InsertBefore(m_PtrlPage.FindIndex( nIndex ) , pTabPage);
	UpdateWindow();
	return TRUE;

}

BOOL CFX_DockContainer::AddPageTail(CFX_TabPage* pTabPage)
{
	if(NULL == pTabPage) return FALSE;	
	pTabPage->m_pWnd->SetParent (this);
	if(GetStyle() & WS_VISIBLE)
		pTabPage->m_bShow = TRUE;
	else
		pTabPage->m_bShow = FALSE;
	m_PtrlPage.AddTail(pTabPage);
	UpdateWindow();
	return TRUE;
}


BOOL CFX_DockContainer::AddPage(CFX_TabPage* pTabPage)
{
	if(NULL == pTabPage) return FALSE;

	if(pTabPage->m_bDockBottom && this->m_nDockBarState == AFX_IDW_DOCKBAR_LEFT)
	{
		CFX_DockContainer* pDockedBar = SearchDockContainer(AFX_IDW_DOCKBAR_BOTTOM);
		if(pDockedBar)
		{
			pDockedBar->AddPageTail(pTabPage);	 
			return TRUE;
		}
	}
	else if(!pTabPage->m_bDockBottom && this->m_nDockBarState == AFX_IDW_DOCKBAR_BOTTOM)
	{
		CFX_DockContainer* pDockedBar = SearchDockContainer(AFX_IDW_DOCKBAR_LEFT);
		if(pDockedBar)
		{
			((CFX_DockContainer*)pDockedBar)->AddPageTail(pTabPage);
			return TRUE;
		}	
		return FALSE;	
	}
	AddPageTail(pTabPage);
	return TRUE;
}

int	 CFX_DockContainer::GetInsertAddPos(int nHistoryPos)
{
	if(m_arrPagePos.GetSize()<1) return -1;
	for(int i = 0; i <m_arrPagePos.GetSize(); i++)
	{
		if(nHistoryPos<m_arrPagePos.GetAt(i))
			return i;
		continue;
	}
	return -1;
}

CFX_DockContainer*  CFX_DockContainer::CreateNewContainer(CFX_TabPage *pTabPage, CSize size, UINT nID , DWORD dwStyle )
{
	CFX_DockContainer* pBar = new CFX_DockContainer();
	pBar->m_iTabStyle = 	pTabPage->m_iTabStyle = this->m_iTabStyle;	
	pBar->ShowTabText(this->IsShowTabText());
	pBar->ShowTitleText(this->IsShowTitleText());
	if(0 == size.cx) size.cx = 230;
	if(0 == size.cy) size.cy = 240;

 	if (!(pBar->Create(pTabPage->m_csText, m_pDockSite, size, TRUE, nID, this->m_bUsePreState, dwStyle)))
	{
		TRACE0("Failed to create CFX_DockContainer\n");
		return NULL;
	}
	if(this->m_pFristContainer == NULL )
		pBar->SetFristContainer(this);
	else
		pBar->SetFristContainer(this->m_pFristContainer);

	pBar->SetBarStyle(this->GetBarStyle() |	CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	pBar->EnableDocking(this->m_dwDockStyle);
	if(FALSE == m_bCanfloat)
	{
		pBar->m_bAutoDelete = TRUE;
	}
	else
	{
		((CFX_DockPageContext*)m_pDockContext)->m_PtrlDPBar.AddTail(pBar);	
	}
	return pBar;
}

BOOL CFX_DockContainer::AddPage( CWnd* pWnd, LPCWSTR csToolTip, LPCWSTR csText, LPCWSTR csName, HBITMAP pBitmap, 
										 int iTabStyle , IReader_PanelView* pPanelView, BOOL bDockBottom)
{
	ASSERT(IsWindow(pWnd->m_hWnd));
	m_iTabStyle = iTabStyle;
	CFX_TabPage *pTabPage;
	pTabPage = new CFX_TabPage(iTabStyle);
	pTabPage->m_pPanelView = pPanelView;
	pTabPage->m_pWnd = pWnd;
	pTabPage->m_csText = csText;
	pTabPage->m_csName = csName;
	pTabPage->m_csToolTip = csToolTip;
	pTabPage->m_bDockBottom = bDockBottom;
	int nid = pWnd->GetDlgCtrlID();
	
	if(NULL != pBitmap)
	{
		pTabPage->m_hBitmap = pBitmap;
	}
	m_ShowContainer = TRUE;
	pTabPage->m_pWnd->SetParent(this);
	if(GetStyle() & WS_VISIBLE)
		pTabPage->m_bShow = TRUE;
	else
		pTabPage->m_bShow = FALSE;

	if(pWnd)
	{
		CRect	rect;
		GetClientRect(&rect, m_PtrlPage.GetCount()>1?TRUE:FALSE);
		pWnd->MoveWindow(rect);
		pWnd->ShowWindow(SW_HIDE);
	}
	m_PtrlPage.AddTail(pTabPage);
	if(m_nActivePage < 0 && !pTabPage->m_bDockBottom )
		SelectItemChange(m_PtrlPage.GetCount()-1);
	UpdateSize();
	Invalidate(FALSE);
	return TRUE;
}

BOOL CFX_DockContainer::AddPage(CRuntimeClass *pClass, UINT nIDTemplate, LPCWSTR csToolTip, LPCWSTR csText, 
							LPCWSTR csName, HBITMAP pBitmap, int iTabStyle , IReader_PanelView* pPanelView, BOOL bDockBottom)
{
	m_iTabStyle = iTabStyle;
	CDialog *pDlg = (CDialog*)pClass->CreateObject();
	if(pDlg != NULL)
	{
		if(pDlg->Create(nIDTemplate, this))
		{
			return AddPage(pDlg, csToolTip, csText, csName, pBitmap);
		}
	}
	return FALSE;
}

void CFX_DockContainer::ShowBar(BOOL bShow, BOOL bDelay)
{
	if(m_nActivePage != -1 && (m_nActivePage<= m_PtrlPage.GetCount()))
	{
		POSITION pos = m_PtrlPage.FindIndex(m_nActivePage);
		CFX_TabPage * pTabPage = NULL;
		pTabPage = (CFX_TabPage *)m_PtrlPage.GetAt(pos);
		if(pTabPage)
		pTabPage->m_bShow = bShow;
	}
	this->m_bShow = bShow;
	m_pDockSite->ShowControlBar(this, bShow, bDelay);
}

BOOL CFX_DockContainer::HasGripper() const
{
	if (IsFloating())
		return FALSE;
	return TRUE;
}

void CFX_DockContainer::OnUpdateCmdUI(CFrameWnd* pTarget, BOOL bDisableIfNoHndler)
{
	if (!HasGripper())
		return;
	
	BOOL bNeedPaint = FALSE;
	
	CWnd* pFocus = GetFocus();
	BOOL bActiveOld = m_bActive;
	
	m_bActive = (pFocus->GetSafeHwnd() && IsChild(pFocus));
	m_bActive = m_bActive || (pFocus == this);
	if (m_bActive != bActiveOld)
	bNeedPaint = TRUE;
	CPoint pt;
	::GetCursorPos(&pt);
	
	///////////////////////////////////////////////////////////
	// hit close
	BOOL bHit = (OnNcHitTest(pt) == HTCLOSE);
	BOOL bLButtonDown = (::GetKeyState(VK_LBUTTON) < 0);

	BOOL bWasPushed = m_BtnHide.m_bPushed;
	m_BtnHide.m_bPushed = bHit && bLButtonDown;

	BOOL bWasRaised = m_BtnHide.m_bRaised;
	m_BtnHide.m_bRaised = bHit && !bLButtonDown;

	bNeedPaint |= (m_BtnHide.m_bPushed ^ bWasPushed) ||
		(m_BtnHide.m_bRaised ^ bWasRaised);

	bHit = (OnNcHitTest(pt) == HTSTUD);
	bWasPushed = m_BtnStud.m_bPushed;
	m_BtnStud.m_bPushed = bHit && bLButtonDown;

	bWasRaised = m_BtnStud.m_bRaised;
	m_BtnStud.m_bRaised = bHit && !bLButtonDown;

	bNeedPaint |= (m_BtnStud.m_bPushed ^ bWasPushed) ||
		(m_BtnStud.m_bRaised ^ bWasRaised);

	if (bNeedPaint)
		SendMessage(WM_NCPAINT);
}

CFX_TabPage* CFX_DockContainer::GetTabPage(int nIndex)
{
	CFX_TabPage *pTabPage = NULL;
	POSITION pos = m_PtrlPage.FindIndex(nIndex);
	if(pos)
		pTabPage = m_PtrlPage.GetNext(pos);	
	return pTabPage;
}

CFX_TabPage* CFX_DockContainer::GetTabPage(int& nItemIndex, CPoint pt)
{
	POSITION pos;
	CFX_TabPage *pTabPage;
	for(pos = m_PtrlPage.GetHeadPosition();pos!= NULL;nItemIndex++)
	{
		pTabPage = m_PtrlPage.GetNext(pos);
		if(pTabPage)
		{
			if(pTabPage->m_rect.PtInRect(pt))
			{
				return pTabPage;
			}
		}
	}
	nItemIndex = 0;
	return NULL;
}
				
CFX_TabPage*  CFX_DockContainer::GetTabPageByName(CString csTabName)
{
	CFX_TabPage *pTabPage = NULL;
	POSITION pos = m_PtrlPage.GetHeadPosition();
	while(pos)
	{
		pTabPage = (CFX_TabPage *)m_PtrlPage.GetAt(pos);
		if(pTabPage)
		{
			if(0 == pTabPage->m_csName.CompareNoCase(csTabName))
			{
				return pTabPage;
			}
		}
		pTabPage = NULL;
		m_PtrlPage.GetNext(pos);
	}
	return pTabPage;
}

void CFX_DockContainer::UpdateSize()
{
	UINT PageCount = m_PtrlPage.GetCount();

	if(TRUE == m_bNeedUpdate)
	{
		for (int j = 1; j <= m_nTipCount; j++)
		{
			m_ToolTip.DelTool(this, j+1);
		}
		m_nTipCount = 0;
	}

	if(PageCount < 1) return;
	
	CFX_TabPage	*pTabPage = NULL;
	CRect		 rect, ClientRect, ItemRect, ItemBottomRect;

	if(/*PageCount == 1 && */ m_iTabStyle == TAB_NULL ) 
	{
		pTabPage = GetTabPage(0);
		GetClientRect(&ClientRect, FALSE);
			if(pTabPage && pTabPage->m_pWnd)
			{
				pTabPage->m_pWnd->MoveWindow(ClientRect);
				pTabPage->m_pWnd->ShowWindow(SW_SHOW);
				pTabPage->m_bShow = TRUE;
			}
		return;
	}
	else if(m_iTabStyle == TAB_TOP)
	{
		GetClientRect(&rect, FALSE);
		rect.left += 2; //tab
		rect.right -= 6;
		rect.bottom -= 1;
		rect.bottom = rect.top + ITEMBUTTON_HEIGHT - 2;
	}
	else 
	{
		GetClientRect(&rect, FALSE);
		rect.left += 2; //tab
		rect.right = rect.left + ITEMBUTTON_HEIGHT - 2;
		rect.bottom -= 1;
		rect.top += 2;
 	}

 	POSITION	 pos;

 	GetClientRect(ClientRect, TRUE);

	ItemRect = rect;
	ItemBottomRect = rect;
	int AreaTopWidth = 0, AreaBottomWidth = ClientRect.Height(), ItemWidth, ItemIndex = 0;
	int nDockBottomCount = GetDockBottomCount();
	for(pos = m_PtrlPage.GetHeadPosition();pos!= NULL;ItemIndex++)
	{
		pTabPage = m_PtrlPage.GetNext(pos);
		if(pTabPage)	
		{
			ItemWidth = pTabPage->GetTabWidth(m_bShowTabText);
 			if(!IsFloating() && (TRUE == pTabPage->m_bDockBottom || m_nDockBarState == AFX_IDW_DOCKBAR_BOTTOM))
 			{
 				AreaBottomWidth -= ItemWidth;
 				if( ClientRect.Height() < (ItemWidth*(m_PtrlPage.GetCount())) && m_nDockBarState != AFX_IDW_DOCKBAR_BOTTOM)
				{
					AreaTopWidth += ItemWidth;
					ItemRect.bottom = ItemRect.top+ItemWidth-1;
					pTabPage->m_rect = ItemRect;
					ItemRect.top = ItemRect.bottom + 1;
					if(pTabPage->m_pWnd)
						pTabPage->m_pWnd->MoveWindow(ClientRect);
				}
				else
				{
					ItemBottomRect.top = ClientRect.bottom - (ItemWidth*nDockBottomCount);
					ItemBottomRect.bottom = ItemBottomRect.top+ItemWidth-1;
					pTabPage->m_rect = ItemBottomRect;
					if(pTabPage->m_pWnd)
 						pTabPage->m_pWnd->MoveWindow(ClientRect);
				}
				nDockBottomCount--;
 			}
 			else if(m_iTabStyle == TAB_TOP)
			{
				AreaTopWidth += ItemWidth;
				ItemRect.right = ItemRect.left+ItemWidth-1;
				pTabPage->m_rect = ItemRect;
				ItemRect.left = ItemRect.right + 1;
				if(pTabPage->m_pWnd)
					pTabPage->m_pWnd->MoveWindow(ClientRect);
			}
			else 
			{
				AreaTopWidth += ItemWidth;
				ItemRect.bottom = ItemRect.top+ItemWidth-1;
				//ItemRect.top += 1;
				pTabPage->m_rect = ItemRect;
				ItemRect.top = ItemRect.bottom + 1;
				if(pTabPage->m_pWnd)
					pTabPage->m_pWnd->MoveWindow(ClientRect);
			}
			m_ToolTip.AddTool(this, pTabPage->m_csToolTip, &(pTabPage->m_rect), ItemIndex+1);
			m_bNeedUpdate = TRUE;
		}
		m_nTipCount = ItemIndex;
	}

}

CFX_DockContainer::~CFX_DockContainer()
{
 	POSITION pos;
	for(pos = m_PtrlDPBContext.GetHeadPosition(); pos;)
	{
		CFX_DockPageContext* pDPBContext = NULL;
		pDPBContext = (CFX_DockPageContext*)m_PtrlDPBContext.GetNext(pos);
		if(NULL != pDPBContext)
		{
			pDPBContext->FreeAll();
		}
	}
	m_PtrlDPBContext.RemoveAll();
	m_arrPagePos.RemoveAll();
}


void CFX_DockContainer::OnDestroy() 
{
	CFX_ControlBar::OnDestroy();
	
	// TODO: Add your message handler code here
	m_font.DeleteObject();
	POSITION pos;
	for(pos = m_PtrlPage.GetHeadPosition(); pos;)
	{
		CFX_TabPage* pTabPage = m_PtrlPage.GetNext(pos);
		CWnd *pWnd = pTabPage->m_pWnd;
		
		delete pTabPage; 
		pTabPage = NULL;
	}
	m_PtrlPage.RemoveAll();
}

void CFX_DockContainer::Move(CPoint pt)
{
	CRect rect;
	GetClientRect(&rect, FALSE);
	if(m_iTabStyle == TAB_TOP)
		rect.bottom = rect.top+ITEMBUTTON_HEIGHT+8;
	else
		rect.right = rect.left+ITEMBUTTON_HEIGHT+8;
	CPoint point = pt;
	ScreenToClient(&point);

	if(rect.PtInRect(point))
	{
		return;
	}
	else 
	{
		if(!m_rtTitleBar.PtInRect(CPoint(point.x, (point.y+24))))
		{
			ReleaseCapture();
			((CFX_DockPageContext*)m_pDockContext)->m_bisPage = TRUE;
			if(!m_bCanfloat) return;
			StartDrag(pt);
		}
	}
}

int CFX_DockContainer::HitTest(CPoint pt)
{
	CRect rtBtnHide;
	rtBtnHide.SetRectEmpty();
	rtBtnHide = m_BtnHide.GetRect();
	if(!rtBtnHide.IsRectEmpty() && rtBtnHide.PtInRect(pt))
	{
		return HTHIDE;
	}

	CRect rtBtnStud;
	rtBtnStud.SetRectEmpty();
	rtBtnStud = m_BtnStud.GetRect();
	if(!rtBtnStud.IsRectEmpty() && rtBtnStud.PtInRect(pt))
	{
		return HTSTUD;
	}

	if(m_rtTitleBar.PtInRect(CPoint(pt.x, (pt.y+24))))
	{
		return HTTITLE;
	}
	else if(m_rtTabBar.PtInRect(pt))
	{
		UINT nItemIndex = 0;
		POSITION pos;
		CFX_TabPage *pItem;
		for(pos = m_PtrlPage.GetHeadPosition();pos!= NULL;nItemIndex++)
		{
			pItem = m_PtrlPage.GetNext(pos);
			if(pItem)
			{
				if(pItem->m_rect.PtInRect(pt))
				{
					return nItemIndex;		
				}
			}
		}
		return HTTABBAR;
	}

	return HTCONTAINER;
}
void CFX_DockContainer::CanDrag(CPoint pt)
{
	 SetCapture();
	// get messages until capture lost or cancelled/accepted
	while (CWnd::GetCapture() == this)
	{
		MSG msg;
		if (!::GetMessage(&msg, NULL, 0, 0))
		{
			AfxPostQuitMessage(msg.wParam);
			break;
		}
		switch (msg.message)
		{
 			case WM_LBUTTONUP:
				LButtonUp(MK_LBUTTON, pt);
 				break;
			case WM_MOUSEMOVE:
				{						
					Move(msg.pt);
					break;

				}			
			default:
				DispatchMessage(&msg);
				break;
		}
	}
}
void CFX_DockContainer::StartDrag(CPoint pt)
{
	ClientToScreen(&pt);
	m_pDockContext->StartDrag(pt);
	((CFX_DockPageContext*)m_pDockContext)->m_bisPage = FALSE;
}

void CFX_DockContainer::UpdateWindow()
{
	if(this->IsFloating())
	{
		CFX_TabPage *pTabPage = GetTabPage(GetActivePage());
		if (NULL != pTabPage)
			SetWindowText(pTabPage->m_csText);
	}

	UpdateSize();
 	Invalidate(FALSE);
}

void CFX_DockContainer::GetClientRect(LPRECT lpRect, BOOL bMulti)
{
	CWnd::GetClientRect(lpRect);
	
	if(TRUE == bMulti)
	{
		if(m_iTabStyle == TAB_TOP)
			lpRect->top += ITEMBUTTON_HEIGHT;
		else 
			lpRect->left += ITEMBUTTON_HEIGHT;
	}
		
}
void CFX_DockContainer::GetActivePage(CString *strTapName)
{
	if(GetActivePage()>= 0)
	{
		CFX_TabPage *pTabPage = NULL;
		pTabPage = GetTabPage(GetActivePage());
		if(NULL != pTabPage)
			*strTapName = pTabPage->m_csName;
		else
			strTapName = NULL;
	}
	else
	{
		strTapName = NULL;
	}
}

void CFX_DockContainer::setActivePage(CFX_TabPage* pTabPage)
{
	int nIndex = GetIndex(pTabPage->m_csName); 
	setActivePage(nIndex);
}

void CFX_DockContainer::setActivePage(int nIndex)
{
	if( -1 == nIndex)
	{
		SelectItemChange(nIndex);
		return;
	}
	CFX_TabPage *pTabPage = NULL;
	if(0 == nIndex && this->m_nDockBarState == AFX_IDW_DOCKBAR_LEFT)
	{
		pTabPage = GetTabPage(nIndex);
		while(pTabPage && pTabPage->m_bDockBottom)
		{
			nIndex++;
			pTabPage = GetTabPage(nIndex);
		}
	}
	else
	{
		pTabPage = GetTabPage(nIndex);
	}
	
	if(!pTabPage)
	{
		SendMessage(WM_NCPAINT);
		Invalidate();
		return;
	}
	
	CFX_TabPage *pOldTabPage = NULL ;
	pOldTabPage = GetTabPage(m_nActivePage);
	if(this->IsFloating())
	{
		SetWindowText(pTabPage->m_csText);
	}	
	if(pOldTabPage)
	{
		pOldTabPage->m_bShow = FALSE;
	}
	pTabPage->m_bShow = TRUE;
	m_nActivePage = nIndex;
	SendMessage(WM_NCPAINT);
	Invalidate();
	if(pTabPage->m_pPanelView)
		pTabPage->m_pPanelView->OnPanelActive();
}
void CFX_DockContainer::setActivePage(CString strTapName)
{
	int nIndex = GetIndex(strTapName); 
	setActivePage(nIndex);
}

void CFX_DockContainer::SelectItemChange(int nIndex)
{
	if(-1 == nIndex)
	{
		m_nActivePage = -1;

		if(!m_bHideHandle)
		{
			SetVertBarSize((ITEMBUTTON_HEIGHT+8, ITEMBUTTON_HEIGHT+8));
			m_bHideHandle = TRUE;
			m_pDockSite->RecalcLayout();
			return;
		}
		SendMessage(WM_NCPAINT);
		Invalidate();
		return;
	}
		
	CFX_TabPage *pTabPage = NULL;
	pTabPage = GetTabPage(nIndex);
	
	if(nIndex == m_nActivePage)
	{
		if (this->IsFloating() && !m_bShow)
		{
			m_pDockSite->ShowControlBar(this, TRUE, TRUE);
			m_ShowContainer = m_bShow = TRUE;
			pTabPage->m_bShow = TRUE;
			return;
		}
		if(pTabPage && pTabPage->m_bDockBottom && this->m_nDockBarState == AFX_IDW_DOCKBAR_BOTTOM)
		{
			RecalcBarLayout(pTabPage, nIndex);
			return;
		}
	}
	else
	{
		if (!this->m_bShow)
		{
			m_pDockSite->ShowControlBar(this, !m_bShow, TRUE);
			m_ShowContainer = m_bShow = !m_bShow;
		}
	}

	if(!pTabPage)
	{
		return;
	}
	if(pTabPage && pTabPage->m_bDockBottom && m_nDockBarState == AFX_IDW_DOCKBAR_LEFT)
	{
		pTabPage->m_bShow = TRUE;
		if(this->m_PtrlPage.GetCount()<= 1)//only one page left
		{
			return;
		}
		else//more the one
		{
			RecalcBarLayout(pTabPage, nIndex);
			return;
		}
		
		if(!pTabPage)
		{
			SendMessage(WM_NCPAINT);
			Invalidate();
			return;
		}		
	}
	pTabPage->m_bShow = TRUE;
	CFX_TabPage *pOldTabPage = NULL ;
	pOldTabPage = GetTabPage(m_nActivePage);
	if(this->IsFloating())
	{
		SetWindowText(pTabPage->m_csText);
	}	
	if(pOldTabPage)
	{
		pOldTabPage->m_bShow = FALSE;
	}
	m_nActivePage = nIndex;
	SendMessage(WM_NCPAINT);
	Invalidate();
	if(pTabPage->m_pPanelView)
		pTabPage->m_pPanelView->OnPanelActive();

}

void CFX_DockContainer::SelectItemChange(CString strTapName)
{
	CString strName;
	GetActivePage(&strName);
	if(!strTapName.IsEmpty() && !strTapName.Compare(strName))
	{
		if ( m_bHideHandle && m_nDockBarState == AFX_IDW_DOCKBAR_LEFT)
		{
			RecalcBarLayout();
		}
		else
		{
			SelectItemChange(-1);
		}
	}
	else
	{
		int nIndex = GetIndex(strTapName);
		if(nIndex>= 0)
		{
			CFX_TabPage * pTabPage = NULL;
			pTabPage = GetTabPage(nIndex);
			SelectItemChange(nIndex);
			if(pTabPage && m_bHideHandle && !pTabPage->m_bDockBottom)
			{
				RecalcBarLayout();
			}
		}
		else
		{
			CList<class CFX_DockContainer *, class CFX_DockContainer *> PtrlContainer;
			GetALLContainer(&PtrlContainer);
			POSITION Pos = PtrlContainer.GetHeadPosition();
			CFX_DockContainer* pContainer = NULL;
			while(Pos)
			{
				pContainer = PtrlContainer.GetNext(Pos);
				if(pContainer)
				{
					int nIndex = pContainer->GetIndex(strTapName);
					if(-1 == nIndex)
					{
						continue;
					}
					else
					{
						pContainer->SelectItemChange(nIndex);
					}
				}		
			}
		}	
	}
}

int CFX_DockContainer::GetIndex(CString strTapName)
{
	int nIndex = -1;
	CFX_TabPage *pTabPage = NULL;
	POSITION pos = m_PtrlPage.GetHeadPosition();
	while(pos)
	{
		nIndex++;
		pTabPage = NULL;
		pTabPage = (CFX_TabPage *)m_PtrlPage.GetAt(pos);
		if(pTabPage)
		{
			if(0 == pTabPage->m_csName.CompareNoCase(strTapName))
			{
				return nIndex;
			}
		}
		m_PtrlPage.GetNext(pos);
	}
	return -1;
	
}

void CFX_DockContainer::HideTabPage(CFX_TabPage* pTabPage)
{
	CFX_DockContainer* pContainer = (CFX_DockContainer*)pTabPage->m_pWnd->GetParent();
	if(pContainer->IsFloating())
	{
		pContainer->ShowBar(FALSE, TRUE);
		pContainer->m_bShow = FALSE;
	}
	else if(pContainer->m_nDockBarState == AFX_IDW_DOCKBAR_LEFT)
	{
		pContainer->RecalcBarLayout();
	}
	else
	{
		RecalcBarLayout(pTabPage, 0);
	}
}

void CFX_DockContainer::NcTitleBar(CDC* pDC, CRect rcClient)
{
	CRect gripper = rcClient;
	if(m_nDockBarState == AFX_IDW_DOCKBAR_LEFT)
	{
 		gripper.right = gripper.right + DOCKEDGE;
	}
	else if(m_nDockBarState == AFX_IDW_DOCKBAR_RIGHT)
	{
		gripper.left = gripper.left - DOCKEDGE;
	}
	gripper.top -= TITLEBARHIGHT;
	gripper.bottom = gripper.top + TITLEBARHIGHT;
	m_rtTitleBar = gripper;

	COLORREF colRGB = ::GetSysColor(COLOR_3DFACE);
	int colR = GetRValue(colRGB);
	int colG = GetGValue(colRGB);
	int colB = GetBValue(colRGB);
	int colUnit = TITLEBARHIGHT;
	colUnit = min(TITLEBARHIGHT, min((COLORTOP-colR), min((COLORTOP-colG), (COLORTOP-colB))));

	int bmp_width = gripper.Width();
	int bmp_height = gripper.Height();		
	
	int pitch = (bmp_width * 24 + 31)/32 * 4;
	int size = pitch * bmp_height;
	BYTE* pBits = new BYTE[size];
	memset(pBits, 0, size);
	for (int row = 0; row < bmp_height; row++) {
		BYTE* scans = pBits+row*pitch;
		colUnit--;
		DWORD color = ((colR+colUnit)<<16)|((colG+colUnit)<<8)|(colB+colUnit);
		for (int col = 0; col < bmp_width; col++) {
			BYTE* pPort = scans+(col<<1)+col;
			*(DWORD*)pPort&= 0xff000000;
			*(DWORD*)pPort|= 0x00ffffff&color;
		}
	}
	BITMAPINFO bmi;
	memset(&bmi, 0, sizeof bmi);
	bmi.bmiHeader.biSize = sizeof bmi.bmiHeader;
	bmi.bmiHeader.biBitCount = 24;
	bmi.bmiHeader.biClrImportant = 0;
	bmi.bmiHeader.biClrUsed = 0;
	bmi.bmiHeader.biCompression = BI_RGB;
	bmi.bmiHeader.biHeight = bmp_height;
	bmi.bmiHeader.biPlanes = 1;
	bmi.bmiHeader.biSizeImage = 0;
	bmi.bmiHeader.biWidth = bmp_width;
	bmi.bmiHeader.biXPelsPerMeter = 0;
	bmi.bmiHeader.biYPelsPerMeter = 0;

	int ret = SetDIBitsToDevice(pDC->m_hDC, gripper.left, gripper.top, bmp_width, bmp_height, 0, 0, 0, bmp_height, pBits, &bmi, DIB_RGB_COLORS);
	delete []pBits;	
	if(!m_bHideHandle)
		DrawTitleText(&gripper, pDC);
	else
	{
		gripper.top += 5;
	}
	m_rtTitleBar.top = gripper.top;
	CPoint ptOrgBtn;
	if(TAB_NULL != m_iTabStyle)
	{
		gripper.right -= 20;	
		ptOrgBtn = CPoint(gripper.right, gripper.top);
		m_BtnStud.Move(ptOrgBtn);
		m_BtnStud.Paint(pDC, m_bHideHandle);
	}
	else
	{
		gripper.right -= 20;
		ptOrgBtn = CPoint(gripper.right, gripper.top);
		m_BtnHide.Move(ptOrgBtn);
		m_BtnHide.Paint(pDC, m_bHideHandle);
	}
}

void CFX_DockContainer::DrawTitleText(CRect* pTextrect, CDC* pDC)
{
	HFONT oldFont = (HFONT)pDC->SelectObject(m_font);
	CGdiObject* poldBrush = pDC->SelectStockObject(NULL_BRUSH); 
	pTextrect->left += 10;
	pTextrect->top += 5;
	CFX_TabPage *pTabPage = NULL;
	pTabPage = GetTabPage(GetActivePage());
	// draw caption
	int nPrevBkMode = pDC->SetBkMode(TRANSPARENT);
	if (pTabPage && !(pTabPage->m_csText).IsEmpty() && m_bShowTitleText)
	{
		CString sText = pTabPage->m_csText;
		int l = sText.GetLength();
		int i;
		
		for(i = 0;i<10 && pDC->GetTextExtent(sText, sText.GetLength()).cx > (pTextrect->Width() - 30);i++, l-= 2)
			sText = sText.Left(l-2);
		if(i > 0)
		{
			sText = sText.Left(l-2);
			sText += L"...";
		}
		pDC->TextOut(pTextrect->left, pTextrect->top, sText, sText.GetLength());
	}

	pDC->SetBkMode(nPrevBkMode);
	pDC->SelectObject(oldFont);
	pDC->SelectObject(poldBrush);
}

void CFX_DockContainer::SetOnlyTabBar()
{
	m_OriginalVertSize = m_szVertBar;
	SetVertBarSize((ITEMBUTTON_HEIGHT, ITEMBUTTON_HEIGHT+8));
	m_bHideHandle = TRUE;
	m_pDockSite->RecalcLayout();
}

BOOL CFX_DockContainer::DockAllPage()
{
	CList<class CFX_DockContainer *, class CFX_DockContainer *> PtrlContainer;
	BOOL bSucceed ;
	bSucceed = GetALLContainer(&PtrlContainer);
	CFX_DockContainer* pFristContainer = NULL;
	if(this->m_pFristContainer == NULL)
	{
		pFristContainer = this;
	}
	else
	{
		pFristContainer = this->m_pFristContainer;
	}

	if(pFristContainer->IsFloating() || AFX_IDW_DOCKBAR_BOTTOM == m_nDockBarState)
	{
		m_pDockSite->DockControlBar(pFristContainer, AFX_IDW_DOCKBAR_LEFT);		
	}

	if(bSucceed)
	{
		POSITION pos = NULL; 
		pos = PtrlContainer.GetHeadPosition();
		CFX_DockContainer *pContainer;
		while(pos)
		{
			pContainer = NULL;
			pContainer = PtrlContainer.GetNext(pos);
			if(NULL != pContainer && pFristContainer != pContainer && NULL != pContainer->m_hWnd)
			{
				if(!pContainer->IsFloating())
				{
					m_pDockSite->FloatControlBar(pContainer, CPoint(0, 0), CBRS_ALIGN_LEFT );
				}
				pFristContainer->AddPage(pContainer);
			}
		}
		pFristContainer->SetOnlyTabBar();
		return TRUE;	
	}
	else
	{
		return FALSE;
	}	
}


BOOL CFX_DockContainer::GetALLContainer(CList<CFX_DockContainer*, CFX_DockContainer*> *pPtrlContainer)
{
	POSITION pos = ((CFrameWnd*)m_pCreateDockWnd)->m_listControlBars.GetHeadPosition();
	CControlBar * pDockedBar;
	while (pos)
	{
		pDockedBar = NULL; 
		pDockedBar = (CControlBar*)((CFrameWnd*)m_pCreateDockWnd)->m_listControlBars.GetNext(pos);
		if(pDockedBar && (pDockedBar->IsKindOf(RUNTIME_CLASS(CFX_DockContainer))) )	
		{
			pPtrlContainer->AddTail((CFX_DockContainer*)pDockedBar);
		}
	}
	
	if(pPtrlContainer->GetCount()<0)
	{
		return FALSE;
	}
	else
	{
		return TRUE;
	}
}

void   CFX_DockContainer::ShowALLVisibleContainer(BOOL bShow, BOOL bDelay)
{
	CList<class CFX_DockContainer *, class CFX_DockContainer *> PtrlContainer;
	BOOL bSucceed = GetALLContainer(&PtrlContainer);
	
	POSITION pos = PtrlContainer.GetHeadPosition();
	CFX_DockContainer *pContainer;
	while(pos)
	{
		pContainer = NULL;
		pContainer = PtrlContainer.GetNext(pos);
		if(NULL != pContainer && NULL != pContainer->m_hWnd && (FALSE != pContainer->m_bShow))
		{
			((CFrameWnd*)m_pCreateDockWnd)->ShowControlBar(pContainer, bShow, bDelay);
		}
	}
	m_ShowContainer = bShow;
}

void CFX_DockContainer::ShowALLContainer(BOOL bShow, BOOL bDelay)
{
	CList<class CFX_DockContainer *, class CFX_DockContainer *> PtrlContainer;
	BOOL bSucceed = GetALLContainer(&PtrlContainer);

	POSITION pos = PtrlContainer.GetHeadPosition();
	CFX_DockContainer *pContainer;
	while(pos)
	{
		pContainer = NULL;
		pContainer = PtrlContainer.GetNext(pos);
		if(NULL != pContainer && NULL != pContainer->m_hWnd)
		{
			((CFrameWnd*)m_pCreateDockWnd)->ShowControlBar(pContainer, bShow, bDelay);
			pContainer->m_bShow = bShow;
 		}
	}
	m_ShowContainer = bShow;
}

BOOL CFX_DockContainer::IsShowContainer()
{
	TRACE(L"m_ShowContainer = %d\n", m_ShowContainer);
	if(!m_ShowContainer)
		return m_ShowContainer;
	else
	{
		CList<class CFX_DockContainer *, class CFX_DockContainer *> PtrlContainer;
		BOOL bSucceed = GetALLContainer(&PtrlContainer);
		POSITION pos = PtrlContainer.GetHeadPosition();
		TRACE(L"POSITION pos = %d\n", pos);
		CFX_DockContainer *pContainer;
		while(pos)
		{
			pContainer = NULL;
			pContainer = PtrlContainer.GetNext(pos);
			if(NULL != pContainer && NULL != pContainer->m_hWnd)
			{
				if(pContainer->m_bShow)
					return TRUE;
			}
		}
		return m_ShowContainer = FALSE;
	}
}

BOOL CFX_DockContainer::GetALLFloatContainer(CList<CFX_DockContainer*, CFX_DockContainer*> *pPtrlContainer, BOOL bShow)
{
	POSITION pos = ((CFrameWnd*)m_pCreateDockWnd)->m_listControlBars.GetHeadPosition();
	while (pos != NULL)
	{
		CControlBar * pDockedBar = (CControlBar*)((CFrameWnd*)m_pCreateDockWnd)->m_listControlBars.GetNext(pos);
		if(pDockedBar && !(pDockedBar->IsKindOf(RUNTIME_CLASS(CFX_DockContainer)))) continue;	
		if( pDockedBar && pDockedBar->IsFloating())
		{
			if(bShow)
			{
				if(pDockedBar->IsWindowVisible()) 
				{
					pPtrlContainer->AddTail((CFX_DockContainer*)pDockedBar);
					continue;
				}
			}
			else
			{
				pPtrlContainer->AddTail((CFX_DockContainer*)pDockedBar);
				continue;
			}
		}
	}
	
	if(pPtrlContainer->GetCount()<0)
	{
		return FALSE;
	}
	else
	{
		return TRUE;
	}
}

void CFX_DockContainer::ShowALLFloatContainer(BOOL bShow, BOOL bDelay)
{
 	CList<class CFX_DockContainer *, class CFX_DockContainer *> PtrlContainer;
	m_bShowFloat = bShow;
 	BOOL bSucceed = GetALLFloatContainer(&PtrlContainer);


	POSITION pos = PtrlContainer.GetHeadPosition();
	CFX_DockContainer *pContainer;
	while(pos)
	{
		pContainer = NULL;
		pContainer = PtrlContainer.GetNext(pos);
		if(NULL != pContainer && (FALSE != pContainer->m_bShow))
		{
			m_pDockSite->ShowControlBar(pContainer, bShow, bDelay);
		}
	}
}

void CFX_DockContainer::GetAllActivePage(CList<CFX_TabPage*, CFX_TabPage*> * pTabPagList)
{
	CList<class CFX_DockContainer *, class CFX_DockContainer *> PtrlContainer;
	BOOL bSucceed = GetALLContainer(&PtrlContainer);
	if(bSucceed)
	{
		POSITION pos = PtrlContainer.GetHeadPosition();
		CFX_DockContainer *pContainer;
		while(pos)
		{
			pContainer = NULL;
			pContainer = PtrlContainer.GetNext(pos);
			if (pContainer && NULL != pContainer->m_hWnd && pContainer->IsWindowVisible())
			{
				pTabPagList->AddTail(pContainer->GetTabPage(pContainer->GetActivePage()));
			}	
		}
	}
}

void CFX_DockContainer::DrawHideHandle(CDC* pDC, CRect rect)
{
	COLORREF colRGB = ::GetSysColor(COLOR_3DFACE);
	int colR = GetRValue(colRGB);
	int colG = GetGValue(colRGB);
	int colB = GetBValue(colRGB);
	int colUnit = 12;
				
	CBrush brush(RGB(colR+colUnit, colG+colUnit, colB+colUnit));
	pDC->FillRect(&rect, &brush);
	brush.DeleteObject();
}

void CFX_DockContainer::NcPaintGripper(CDC* pDC, CRect rcClient)
{
	if (!HasGripper())
		return;
	if(rcClient.bottom>rcClient.top && m_iTabStyle!= TAB_TOP)
		NcTitleBar(pDC, rcClient);
}
void CFX_DockContainer::DrawArrow(CDC* pDC, LPPOINT lpPoints)
{
	CRgn rgnArrow;
	CBrush brush(RGB(0, 0, 0));
	rgnArrow.CreatePolygonRgn(lpPoints, 3, ALTERNATE);
	pDC->FillRgn(&rgnArrow, &brush);
	rgnArrow.DeleteObject();
	brush.DeleteObject();
}

void  CFX_DockContainer::RecalcBarLayout(CFX_TabPage* pTabPage, int nClickTabPage)
{
	if(m_nDockBarState == AFX_IDW_DOCKBAR_BOTTOM)
	{
		if(NULL == this->m_pFristContainer)
		{
			POSITION pos = ((CFrameWnd*)m_pCreateDockWnd)->m_listControlBars.GetHeadPosition();
			while (pos != NULL)
			{
				CControlBar * pBar = (CControlBar*)((CFrameWnd*)m_pCreateDockWnd)->m_listControlBars.GetNext(pos);
				if(pBar && !(pBar->IsKindOf(RUNTIME_CLASS(CFX_DockContainer)))) continue;
				CFX_DockContainer* pDockBar = (CFX_DockContainer*)pBar;
				if( pDockBar && (pDockBar->m_nDockBarState == AFX_IDW_DOCKBAR_LEFT) )
				{	
					int nActivePage = pDockBar->GetActivePage();
					pDockBar->AddPage(this);
					pDockBar->m_nActivePage = nActivePage;
					return;
				}
			}
			m_pDockSite->DockControlBar(this, AFX_IDW_DOCKBAR_LEFT);
			this->SelectItemChange(-1);
			m_bHideHandle = FALSE;
			RecalcBarLayout();

		}
		else
		{
			POSITION pos = ((CFrameWnd*)m_pCreateDockWnd)->m_listControlBars.GetHeadPosition();
			while (pos != NULL)
			{
				CControlBar * pBar = (CControlBar*)((CFrameWnd*)m_pCreateDockWnd)->m_listControlBars.GetNext(pos);
				if(pBar && !(pBar->IsKindOf(RUNTIME_CLASS(CFX_DockContainer)))) continue;
				CFX_DockContainer* pDockBar = (CFX_DockContainer*)pBar;
				/********************************************************************///Ҫ		
				if( pDockBar && (pDockBar->m_nDockBarState == AFX_IDW_DOCKBAR_LEFT) )
					/********************************************************************/
				{	
					//	ShowBar(FALSE, FALSE);
					int nActivePage = pDockBar->GetActivePage();
					this->ShowWindow(SW_HIDE);
					this->m_pDockBar->m_pDockSite->RecalcLayout();
	
					pDockBar->AddPage(this/*, TRUE*/);
					pDockBar->m_nActivePage = nActivePage;
					return;
				}
			}
			if(AFX_IDW_DOCKBAR_BOTTOM == this->m_nDockBarState)
			{
				m_pDockSite->DockControlBar(this, AFX_IDW_DOCKBAR_LEFT);
				this->RecalcBarLayout();
				this->m_nActivePage = -1;
			}
		}		
	}
	else if (pTabPage->m_bDockBottom)
	{
		if(this->IsALLDockBottomPage())
		{
			CFX_DockContainer * pContainer = SearchDockContainer(AFX_IDW_DOCKBAR_BOTTOM);
			if(pContainer)
			{
				pContainer->AddPage(this);
			}
			else
			{
				m_pDockSite->DockControlBar(this, AFX_IDW_DOCKBAR_BOTTOM);
				this->setActivePage(0);
			}			
		}
		else
		{
			CFX_DockContainer* pBar = NULL;//new CFX_DockContainer();
			if(m_bUsePreState)
				//pBar = CreateNewContainer(pTabPage, GetContainerSize(STATE_BOTTOM), pTabPage->m_pWnd->GetDlgCtrlID());
				pBar = CreateNewContainer(pTabPage, CSize(0, 0), pTabPage->m_pWnd->GetDlgCtrlID());
			else
				pBar = CreateNewContainer(pTabPage, CSize(0, 0), pTabPage->m_pWnd->GetDlgCtrlID());
			if(NULL == pBar || NULL == pBar->m_hWnd)
			{
				TRACE0("Failed to create CFX_DockContainer\n");
				return ;  // fail to createl  
			}
			pBar->setFloatBarSize(CSize(230, 240));
			pBar->SetVertBarSize(CSize(230, 240));
			CFX_TabPage * pItem = NULL;
			POSITION pos = m_PtrlPage.GetHeadPosition();
			
			int nTabNam = 0;
			while ( pos!= NULL )
			{
				POSITION pos1 = pos;
				pItem = m_PtrlPage.GetNext(pos1);
				if(pItem && pItem->m_bDockBottom)// && pTabPage != pItem
				{
					pItem->m_pWnd->ShowWindow(SW_HIDE);
					pItem->m_bShow = FALSE;
					m_PtrlPage.RemoveAt (pos);
					pBar->AddPage(pItem);
					
					m_pDockSite->DockControlBar(pBar, AFX_IDW_DOCKBAR_BOTTOM);
					if (nTabNam<= m_nActivePage)
					{
						m_nActivePage--;
					}
				}
				pos = pos1;
				nTabNam++;
			}
			pBar->SelectItemChange(pTabPage->m_csName);
		}			
		return;
	}
}

BOOL CFX_DockContainer::IsALLDockBottomPage()
{
	POSITION pos = this->m_PtrlPage.GetHeadPosition();
	CFX_TabPage *pTabPage = NULL;
	while(pos)
	{
		pTabPage = this->m_PtrlPage.GetNext(pos);
		if(FALSE == pTabPage->m_bDockBottom)
			return FALSE;
	}
	return TRUE;
}

void  CFX_DockContainer::RecalcBarLayout()
{
	if(!m_bHideHandle && (m_nDockBarState == AFX_IDW_DOCKBAR_LEFT || m_nDockBarState == AFX_IDW_DOCKBAR_RIGHT))
	{
		m_OriginalVertSize = GetVertBarSize();
		SetVertBarSize((ITEMBUTTON_HEIGHT+8, ITEMBUTTON_HEIGHT+8));
		m_bHideHandle = TRUE;
	}
	else if (!m_bHideHandle && (m_nDockBarState == AFX_IDW_DOCKBAR_TOP || m_nDockBarState == AFX_IDW_DOCKBAR_BOTTOM))
	{
		int nActivePage = GetActivePage();
		RecalcBarLayout(GetTabPage(nActivePage), nActivePage);
	}
	else if(m_bHideHandle && (m_nDockBarState == AFX_IDW_DOCKBAR_LEFT || m_nDockBarState == AFX_IDW_DOCKBAR_RIGHT))
	{
		if(-1 == m_nActivePage )
		{
			int nIndex = 0;
			CFX_TabPage *pTabPage = NULL;
			pTabPage = GetTabPage(nIndex);
			while(pTabPage)
			{
				if(!pTabPage->m_bDockBottom)
				{
					SelectItemChange(nIndex);
					SetVertBarSize(m_OriginalVertSize);
					m_bHideHandle = FALSE;
					m_pDockSite->RecalcLayout();
					return;
				}
				pTabPage->m_bShow = FALSE;
				pTabPage = NULL;
				nIndex++;
				pTabPage = GetTabPage(nIndex);	
			}
			SelectItemChange(nIndex-1);
			m_pDockSite->DockControlBar(this, AFX_IDW_DOCKBAR_BOTTOM);
			return;
		}
		else
		{
			if(m_OriginalVertSize.cx<= ITEMBUTTON_HEIGHT+40)
				m_OriginalVertSize.cx = 230;
			SetVertBarSize(m_OriginalVertSize);
			m_bHideHandle = FALSE;
		}
		
	}
	else if(m_bHideHandle && (m_nDockBarState == AFX_IDW_DOCKBAR_TOP || m_nDockBarState == AFX_IDW_DOCKBAR_BOTTOM))
	{
		SetHorzBarSize(m_OriginalHorzSize);
		m_bHideHandle = FALSE;
	}
	if(TRUE == m_bCanfloat || AFX_IDW_DOCKBAR_LEFT == this->m_nDockBarState)
		m_pDockSite->RecalcLayout();

}

CSize  CFX_DockContainer::CalcFixedLayout(BOOL bStretch, BOOL bHorz)
{
	CSize TempSize = CFX_ControlBar::CalcFixedLayout(bStretch, bHorz);
	if (bHorz)
 	{
 		m_bHideHandle = FALSE;
		if(TempSize.cy<ITEMBUTTON_HEIGHT+40)
			return 	CSize(TempSize.cx, ITEMBUTTON_HEIGHT+60);
 	}
 	else if(!bHorz && TempSize.cx>ITEMBUTTON_HEIGHT+40)
 	{
 		m_bHideHandle = FALSE;
 	}
 	else if(!bHorz)
 	{
 		m_bHideHandle = TRUE;
		return 	CSize(ITEMBUTTON_HEIGHT+8, TempSize.cy);
 	}
	CRect rect;		 

	m_pCreateDockWnd->GetClientRect(&rect);

	if(!rect.IsRectEmpty() && (TempSize.cx > (rect.Width()-5)) && m_nDockBarState == AFX_IDW_DOCKBAR_LEFT)
	{
		return CSize((rect.Size().cx-5), rect.Size().cy);
	}
	return TempSize;
}


void CFX_DockContainer::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	CWnd::OnLButtonDblClk(nFlags, point);
}

void CFX_DockContainer::NcCalcClient(LPRECT pRc, UINT nDockBarID)
{
	CRect rcBar(pRc); // save the bar rect
	
	// subtract edges
	CFX_ControlBar::NcCalcClient(pRc, nDockBarID);
	
	if (!HasGripper())
		return;
 	
	CRect rc(pRc); // the client rect as calculated by the base class
	int ndockedge;
	ndockedge = DOCKEDGE;
	int iTtlBar = TITLEBARHIGHT;
	if(m_iTabStyle == TAB_TOP)
	{
		ndockedge = 3;
		iTtlBar = 0;
	}
 		
	if(m_nDockBarState == AFX_IDW_DOCKBAR_TOP)
	{
		rc.DeflateRect(4, iTtlBar+2, 4, ndockedge);
	}
	else if(m_nDockBarState == AFX_IDW_DOCKBAR_BOTTOM)
	{
		rc.DeflateRect(4, iTtlBar, 4, 4);
	}
	else if(m_nDockBarState == AFX_IDW_DOCKBAR_LEFT)
	{
		rc.DeflateRect(4, iTtlBar-2, 6, 4);
	}
	else if(m_nDockBarState == AFX_IDW_DOCKBAR_RIGHT)
	{
		rc.DeflateRect(ndockedge , iTtlBar, 4, 4);
	}
	*pRc = rc;
}

BOOL CFX_DockContainer::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN && (pMsg->wParam == 13 || pMsg->wParam == 27 
		|| pMsg->wParam == VK_UP
		||pMsg->wParam == VK_DOWN
		||pMsg->wParam == VK_LEFT
		||pMsg->wParam == VK_RIGHT))
		return FALSE;
	m_ToolTip.RelayEvent(pMsg); 
	return CControlBar::PreTranslateMessage(pMsg);
}

int	 CFX_DockContainer::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	m_ToolTip.Create(this);
	m_ToolTip.Activate(TRUE);
	m_pCreateDockWnd = GetParent();
	if (CFX_ControlBar::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (m_font.CreatePointFont(85, L"Tahoma"))
		SetFont(&m_font);	
	m_bActive = FALSE;	
	return 0;
}

LRESULT CFX_DockContainer::OnNcHitTest(CPoint point)
{

	CPoint pt = point;
	ScreenToClient(&pt);

	int iTtlBar = TITLEBARHIGHT;
	if(m_iTabStyle == TAB_TOP)
		 iTtlBar = 0;

	pt.y += iTtlBar;
	if(m_rtHideHdlArea.PtInRect(pt))
		return HTCLIENT;
	CRect rcBar;
	GetWindowRect(&rcBar);
	
	UINT nRet = CFX_ControlBar::OnNcHitTest(point);
	if (nRet != HTCLIENT)
		return nRet;
	
	CRect rc = m_BtnHide.GetRect();
	rc.OffsetRect(rcBar.TopLeft());

	if (rc.PtInRect(point) && this->GetDlgCtrlID() == AFX_IDW_SEARCHBAR)
		return HTCLOSE;
	else if(rc.PtInRect(point))
		return HTSTUD;

	rc = m_BtnStud.GetRect();
	rc.OffsetRect(rcBar.TopLeft());
	if (rc.PtInRect(point))
		return HTSTUD;

	return HTCLIENT;
}

void CFX_DockContainer::OnMouseMove(UINT nFlags, CPoint point)
{
	CPoint pt;
	pt.x = point.x+4;
	if(m_nDockBarState != AFX_IDW_DOCKBAR_BOTTOM)
		pt.y = point.y+26;
	else
		pt.y = point.y+32;
	
	BOOL BChangedCursor = FALSE;
	
	HCURSOR hOldCursor = GetCursor();
	
	if(m_rtHideHdlArea.PtInRect(pt))
	{
		m_hHandCursor = AfxGetApp()->LoadCursor(IDC_CUR_POINT);
		hOldCursor = ::SetCursor(m_hHandCursor);
		BChangedCursor = TRUE;
	}
	else
	{
		if(NULL != m_hHandCursor)
		{
			SetCursor(hOldCursor);
			BChangedCursor = FALSE;
			m_hHandCursor = NULL;
		}
	
	}
	CRect rctTabBar;
	GetWindowRect(&rctTabBar);
	rctTabBar.right = rctTabBar.left + ITEMBUTTON_HEIGHT;
	CFX_ControlBar::OnMouseMove(nFlags, point);
}

void CFX_DockContainer::OnNcLButtonUp(UINT nHitTest, CPoint point)
{
 	if (nHitTest == HTCLOSE)
		ShowBar(FALSE, FALSE);
	if (nHitTest == HTSTUD)
	{
 		RecalcBarLayout();
	}
}

void CFX_DockContainer::LButtonUp(UINT nFlags, CPoint point)
{
	SetCapture();
	BOOL btemp = ReleaseCapture();
	CPoint pt ;
 	pt.x = point.x+4;
 	if(m_nDockBarState != AFX_IDW_DOCKBAR_BOTTOM)
 		pt.y = point.y+26;
 	else
 		pt.y = point.y+32;
	
	if(m_rtHideHdlArea.PtInRect(pt))
	{
		RecalcBarLayout();
		return;
	}
	else 
	{
		SetFocus();
		UINT nItemIndex = 0;
		POSITION pos = NULL;
		CFX_TabPage *pItem = NULL;
		for(pos = m_PtrlPage.GetHeadPosition();pos!= NULL;nItemIndex++)
		{
			pItem = m_PtrlPage.GetNext(pos);
			if(pItem)
			{
				if(pItem->m_rect.PtInRect(point))
				{
					if(this->IsFloating())
					{	
						m_nActivePage = nItemIndex;
						SendMessage(WM_NCPAINT);
						Invalidate();
					}
					else if(m_nActivePage == (int)nItemIndex)
					{
						if (m_nDockBarState == AFX_IDW_DOCKBAR_BOTTOM || TRUE == pItem->m_bDockBottom)
						{
							RecalcBarLayout(pItem, m_nActivePage);
							return;
						}
						else
						{
							RecalcBarLayout();
							this->setActivePage(m_nActivePage);
						}	
					}
					else 
					{
						if((m_bHideHandle && AFX_IDW_DOCKBAR_BOTTOM == m_nDockBarState)||(AFX_IDW_DOCKBAR_BOTTOM != m_nDockBarState && TRUE == pItem->m_bDockBottom))
						{
							RecalcBarLayout(pItem, nItemIndex);	
						}
						else
						{
							SelectItemChange(nItemIndex);	
							if(m_bHideHandle && 0 != m_PtrlPage.GetCount())
								RecalcBarLayout();
						}
						return;
					}
				}
			}
		}
	}	
}

void CFX_DockContainer::OnLButtonDown(UINT nFlags, CPoint point)
{	
	SetFocus();
	UINT nItemIndex = 0;
	POSITION pos;
	CFX_TabPage *pItem;
	for(pos = m_PtrlPage.GetHeadPosition();pos!= NULL;nItemIndex++)
	{
		pItem = m_PtrlPage.GetNext(pos);
		if(pItem)
		{
			if(pItem->m_rect.PtInRect(point))
			{
				m_nBtnDownPage = nItemIndex;
				CanDrag(point);			// drag PageItem
				return;
			}
		}
	}	
 	((CFX_DockPageContext*)m_pDockContext)->m_bisPage = FALSE;
	CPoint pt;
	pt.x = point.x;
	pt.y = point.y+TITLEBARHIGHT;
	if (NULL != m_pDockBar && NULL != m_pDockBar->m_hWnd && m_rtTitleBar.PtInRect(pt) && m_PtrlPage.GetCount()<= 1 )/* && !m_bHideHandle*/
	{
		ASSERT(m_pDockContext != NULL);
 		ClientToScreen(&point);	
	 	CanDrag(point);	
	}
	else
	CWnd::OnLButtonDown(nFlags, point);			
}

void CFX_DockContainer::OnRButtonUp(UINT nFlags, CPoint point)
{
	CPoint pt = point;
	ClientToScreen(&pt);
	CWnd::OnRButtonDown(nFlags, point);		
}

void CFX_DockContainer::OnSize(UINT nType, int cx, int cy)
{
	UpdateSize();
	Invalidate(FALSE);
	if(AFX_IDW_DOCKBAR_BOTTOM == this->m_nDockBarState)
	{
		
	}
	else if(AFX_IDW_DOCKBAR_LEFT == this->m_nDockBarState)
	{
		
	}
	else
	{
		
	}
}

void CFX_DockContainer::OnPaint()
{
	CPaintDC	dc(this); 
	if(m_nActivePage<0 || m_nActivePage >(m_PtrlPage.GetCount()-1))
	{
		if(!(AFX_IDW_DOCKBAR_LEFT == m_nDockBarState && TRUE == m_bHideHandle))
			SelectItemChange(0);
	}
	DrawPageTab(&dc);
}

void CFX_DockContainer::DrawPageTab(CDC* pDC)
{
	CFX_TabPage	*pTabPage = NULL;
	POSITION	pos;
	int			nItemIndex = 0;
	CRect		rect;
	if(m_iTabStyle == TAB_TOP)
	{
		GetClientRect(&rect, FALSE);
		rect.bottom = rect.top + ITEMBUTTON_HEIGHT;
		m_rtTabBar = rect;
	}
	else 
	{
		GetClientRect(&rect, FALSE);
		rect.right = rect.left + ITEMBUTTON_HEIGHT;
		m_rtTabBar = rect;
	}
	CBrush brush;

	if(m_iTabStyle != TAB_TOP)
	{
 		brush.CreateSolidBrush(GetSysColor(COLOR_BTNSHADOW));
 		pDC->FillRect(rect, &brush);
		brush.DeleteObject();
	}
	else
	{
		COLORREF colRGB = ::GetSysColor(COLOR_3DHIGHLIGHT);
		int colR = GetRValue(colRGB);
		int colG = GetGValue(colRGB);
		int colB = GetBValue(colRGB);
		int colUnit = 0;
		for(int cy = rect.top; cy < rect.bottom; cy++)
		{
			colUnit+= 3;
			for(int cx = rect.left; cx<rect.right; cx++)
			{
				pDC->SetPixel(CPoint(cx, cy), RGB(colR-colUnit, colG-colUnit, colB-colUnit));
			}
		}
		CPoint ptOrgBtn;
		rect.right -= 25;
		rect.top += 6;
		ptOrgBtn = CPoint(rect.right, rect.top);
		m_BtnHide.Move(ptOrgBtn);
		m_BtnHide.Paint(pDC, m_bActive);
	}
	HFONT oldFont = (HFONT)pDC->SelectObject (m_font);
	// draw PageItem
	for(pos = m_PtrlPage.GetHeadPosition();pos!= NULL;nItemIndex++)
	{
		pTabPage = m_PtrlPage.GetNext(pos);
		if(NULL != pTabPage && pTabPage->m_bShowTab)
		{
			pTabPage->Draw(pDC, (m_nActivePage == nItemIndex)?TRUE:FALSE, m_bShowTabText);
		}
	
	}
	pDC->SelectObject (oldFont);
	brush.DeleteObject();
}

BOOL CFX_DockContainer::Create(LPCWSTR lpszWindowName, CWnd* pParentWnd, 
								 CSize sizeDefault, BOOL bHasGripper, 
								 UINT nID, BOOL bUsePreState, DWORD dwStyle)
{
	m_bUsePreState = bUsePreState;
	if(nID == AFX_IDW_BOOKMARKBAND)
	{
 		m_szVertBar = CSize(38, sizeDefault.cy);
 		m_szHorzBar = CSize(sizeDefault.cx, 240);
		m_szFloatBar = sizeDefault;
	}
	else
	{
		m_szVertBar = CSize(sizeDefault.cx, sizeDefault.cy);
		m_szHorzBar = CSize(sizeDefault.cx, sizeDefault.cy);
		m_szFloatBar = sizeDefault;
	}
	return Create(lpszWindowName, pParentWnd, nID, dwStyle);
}

BOOL CFX_DockContainer::Create(LPCWSTR lpszWindowName, CWnd* pParentWnd, 
		UINT nID, DWORD dwStyle )
{
	return CFX_ControlBar::Create(lpszWindowName, pParentWnd, nID, dwStyle);
}

void CFX_DockContainer::ChangeToolTip()
{
	if(TRUE == m_bNeedUpdate)
	{
		for (int j = 1; j <= m_nTipCount; j++)
		{
			m_ToolTip.DelTool(this, j+1);
		}
		m_nTipCount = 0;
	}
	int ItemIndex = 0;
	
	CFX_TabPage	*pTabPage = NULL;
	POSITION pos;
	for(pos = m_PtrlPage.GetHeadPosition();pos!= NULL;ItemIndex++)
	{
		pTabPage = m_PtrlPage.GetNext(pos);
		if(pTabPage)	
		{
			m_ToolTip.AddTool(this, pTabPage->m_csToolTip, &(pTabPage->m_rect), ItemIndex+1);
			m_bNeedUpdate = TRUE;
		}
		m_nTipCount = ItemIndex;
	}
}

CFX_DockContainer* CFX_DockContainer::SearchDockContainer(UINT nDockBarState)
{
	POSITION pos = ((CFrameWnd*)m_pCreateDockWnd)->m_listControlBars.GetHeadPosition();
	while (pos != NULL)
	{
		CControlBar * pDockedBar = (CControlBar*)((CFrameWnd*)m_pCreateDockWnd)->m_listControlBars.GetNext(pos);
		
		if(pDockedBar && !(pDockedBar->IsKindOf(RUNTIME_CLASS(CFX_DockContainer)))) continue;	
		
		if( pDockedBar && nDockBarState == (((CFX_DockContainer*)pDockedBar)->m_nDockBarState))
		{
			return (CFX_DockContainer*)pDockedBar;
		}
	}
	return NULL;
}

BOOL CFX_DockContainer::GetTabPageList(CList<CFX_TabPage*, CFX_TabPage*> *pPtrTabPage, BOOL bDockBottom)
{
	POSITION pos = m_PtrlPage.GetHeadPosition();
	CFX_TabPage * pTabPage;
	while (pos)
	{
		pTabPage = NULL; 
		pTabPage = (CFX_TabPage*)m_PtrlPage.GetNext(pos);
		if(pTabPage && NULL != pTabPage->m_pWnd && pTabPage->m_bDockBottom == bDockBottom)	
		{
			pPtrTabPage->AddTail((CFX_TabPage*)pTabPage);
		}
	}
	
	if(pPtrTabPage->GetCount()<= 0)
	{
		return FALSE;
	}
	else
	{
		return TRUE;
	}
}

void CFX_DockContainer::DockLeftAdjustment()
{
	CList<CFX_TabPage*, CFX_TabPage*> TabPageList ;
	this->GetTabPageList(&TabPageList, TRUE);
	if(!TabPageList.IsEmpty())
	{
		CFX_DockContainer* pBottomBar = NULL;
		pBottomBar = this->SearchDockContainer(AFX_IDW_DOCKBAR_BOTTOM);
		if(pBottomBar)
		{
			if(TabPageList.GetCount() == m_PtrlPage.GetCount())
			{
				pBottomBar->AddPage(this);
				return;
			}
			else
			{
				POSITION pos = TabPageList.GetHeadPosition();
				CFX_TabPage *pTab = NULL;
				while(pos)
				{
					pTab = TabPageList.GetNext(pos);
					if(pTab)
					{
						pBottomBar->AddPageTail(pTab);
						this->DeletePage(pTab);
					}
				}
			}
			
		}
	}
}

void CFX_DockContainer::DockBottomAdjustment()
{
	CList<CFX_TabPage*, CFX_TabPage*> TabPageList ;
	this->GetTabPageList(&TabPageList, FALSE);
	if(!TabPageList.IsEmpty())
	{
		CFX_DockContainer* pLeftBar = NULL;
		pLeftBar = this->SearchDockContainer(AFX_IDW_DOCKBAR_LEFT);
		if(pLeftBar)
		{
			POSITION pos = TabPageList.GetHeadPosition();
			CFX_TabPage *pTab = NULL;
			while(pos)
			{
				pTab = TabPageList.GetNext(pos);
				if(pTab)
				{
					pLeftBar->AddPageTail(pTab);
					this->DeletePage(pTab);
				}
			}
		}
		else
		{
			POSITION pos = TabPageList.GetHeadPosition();
			CFX_TabPage *pTab = NULL;
			while(pos)
			{
				pTab = TabPageList.GetNext(pos);
				if(pLeftBar == NULL && pTab)
				{
					pLeftBar = CreateNewContainer(pTab, this->GetFloatBarSize(), pTab->m_pWnd->GetDlgCtrlID());
				}
				if(pTab)
				{
					pLeftBar->AddPageTail(pTab);
					this->DeletePage(pTab);
				}
			}
			m_pDockSite->DockControlBar(pLeftBar, AFX_IDW_DOCKBAR_LEFT);	
		}
	}
}

LRESULT CFX_DockContainer::OnGetObject(WPARAM wParam, LPARAM lParam)
{

	HRESULT hr = 0;

	if(lParam == OBJID_CLIENT)
	{
  
	}
	return hr;
	
}
/////////////////////////////////////////////////////////////////////////////
// CFX_DockPageContext


#define _AfxGetDlgCtrlID(hWnd)   ((UINT)(WORD)::GetDlgCtrlID(hWnd))

#define CX_BORDER 1
#define CY_BORDER 1

#define CBRS_INSERT_PAGE				0x0001L	// drag to another CFX_DockContainer
#define HORZF(dw) (dw & CBRS_ORIENT_HORZ)
#define VERTF(dw) (dw & CBRS_ORIENT_VERT)

#define BORDERSIZE -2 

CFX_DockPageContext::~CFX_DockPageContext(void)
{
}

void CFX_DockPageContext::FreeAll()
{
	for(POSITION pos = m_PtrlDPBar.GetHeadPosition(); pos;)
	{
		CFX_DockContainer* pBar = NULL;
		pBar = (CFX_DockContainer*)m_PtrlDPBar.GetNext(pos);
		ASSERT(pBar != NULL);
		if(pBar->m_pDockBar)
			delete pBar->m_pDockBar; 
		pBar->m_pDockBar = NULL;
		delete pBar;
			pBar = NULL;
	}	
	m_PtrlDPBar.RemoveAll ();
}

void CFX_DockPageContext::StartDrag(CPoint pt)
{
	ASSERT_VALID(m_pBar);
	m_bDragging = TRUE;	
	InitLoop();	
	// GetWindowRect returns screen coordinates(not mirrored), 
	// so if the desktop is mirrored then turn off mirroring
	// for the desktop dc so that we get correct focus rect drawn.
	// This layout change should be remembered, just in case ...
	CRect rect;
	m_pBar->GetWindowRect(&rect);
	if (m_pDC->GetLayout() & LAYOUT_RTL)
		m_pDC->SetLayout(LAYOUT_LTR);
	
	if (m_pBar->m_dwStyle & CBRS_SIZE_DYNAMIC)
	{
		// get true bar size (including borders)
		m_ptLast = pt;
		CSize sizeHorz = m_pBar->CalcDynamicLayout(0, LM_HORZ | LM_HORZDOCK);
		CSize sizeVert = m_pBar->CalcDynamicLayout(0, LM_VERTDOCK);
		CSize sizeFloat = m_pBar->CalcDynamicLayout(0, LM_HORZ | LM_MRUWIDTH);

		// calculate frame dragging rectangle
		CRect TempRect(rect.TopLeft(), sizeFloat);
		CPoint TempPt(pt.x, pt.y+20); //the value of cmimiframe's title's height is 20
		if (TempRect.PtInRect(TempPt) && m_pBar->IsFloating())
		{
			m_rectDragHorz = CRect(rect.TopLeft(), sizeHorz);
			m_rectDragVert = CRect(rect.TopLeft(), sizeVert);
			m_rectFrameDragVert = m_rectFrameDragHorz = CRect(rect.TopLeft(), sizeFloat);
		}
		else
		{
			TempPt.x -= 30; 
			TempPt.y = pt.y;
			m_rectDragHorz = CRect(TempPt, sizeHorz);
			m_rectDragVert = CRect(TempPt, sizeVert);
			m_rectFrameDragVert = m_rectFrameDragHorz = CRect(TempPt, sizeFloat);
		}
		CMiniFrameWnd::CalcBorders(&m_rectFrameDragHorz);
		CMiniFrameWnd::CalcBorders(&m_rectFrameDragVert);
		
 		m_rectFrameDragHorz.InflateRect(BORDERSIZE, BORDERSIZE);
 		m_rectFrameDragVert.InflateRect(BORDERSIZE, BORDERSIZE);		
	}
	else if (m_pBar->m_dwStyle & CBRS_SIZE_FIXED)
	{
		// get true bar size (including borders)
		m_ptLast = pt;
		CSize sizeHorz = m_pBar->CalcDynamicLayout(-1, LM_HORZ | LM_HORZDOCK);
		CSize sizeVert = m_pBar->CalcDynamicLayout(-1, LM_VERTDOCK);
		
		// calculate frame dragging rectangle
		m_rectFrameDragHorz = m_rectDragHorz = CRect(rect.TopLeft(), sizeHorz);
		m_rectFrameDragVert = m_rectDragVert = CRect(rect.TopLeft(), sizeVert);
		
		CMiniFrameWnd::CalcBorders(&m_rectFrameDragHorz);
		CMiniFrameWnd::CalcBorders(&m_rectFrameDragVert);
 		m_rectFrameDragHorz.InflateRect(BORDERSIZE, BORDERSIZE);
 		m_rectFrameDragVert.InflateRect(BORDERSIZE, BORDERSIZE);
	}
	else
	{
		// get true bar size (including borders)
		m_ptLast = pt;
		BOOL bHorz = HORZF(m_dwStyle);
		DWORD dwMode = !bHorz ? (LM_HORZ | LM_HORZDOCK) : LM_VERTDOCK;
		CSize size = m_pBar->CalcDynamicLayout(-1, dwMode);
		
		// calculate inverted dragging rect
		if (bHorz)
		{
			m_rectDragHorz = rect;
			m_rectDragVert = CRect(CPoint(pt.x - rect.Height()/2, rect.top), size);
		}
		else // vertical orientation
		{
			m_rectDragVert = rect;
			m_rectDragHorz = CRect(CPoint(rect.left, pt.y - rect.Width()/2), size);
		}
		
		// calculate frame dragging rectangle
		m_rectFrameDragHorz = m_rectDragHorz;
		m_rectFrameDragVert = m_rectDragVert;
		
		CMiniFrameWnd::CalcBorders(&m_rectFrameDragHorz);
		CMiniFrameWnd::CalcBorders(&m_rectFrameDragVert);
 		m_rectFrameDragHorz.InflateRect(BORDERSIZE, BORDERSIZE);
 		m_rectFrameDragVert.InflateRect(BORDERSIZE, BORDERSIZE);
	}
	// initialize tracking state and enter tracking loop
	m_dwOverDockStyle = CanDock(pt);

	Move(pt); // call it here to handle special keys
	Track();
}

BOOL CFX_DockPageContext::Track()
{
	// don't handle if capture already set
	if (::GetCapture() != NULL)
		return FALSE;
	
	// set capture to the window which received this message
	m_pBar->SetCapture();
	ASSERT(m_pBar == CWnd::GetCapture());
	
	// get messages until capture lost or cancelled/accepted
	while (CWnd::GetCapture() == m_pBar)
	{
		MSG msg;
		if (!::GetMessage(&msg, NULL, 0, 0))
		{
			AfxPostQuitMessage(msg.wParam);
			break;
		}
		
		switch (msg.message)
		{
		case WM_LBUTTONUP:
			if (m_bDragging)
				EndDrag(msg.pt);
			else
				EndResize();
			return TRUE;
		case WM_MOUSEMOVE:
			if (m_bDragging)
				Move(msg.pt);
			else
				Stretch(msg.pt);
			break;
		case WM_KEYUP:
			if (m_bDragging)
				OnKey((int)msg.wParam, FALSE);
			break;
		case WM_KEYDOWN:
			if (m_bDragging)
				OnKey((int)msg.wParam, TRUE);
			if (msg.wParam == VK_ESCAPE)
			{
				CancelLoop();
				return FALSE;
			}
			break;
		case WM_RBUTTONDOWN:
			CancelLoop();
			return FALSE;
			
			// just dispatch rest of the messages
		default:
			DispatchMessage(&msg);
			break;
		}
	}
	CancelLoop();
	return FALSE;
}

void CFX_DockPageContext::Move(CPoint pt)
{
	CPoint ptOffset = pt - m_ptLast;
	
	if(TRUE == isDockPage(pt))
	{
		m_dwOverDockStyle = CBRS_INSERT_PAGE;
	}
	else
	{
		// offset all drag rects to new position
		m_rectDragHorz.OffsetRect(ptOffset);
		m_rectFrameDragHorz.OffsetRect(ptOffset);
		m_rectDragVert.OffsetRect(ptOffset);
		m_rectFrameDragVert.OffsetRect(ptOffset);
		// if control key is down don't dock
		if(m_pCreateDockWnd != m_pDockSite)
		{
			m_dwOverDockStyle = 0;
		}
		else
		{
			m_dwOverDockStyle = m_bForceFrame ? 0 : CanDock(pt);
		}		
	}
	m_ptLast = pt;
	// update feedback
	DrawFocusRect();
}

void CFX_DockPageContext::EndDrag( CPoint pt)
{
	CancelLoop();	
	if((NULL != m_pTgDockPage) && (m_dwOverDockStyle == CBRS_INSERT_PAGE))
	{
		if(TRUE == m_bisPage)	// drag PageItem
		{
			CFX_TabPage * pTabPage = NULL;
			pTabPage = (CFX_TabPage *)((CFX_DockContainer*)m_pBar)->DeletePage(((CFX_DockContainer*)m_pBar)->m_nBtnDownPage);
			((CFX_DockContainer*)m_pBar)->m_nBtnDownPage = -1;

			if(!m_pTgDockPage->AddPage(pTabPage))
			{
				pTabPage = NULL;
				pTabPage = ((CFX_DockContainer*)m_pBar)->GetTabPage(0);
				if(NULL != pTabPage)
					m_pTgDockPage->AddPage((CFX_DockContainer*)m_pBar);
				else
					m_pTgDockPage->AddPage((CFX_DockContainer*)m_pBar);	
			}
			else
			{
				m_pTgDockPage->SelectItemChange(pTabPage->m_csName);
			}			
		}
		else					
		{
			m_pTgDockPage->AddPage((CFX_DockContainer*)m_pBar);
		}
		return;
	}
		// if drag a PageItem, create a new bar which contains the PageItem
	CControlBar* pBar = NULL;
	if(TRUE == m_bisPage)// drag PageItem (dock or float)
		pBar = CreateNewBar();

	if(NULL == pBar && NULL == m_pBar)
		return;
	else if(NULL == pBar)
	{
		pBar = m_pBar;
		//SelectItemChange(0)
	}
	if(NULL == pBar) return;

	POSITION pos = ((CFrameWnd*)m_pCreateDockWnd)->m_listControlBars.GetHeadPosition();
	while (pos != NULL)
	{
		CControlBar * pDockedBar = (CControlBar*)((CFrameWnd*)m_pCreateDockWnd)->m_listControlBars.GetNext(pos);
			
		if(pDockedBar && !(pDockedBar->IsKindOf(RUNTIME_CLASS(CFX_DockContainer)))) continue;	
				
		if( pDockedBar && 
			(((m_dwOverDockStyle & CBRS_ALIGN_LEFT) 
				&& ((CFX_DockContainer*)pDockedBar)->GetDockBarState() == AFX_IDW_DOCKBAR_LEFT)
			||((m_dwOverDockStyle & CBRS_ALIGN_BOTTOM) 
				&& ((CFX_DockContainer*)pDockedBar)->GetDockBarState() == AFX_IDW_DOCKBAR_BOTTOM)
			))
		{
			m_dwOverDockStyle = 0;
		}
 	}

	if (m_dwOverDockStyle != 0)
	{
		CDockBar* pDockBar = GetDockBar(m_dwOverDockStyle, pt);
		if(pDockBar == NULL) return;
		CRect rect;
		if(m_dwOverDockStyle & CBRS_ORIENT_VERT) 
		{
			rect = m_rectDragVert;
			rect.top = 0;
		}
		else
		{
			rect = m_rectDragHorz;
			rect.left = 0;
		}
				
		UINT uID = _AfxGetDlgCtrlID(pDockBar->m_hWnd);
		if (uID >= AFX_IDW_DOCKBAR_TOP && 
			uID <= AFX_IDW_DOCKBAR_BOTTOM)
		{
			m_uMRUDockID = uID;
			m_rectMRUDockPos = rect;
			pDockBar->ScreenToClient(&m_rectMRUDockPos);
		}		
		// dock it at the specified position, RecalcLayout will snap
		m_pDockSite->DockControlBar(pBar, pDockBar, &rect);
		if(AFX_IDW_DOCKBAR_LEFT == ((CFX_DockContainer*)pBar)->GetDockBarState())
		{
			((CFX_DockContainer*)pBar)->DockLeftAdjustment();					
			return;
		}
		m_pDockSite->RecalcLayout();
	}
	else if ((m_dwStyle & CBRS_SIZE_DYNAMIC) || (HORZF(m_dwStyle) && !m_bFlip) ||
		(VERTF(m_dwStyle) && m_bFlip))
	{
		m_dwMRUFloatStyle = CBRS_ALIGN_TOP | (m_dwDockStyle & CBRS_FLOAT_MULTI);
		m_ptMRUFloatPos = m_rectFrameDragHorz.TopLeft();
		if(m_ptMRUFloatPos.y<0)
		{
			m_ptMRUFloatPos.y = 100;
		}
		if (m_pDockSite->IsKindOf(RUNTIME_CLASS(CMainFrame)))
		{
			((CMainFrame*)m_pDockSite)->FloatControlBar(pBar, m_ptMRUFloatPos, m_dwMRUFloatStyle);
		}
		else
		{
			m_pDockSite->FloatControlBar(pBar, m_ptMRUFloatPos, m_dwMRUFloatStyle);
			
		}
		if(((CFX_DockContainer*)pBar)->GetActivePage() == -1)
		{
			((CFX_DockContainer*)pBar)->SelectItemChange(0);
		}	
	}
	else // vertical float
	{
		m_dwMRUFloatStyle = CBRS_ALIGN_LEFT | (m_dwDockStyle & CBRS_FLOAT_MULTI);
		m_ptMRUFloatPos = m_rectFrameDragVert.TopLeft();
		if(m_ptMRUFloatPos.y<0)
		{
			m_ptMRUFloatPos.y = 100;
		}
		if (m_pDockSite->IsKindOf(RUNTIME_CLASS(CMainFrame)))
		{
			((CMainFrame*)m_pDockSite)->FloatControlBar(pBar, m_ptMRUFloatPos, m_dwMRUFloatStyle);
		}
		else
		{
			m_pDockSite->FloatControlBar(pBar, m_ptMRUFloatPos, m_dwMRUFloatStyle);	
		}
		if(((CFX_DockContainer*)pBar)->GetActivePage() == -1)
		{
			((CFX_DockContainer*)pBar)->SelectItemChange(0);
		}
	}
	DWORD dw = pBar->GetBarStyle();		
}

CDockBar* CFX_DockPageContext::GetDockBar(DWORD dwOverDockStyle, CPoint pt)
{
	DWORD dw = 0;
	CDockBar* pBar;
	if (HORZF(dwOverDockStyle))
	{
		dw = CanDock(m_rectDragHorz, dwOverDockStyle & ~CBRS_ORIENT_VERT, pt, &pBar);
		if(dw == 0 || pBar == NULL ) return NULL;

		return pBar;
	}
	if (VERTF(dwOverDockStyle))
	{
		dw = CanDock(m_rectDragVert, dwOverDockStyle & ~CBRS_ORIENT_HORZ, pt, &pBar);
		if(dw == 0 || pBar == NULL ) return NULL;
		return pBar;
	}
	return NULL;
}


DWORD CFX_DockPageContext::CanDock(CPoint pt)
{
	BOOL bStyleHorz;
	DWORD dwDock = 0; // Dock Canidate
	DWORD dwCurr = 0; // Current Orientation
	
	// let's check for something in our current orientation first
	// then if the shift key is not forcing our orientation then
	// check for horizontal or vertical orientations as long
	// as we are close enough
	ASSERT(m_dwStyle != 0);
	
	bStyleHorz = HORZF(m_dwStyle);
	bStyleHorz = m_bFlip ? !bStyleHorz : bStyleHorz;
	
	if (bStyleHorz && HORZF(m_dwDockStyle))
		dwDock = CanDock(m_rectDragHorz, m_dwDockStyle & ~CBRS_ORIENT_VERT, pt);
	else if (VERTF(m_dwDockStyle))
		dwDock = CanDock(m_rectDragVert, m_dwDockStyle & ~CBRS_ORIENT_HORZ, pt);
	
	if (!m_bFlip)
	{
		if (dwDock == 0 && HORZF(m_dwDockStyle))
		{
			dwCurr = CanDock(m_rectDragVert, m_dwDockStyle & ~CBRS_ORIENT_VERT, pt);
			dwDock = CanDock(m_rectDragHorz, m_dwDockStyle & ~CBRS_ORIENT_VERT, pt);
			dwDock = (dwDock == dwCurr) ? dwDock : 0;
		}
		if (dwDock == 0 && VERTF(m_dwDockStyle))
		{
			dwCurr = CanDock(m_rectDragHorz, m_dwDockStyle & ~CBRS_ORIENT_HORZ, pt);
			dwDock = CanDock(m_rectDragVert, m_dwDockStyle & ~CBRS_ORIENT_HORZ, pt);
			dwDock = (dwDock == dwCurr) ? dwDock : 0;
		}
	}
	return dwDock;
}


DWORD  CFX_DockPageContext::CanDock(CRect rect, DWORD dwDockStyle, CPoint pt, CDockBar** ppDockBar)
{
	// dwDockStyle -- allowable styles of bar
	// don't allow to dock to floating unless multi is specified
	dwDockStyle &= CBRS_ALIGN_ANY|CBRS_FLOAT_MULTI;
	
	if (ppDockBar != NULL)
		*ppDockBar = NULL;
	POSITION pos = m_pDockSite->m_listControlBars.GetHeadPosition();
	while (pos != NULL)
	{
		CDockBar* pDockBar = (CDockBar*)(m_pDockSite->m_listControlBars.GetNext(pos));
		if (pDockBar->IsDockBar() && pDockBar->IsWindowVisible() && 
			(pDockBar->m_dwStyle & dwDockStyle & CBRS_ALIGN_ANY) && 
			(!pDockBar->m_bFloating ||
			(dwDockStyle & pDockBar->m_dwStyle & CBRS_FLOAT_MULTI)))
		{
			CRect rectWnd, recttemp;

 			m_pCreateDockWnd->GetWindowRect(&rectWnd);
			if(pDockBar->m_dwStyle & CBRS_ALIGN_LEFT)
			{
				rectWnd.right = rectWnd.left + DOCKRECTWIDTN;
			}
			else if(pDockBar->m_dwStyle & CBRS_ALIGN_BOTTOM)
			{
				rectWnd.top = rectWnd.bottom - DOCKRECTWIDTN;
			}
			else if(pDockBar->m_dwStyle & CBRS_ALIGN_TOP)
			{
				rectWnd.bottom = rectWnd.top + DOCKRECTWIDTN;
			}
			else if(pDockBar->m_dwStyle & CBRS_ALIGN_RIGHT)
			{
				rectWnd.left = rectWnd.right - DOCKRECTWIDTN;
			}
			
			if (recttemp.IntersectRect(rectWnd, rect) && rectWnd.PtInRect(pt))
			{
				if (ppDockBar != NULL)
					*ppDockBar = pDockBar;
				return pDockBar->m_dwStyle & dwDockStyle;
			}
		}
	}
	return 0;
}


void CFX_DockPageContext::DrawFocusRect()
{
	ASSERT(m_pDC != NULL);
	
	// default to thin frame
	CSize size(CX_BORDER, CY_BORDER);
	
	// determine new rect and size
	CRect rect;
	CBrush* pWhiteBrush = CBrush::FromHandle((HBRUSH)::GetStockObject(WHITE_BRUSH));
	CBrush* pDitherBrush = CDC::GetHalftoneBrush();
	CBrush* pBrush = pWhiteBrush;
	
	size.cx = GetSystemMetrics(SM_CXFRAME) - CX_BORDER;
	size.cy = GetSystemMetrics(SM_CYFRAME) - CY_BORDER;

	if(CBRS_INSERT_PAGE == m_dwOverDockStyle)
	{
		rect = m_addRect;
	}	
	else 
	{	
		DrawDockEdgeRect();
		if (HORZF(m_dwOverDockStyle) || VERTF(m_dwOverDockStyle))
		{
			POSITION pos = ((CFrameWnd*)m_pCreateDockWnd)->m_listControlBars.GetHeadPosition();
			while (pos != NULL)
			{
				CControlBar * pBar = (CControlBar*)((CFrameWnd*)m_pCreateDockWnd)->m_listControlBars.GetNext(pos);
				
				if(pBar && !(pBar->IsKindOf(RUNTIME_CLASS(CFX_DockContainer)))) continue;	

				if( pBar && 
					(((m_dwOverDockStyle & CBRS_ALIGN_LEFT) && 
					((CFX_DockContainer*)pBar)->GetDockBarState() == AFX_IDW_DOCKBAR_LEFT)
					||((m_dwOverDockStyle & CBRS_ALIGN_BOTTOM) && 
					((CFX_DockContainer*)pBar)->GetDockBarState() == AFX_IDW_DOCKBAR_BOTTOM)
					))
				{
					rect.SetRectEmpty();
					break;
				}
				else
				{
					rect = m_DockEdgeRect;
				}
 			}	
		}
		else
		{
			// use thick frame instead
			if ((HORZF(m_dwStyle) && !m_bFlip) || (VERTF(m_dwStyle) && m_bFlip))
				rect = m_rectFrameDragHorz;
			else
				rect = m_rectFrameDragVert;
		}
	}
	pBrush = pDitherBrush;
	// draw it and remember last size
	if(rect.IsRectEmpty())
	{
		return;
	}
	m_pDC->DrawDragRect(&rect, size, &m_rectLast, m_sizeLast, pBrush, 
		m_bDitherLast ? pDitherBrush : pWhiteBrush);
		m_rectLast = rect;
	m_sizeLast = size;
	m_bDitherLast = (pBrush == pDitherBrush);
}

void CFX_DockPageContext::DrawDockEdgeRect()
{
	if(!m_DockEdgeRect.IsRectEmpty())
	{
		m_DockEdgeRect.SetRectEmpty();
	}
	m_pCreateDockWnd->GetWindowRect(&m_DockEdgeRect);
	m_DockEdgeRect.left = m_DockEdgeRect.left + 5;
	m_DockEdgeRect.bottom = m_DockEdgeRect.bottom - 5;
	m_DockEdgeRect.right = m_DockEdgeRect.right - 5;
	m_DockEdgeRect.top = m_DockEdgeRect.top + 30;

	if (m_dwOverDockStyle & CBRS_ALIGN_LEFT)//HORZF(m_dwOverDockStyle))
	{
		m_DockEdgeRect.right = m_DockEdgeRect.left + DOCKRECTWIDTN	;
	}
	else if (m_dwOverDockStyle & CBRS_ALIGN_BOTTOM)
	{
		m_DockEdgeRect.top = m_DockEdgeRect.bottom - DOCKRECTWIDTN;
	}
	else if (m_dwOverDockStyle & CBRS_ALIGN_RIGHT)
	{
		m_DockEdgeRect.left = m_DockEdgeRect.right - DOCKRECTWIDTN;
	}
	else if (m_dwOverDockStyle & CBRS_ALIGN_TOP)
	{
		m_DockEdgeRect.bottom = m_DockEdgeRect.top + DOCKRECTWIDTN;	
	}
	else
	{
		m_DockEdgeRect.SetRectEmpty();
	}
}

CFX_DockContainer* CFX_DockPageContext::CreateNewBar()
{
	CFX_TabPage * pTabPage = NULL; 
	pTabPage = (CFX_TabPage *)((CFX_DockContainer*)m_pBar)->DeletePage(((CFX_DockContainer*)m_pBar)->m_nBtnDownPage);
	if(NULL == pTabPage) return NULL;
	if(pTabPage->m_pWnd->GetDlgCtrlID() == m_pBar->GetDlgCtrlID())
	{
		CFX_TabPage * pActiveTabPage = ((CFX_DockContainer*)m_pBar)->GetTabPage(((CFX_DockContainer*)m_pBar)->GetActivePage());
		if(pActiveTabPage)
			m_pBar->SetDlgCtrlID(pActiveTabPage->m_pWnd->GetDlgCtrlID());
	}
	((CFX_DockContainer*)m_pBar)->m_nBtnDownPage = -1;
	CFX_DockContainer* pBar = new CFX_DockContainer();

	pBar->m_iTabStyle = 	pTabPage->m_iTabStyle = ((CFX_DockContainer*)m_pBar)->m_iTabStyle;

	pBar->ShowTabText(((CFX_DockContainer*)m_pBar)->IsShowTabText());
	pBar->ShowTitleText(((CFX_DockContainer*)m_pBar)->IsShowTitleText());
	
	DWORD dwStyle = WS_VISIBLE |WS_CHILD | CBRS_TOP | WS_CLIPCHILDREN;
	if (!(pBar->Create(pTabPage->m_csText, m_pDockSite, CSize(230, 240), TRUE, pTabPage->m_pWnd->GetDlgCtrlID(), 
		((CFX_DockContainer*)m_pBar)->m_bUsePreState, dwStyle)))
	{
		TRACE0("Failed to create CFX_DockContainer\n");
		return NULL;  // fail to createl  
	}
	if(((CFX_DockContainer*)m_pBar)->GetFristContainer() == NULL)
		pBar->SetFristContainer((CFX_DockContainer*)m_pBar);
	else
		pBar->SetFristContainer(((CFX_DockContainer*)m_pBar)->GetFristContainer());
	pBar->SetBarStyle(m_pBar->GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	pBar->EnableDocking(m_pBar->m_dwDockStyle);
	pBar->AddPage(pTabPage);
	pBar->SelectItemChange(pTabPage->m_csName);
	m_PtrlDPBar.AddTail(pBar);
	return pBar;
}

BOOL CFX_DockPageContext::isDockPage(CPoint pt)
{	
	HWND hWnd = WindowFromPoint(pt);
	CWnd* pWnd = CWnd::FromHandle (hWnd);
	CWnd* pWndParent = NULL;
	if(::IsWindow(hWnd) && pWnd->GetParent())
	{
		pWndParent = pWnd->GetParent();
	}
	CFX_DockContainer* pBar = NULL;
	
	if(pWnd && pWnd->IsKindOf (RUNTIME_CLASS(CFX_DockContainer)))
	{
		pBar = (CFX_DockContainer*)pWnd;
	}
	else if(pWndParent && pWndParent->IsKindOf(RUNTIME_CLASS(CFX_DockContainer)))
	{
		pBar = (CFX_DockContainer*)pWndParent;
	}

	if(pBar && pBar != m_pBar)
	{
		CRect rectBar;
		pBar->GetWindowRect (&rectBar);

		if(pBar->m_iTabStyle == TAB_TOP)
		{
			rectBar.bottom = rectBar.top + ITEMBUTTON_HEIGHT;
		}
		else if(pBar->m_iTabStyle == TAB_LEFT)
		{
			rectBar.right = rectBar.left + ITEMBUTTON_HEIGHT;
		}
		
		if( rectBar.PtInRect(pt) && pBar->m_pCreateDockWnd == m_pCreateDockWnd )
		{
			m_pTgDockPage = pBar;
			pBar->GetWindowRect(&m_addRect);
			return TRUE;
		}
	}
	m_pTgDockPage = NULL;
	return FALSE;
}

/////////////////////////////////////////////////////////////////////////
//CFX_MiniDockFrameWnd CMiniDockFrameWnd
// 
IMPLEMENT_DYNCREATE(CFX_MiniDockFrameWnd, CMiniDockFrameWnd);

BEGIN_MESSAGE_MAP(CFX_MiniDockFrameWnd, CMiniDockFrameWnd)
//{{AFX_MSG_MAP(CFX_MiniDockFrameWnd)
ON_WM_CLOSE()
ON_WM_NCLBUTTONDBLCLK()
ON_WM_MOVE()
ON_WM_LBUTTONDOWN()
ON_WM_NCLBUTTONDOWN()
//ON_WM_WINDOWPOSCHANGING()
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void		CFX_MiniDockFrameWnd::OnLButtonDown(UINT nFlags, CPoint point)
{

}

void		CFX_MiniDockFrameWnd::OnClose()
{
	for (int nPos = 0; nPos < m_wndDockBar.m_arrBars.GetSize(); nPos++)
	{
		CFX_DockContainer* pBar = (CFX_DockContainer*)m_wndDockBar.m_arrBars.GetAt(nPos);
		if (pBar != NULL)
		{	
			CFrameWnd* pFrameWnd = pBar->GetDockingFrame();
			pFrameWnd->ShowControlBar(pBar, FALSE, TRUE);
			pBar->m_bShow = FALSE;

			CView* pView = NULL;
			CFrameWnd* pMainFrm = (CFrameWnd*)AfxGetMainWnd();
			if(pMainFrm != NULL)
			{			
				CFrameWnd* pChildFrm = pMainFrm->GetActiveFrame();
				if(pChildFrm)
				{
					pView = (CView*)pChildFrm->GetWindow(GW_CHILD);
				}				
			}
			if(pView != NULL)
			{
				CFrameWnd* pFrame = pView->GetParentFrame();
				pFrame->SetActiveView(pView);		
			}
		}
	}
}


BOOL CFX_MiniDockFrameWnd::PreTranslateMessage(MSG *pMsg)
{
	if (pMsg->message == WM_KEYDOWN && (pMsg->wParam == 13 || pMsg->wParam == 27))
	{
		for (int nPos = 0; nPos < m_wndDockBar.m_arrBars.GetSize(); nPos++)
		{
			CFX_DockContainer* pBar = (CFX_DockContainer*)m_wndDockBar.m_arrBars.GetAt(nPos);
			if (pBar != NULL)
			{
				CFX_TabPage* pTabPage = NULL;
				pTabPage = pBar->GetTabPage(pBar->GetActivePage());
				if(pTabPage && pTabPage->m_pWnd)
				{
					return pTabPage->m_pWnd->PreTranslateMessage(pMsg);
				}
			}
		}	
	}
	return CMiniDockFrameWnd::PreTranslateMessage(pMsg);
}

void CFX_MiniDockFrameWnd::OnNcLButtonDown(UINT nHitTest, CPoint point)
{
	SetFocus();
	CMiniDockFrameWnd::OnNcLButtonDown(nHitTest, point);
}

void CFX_MiniDockFrameWnd::OnNcLButtonDblClk(UINT nHitTest, CPoint point)
{
	ActivateTopParent();
	
	// initiate toolbar toggle for non-CBRS_FLOAT_MULTI toolbars
	if ((m_wndDockBar.m_dwStyle & CBRS_FLOAT_MULTI) == 0)
	{
		CControlBar* pDockedBar = NULL;
		CFX_DockContainer* pDockedLeftBar = NULL;
		CFX_DockContainer* pDockedBottomBar = NULL;
		POSITION pos = m_wndDockBar.m_pDockSite->m_listControlBars.GetHeadPosition();
		while(pos)
		{
			pDockedBar = (CControlBar*)m_wndDockBar.m_pDockSite->m_listControlBars.GetNext(pos);
			if(pDockedBar && (pDockedBar->IsKindOf(RUNTIME_CLASS(CFX_DockContainer))))
			{
				if(((CFX_DockContainer*)pDockedBar)->GetDockBarState() == AFX_IDW_DOCKBAR_LEFT)
				{
					pDockedLeftBar = (CFX_DockContainer*)pDockedBar;
					break;
				}
				else if(((CFX_DockContainer*)pDockedBar)->GetDockBarState() == AFX_IDW_DOCKBAR_BOTTOM)
				{
					pDockedBottomBar = (CFX_DockContainer*)pDockedBar;
				}
			}

		}
		int nPos = 1;
		CFX_DockContainer* pBar = NULL;
		while(pBar == NULL && nPos < m_wndDockBar.m_arrBars.GetSize())
		{
			pBar = (CFX_DockContainer*)m_wndDockBar.m_arrBars[nPos];
			if (HIWORD(pBar) == 0)
			{
				continue;
				nPos++;
			}
			else
				break;
		}
		ASSERT(pBar != NULL);
		ASSERT_KINDOF(CFX_DockContainer, pBar);
		if(NULL != pDockedLeftBar)
		{
			pDockedLeftBar->AddPage(pBar);
		}
		else if(NULL != pDockedBottomBar)
		{
			POSITION pos, posPrev;
			CFX_TabPage *pTabPage = NULL;
			for(pos = pBar->m_PtrlPage.GetHeadPosition();pos!= NULL;)
			{
				posPrev = pos;
				pTabPage = pBar->m_PtrlPage.GetNext(pos);
				if(pTabPage )
				{
					if(pTabPage->m_bDockBottom)
					{
						pTabPage->m_pWnd->SetParent (pDockedBottomBar);
						if(GetStyle() & WS_VISIBLE)
							pTabPage->m_bShow = TRUE;
						else
							pTabPage->m_bShow = FALSE;
						pDockedBottomBar->m_PtrlPage.AddTail(pTabPage);
						pBar->m_PtrlPage.RemoveAt(posPrev);
						pDockedBottomBar->UpdateWindow();
					}
					else
						continue;
				}
				else
				{
					break;
				}
			}
			if(0 == pBar->m_PtrlPage.GetCount())
			{
				pBar->DestroyWindow();
			}
			else
			{
				m_wndDockBar.m_pDockSite->DockControlBar(pBar, AFX_IDW_DOCKBAR_LEFT);
			}
		}
		else
		{
			m_wndDockBar.m_pDockSite->DockControlBar(pBar, AFX_IDW_DOCKBAR_LEFT);
		}	
	}
}

void CFX_MiniDockFrameWnd::OnMove( int x, int y )
{
	CRect rtClient;
 	::SystemParametersInfo(SPI_GETWORKAREA, 0, &rtClient, 0);
	int	nScreenY = rtClient.bottom;
	if(y > nScreenY) 
	{
		y = nScreenY - 30;	 
		CRect rect;
		GetWindowRect(&rect);
	 	this->MoveWindow(x, y, rect.Width(), rect.Height(), TRUE);
	}
	CMiniDockFrameWnd::OnMove(x, y);
}

BOOL CFX_DockContainer::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Add your message handler code here and/or call default
	return TRUE;
}

int CFX_DockContainer::GetDockBottomCount()
{
	CFX_TabPage	*pTabPage;
	int nCount = 0;
	POSITION	 pos;
	POSITION	 posPrev;
	int i = 0;
	for(pos = m_PtrlPage.GetHeadPosition();pos!= NULL;)
	{
		i++;
		pTabPage = NULL;
		posPrev = pos;
		pTabPage = m_PtrlPage.GetNext(pos);
		if(pTabPage && pTabPage->m_bDockBottom)
		{
			if(!(m_nActivePage<i-1) && (AFX_IDW_DOCKBAR_LEFT == this->m_nDockBarState))
			{
				m_nActivePage--;
			}
			m_PtrlPage.RemoveAt(posPrev);
			m_PtrlPage.AddTail(pTabPage);

			nCount++;
		}
		if(i == m_PtrlPage.GetCount()) break;
	}
	return nCount;
}