// FX_DockContainer.h: interface for the CFX_DockContainer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FX_DOCKCONTAINER_H__INCLUDED_)
#define AFX_FX_DOCKCONTAINER_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif 

#include "FX_ControlBar.h"

#define  AFX_IDW_BOOKMARKBAND           AFX_IDW_CONTROLBAR_LAST-22
#define  AFX_IDW_SEARCHBAR              AFX_IDW_CONTROLBAR_LAST-21

//#define WM_DOCKHIDE_ON		WM_USER+100
#define HTCONTAINER			-3
#define HTTITLE				-2
#define HTTABBAR			-1
#define HTSTUD				-4
#define HTHIDE				-5


///////////////////////////////////////////////////////////////////////////
//  title bar button

class CMainFrame;

#define	 CONTAINER_REGISTRY_PANELS_KEY	L"Panels_2"
#define	 CONTAINER_REGISTRY_PANELS_SIZE	L"Panels_2\\Size"
#define	 CONTAINER_REGISTRY_PANELS_LEFT_SIZE	L"Panels_2\\Left Size"
#define	 CONTAINER_REGISTRY_PANELS_BOOTOM_SIZE	L"Panels_2\\Bottom Size"


#define	 PANEL_RECT_TOP		L"Top"
#define	 PANEL_RECT_LEFT	L"Left"
#define	 PANEL_RECT_WIDTH	L"Width"
#define	 PANEL_RECT_HEIGHT	L"Height"

#define	 PAGEINFO_ID		L"ID"
#define	 PAGEINFO_NAME		L"Name"
#define	 PAGEINFO_PARENTID  L"ParentID"
#define	 PAGEINFO_ACTIVE	L"Active"
#define	 PAGEINFO_BARSTATE  L"BarState"
#define	 PAGEINFO_RECT		L"Rect"
#define	 PAGEINFO_POS		L"Position"
//#define	 PAGEINFO_ONLYTABBAR		_T("OnlyTabBar")
#define	 PAGEINFO_HIDE		L"Hide"


#define	 STATE_LEFT			0
#define	 STATE_BOTTOM		1
#define	 STATE_FLOATING		2

typedef struct _PanelPageInfo	{   
	UINT				dbID;
	CString				csName;			 //[age Name]
	UINT				dbParentID;		 //[id of creating container]
	CRect				rtRect;          
	BOOL				bActive;            //[is activated]
	UINT 				nState;
	int					nPos;				//[position in container]
	BOOL				bHide;
}PAGEINFO;

typedef CTypedPtrArray<CPtrArray, PAGEINFO*> HISTORY_PanelInfoArray;

//CReader_RegistryManager g_RegistryManager;

class CFX_TitleBarBtn
{
public:
	CFX_TitleBarBtn();
	
	void Move(CPoint ptTo) {m_ptOrg = ptTo;}
    virtual CRect GetRect() { return CRect(m_ptOrg, CSize(14, 14)); };
    virtual void Paint(CDC* pDC, BOOL bActive);
    BOOL    m_bPushed;
    BOOL    m_bRaised;

protected:
	CPoint  m_ptOrg;
	
};
//close button
class CFX_CloseBtn : public CFX_TitleBarBtn
{
public:
	virtual void Paint(CDC* pDC, BOOL bActive);
};
//hide button
class CFX_StudBtn : public CFX_TitleBarBtn
{
public:
  	CFX_StudBtn();
//  	BOOL m_bStretch  ;
  	virtual void Paint(CDC* pDC, BOOL bActive);	
};

///////////////////////////////////////////////////////////////////////////
//label page

#define ICONWIDTH 32


class IReader_PanelView;
class CFX_TabPage
{
public:
	IReader_PanelView*	m_pPanelView;
	CWnd				*m_pWnd;		
	CString				m_csText;//the word show on tab
	CString				m_csName;//the unique sign the name of tab
	CString				m_csToolTip;//the unique sign the name of tab
	BOOL				m_bShow;
	UINT				m_nTabWidth;//all of the current tab width
	CRect				m_rect;
	int					m_iTabStyle;
	BOOL				m_bDockBottom;
	HBITMAP				m_hBitmap;
	UINT				m_IconWidth;
	INT					m_nLanguage;
	BOOL				m_bShowTab;
	
	CFX_TabPage(int iTabStyle);
	~CFX_TabPage();
public:
	
	void Draw(CDC *pDC,BOOL bActive,BOOL bShowText);
	void DrawTabRect(CDC *pDC, CRect rect, BOOL bActive, int iTabStyle ); //draw the shape of the tags
	void DrawTabText(CDC *pDC, CString csText, CRect rect, BOOL bActive, int iTabStyle);
	void Delete();
	int	 GetTabWidth(BOOL bShowTabText);
};
 /////////////////////////////////////////////////////////////////////////////
// CFX_DockContainer control bar

#define  DOCKRECTWIDTN 60
#define  TAB_NULL 0
#define  TAB_LEFT 1
#define  TAB_TOP  2
#define	 DOCKEDGE 9	
#define	 ITEMBUTTON_HEIGHT	30
#define  TITLEBARHIGHT 25
#define  COLORTOP 255

class CFX_DockContainer : public CFX_ControlBar  
{
	DECLARE_DYNAMIC(CFX_DockContainer);
// Construction
public:
	friend class CFX_MiniDockFrameWnd;
	CFX_DockContainer();
	CFX_DockContainer(CSize szFloatBar,CSize szMinFloatBar = (50,50));
// Attributes
public:
	int			m_nCyGripper; 
	CWnd		*m_pCreateDockWnd; //the windows belongs to Container
	int			m_iTabStyle;
	int			m_nBtnDownPage; //the currently selected number of tab		
	BOOL		m_bShow;//whether to be hidden
	BOOL		m_bUsePreState;
	BOOL		m_bUsedDocHistory;
// Implementation
public:
	int				HitTest(CPoint pt);
	void			OnStudClick();
	void			EnableDocking(DWORD dwDockStyle);
	CFX_TabPage*	DeletePage();
	CFX_TabPage*	DeletePage(int nPageNam);
	BOOL			DeletePage(CFX_TabPage* pTabPage);
	BOOL			AddPage(CFX_DockContainer* pDockContainer/*,BOOL bDockBottom = FALSE*/);
	int				GetInsertAddPos(int nHistoryPos);
	BOOL			AddPage(CFX_TabPage* pTabPage);
	BOOL			AddPage( CWnd* pWnd,  LPCWSTR csToolTip,LPCWSTR csText, LPCWSTR csName, HBITMAP  pBitmap = NULL, 
					int iTabStyle = TAB_NULL ,IReader_PanelView* pPanelView =NULL, BOOL bDockBottom = FALSE);
	BOOL			AddPage( CRuntimeClass *pClass, UINT nIDTemplate, LPCWSTR csToolTip, LPCWSTR csText, LPCWSTR csName,
					HBITMAP pBitmap = NULL, int iTabStyle = TAB_LEFT ,IReader_PanelView* pPanelView =NULL, BOOL bDockBottom = FALSE);
	BOOL			AddPageBefore(CFX_TabPage* pTabPage, int nIndex);
	BOOL			AddPageTail(CFX_TabPage* pTabPage);
	void			ShowBar(BOOL bShow, BOOL bDelay);

	int				GetActivePage(){return 	m_nActivePage;}
	void			GetActivePage(CString *strTapName);

	void			SelectItemChange(int nIndex);
	void			SelectItemChange(CString strTapName);
	void			setActivePage(CFX_TabPage* pTabPage);
	void			setActivePage(int nIndex);
	void			setActivePage(CString strTapName);

	void			GetAllActivePage(CList<CFX_TabPage*,CFX_TabPage*>  *pTabPagList);
	int				GetIndex(CString strTapName); // return -1 means not found
	void			HideTabPage(CFX_TabPage* pTabPage);
	int				GetTabPageCount(){return m_PtrlPage.GetCount();}

	
	void			ShowTabText(BOOL bShowTabText){m_bShowTabText = bShowTabText;}
	void			ShowTitleText(BOOL bShowTitleText){m_bShowTitleText = bShowTitleText;}
	BOOL			IsShowTabText(){return m_bShowTabText;}
	BOOL			IsShowTitleText(){return m_bShowTitleText;}
	void			DrawTitleText(CRect* pTextrect, CDC* pDC);
	BOOL			IsOnlyTabBar(){return m_bHideHandle;}
	void			SetOnlyTabBar();
	
	void			SetCanFloat(BOOL Canfloat){ m_bCanfloat = Canfloat;}
	void			SetShowTitle(BOOL ShowTitle){ m_bShowTitle = ShowTitle;}

	BOOL			DockAllPage();
	BOOL			GetALLContainer(CList<CFX_DockContainer*,CFX_DockContainer*> *pPtrlContainer);
	void			ShowALLContainer(BOOL bShow, BOOL bDelay);
	BOOL			GetALLFloatContainer(CList<CFX_DockContainer*,CFX_DockContainer*> *pPtrlContainer, BOOL bShow = FALSE);
	void			ShowALLFloatContainer(BOOL bShow, BOOL bDelay);
	void			ShowALLVisibleContainer(BOOL bShow, BOOL bDelay);
	BOOL			IsShowContainer();
	void			SetFristContainer(CFX_DockContainer* pFristContainer){m_pFristContainer = pFristContainer;}	
	CFX_DockContainer* GetFristContainer(){return m_pFristContainer;}

	virtual BOOL	HasGripper() const;
	virtual void	OnUpdateCmdUI(CFrameWnd* pTarget, BOOL bDisableIfNoHndler);
 	virtual BOOL	Create(LPCWSTR lpszWindowName, CWnd* pParentWnd, CSize sizeDefault, BOOL bHasGripper,
					UINT nID, BOOL bUsePreState = FALSE,DWORD dwStyle = WS_CHILD | CBRS_TOP | WS_CLIPCHILDREN);
	virtual BOOL	Create(LPCWSTR lpszWindowName, CWnd* pParentWnd, 
					UINT nID, DWORD dwStyle = WS_CHILD | CBRS_TOP| WS_CLIPCHILDREN);
	virtual			~CFX_DockContainer();

	CFX_TabPage*	GetTabPage(int nIndex);
	CFX_TabPage*	GetTabPage(int& nItemIndex, CPoint pt);
	CFX_TabPage*	GetTabPageByName(CString csTabName);
	BOOL			GetTabPageList(CList<CFX_TabPage*,CFX_TabPage*> *pPtrTabPage,BOOL bDockBottom);
	virtual void	UpdateSize();
	virtual void	GetClientRect(LPRECT lpRect,BOOL bMulti);

	CFX_DockContainer* SearchDockContainer(UINT nDockBarState);
	
	void			ChangeToolTip();
	void			DockLeftAdjustment();
	void			DockBottomAdjustment();
	CRect			GetTabBarRect(){return m_rtTabBar;}
	CRect			GetTitleRect(){ return CRect(m_rtTitleBar.left,m_rtTitleBar.top - TITLEBARHIGHT,m_rtTitleBar.right-DOCKEDGE,m_rtTitleBar.bottom - TITLEBARHIGHT);}

	
public:
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CFX_DockContainer)
    virtual CSize CalcFixedLayout(BOOL bStretch, BOOL bHorz);
    //}}AFX_VIRTUAL

protected:
	void			Move(CPoint pt);
	void			CanDrag(CPoint pt);
	void			StartDrag(CPoint pt);
	void			UpdateWindow();
	void			DrawHideHandle(CDC* pDC, CRect rect);
	void			DrawPageTab(CDC* pDC);
	BOOL			IsALLDockBottomPage();
	virtual void	NcPaintGripper(CDC* pDC,CRect rcClient);
	virtual void	NcCalcClient(LPRECT pRc, UINT nDockBarID);
	virtual void	NcTitleBar(CDC* pDC,CRect rcClient);
	virtual void	DrawArrow(CDC* pDC,LPPOINT lpPoints);
	virtual void	RecalcBarLayout();
	virtual void	RecalcBarLayout(CFX_TabPage* pTabPage,int nClickTabPage);
	void			LButtonUp(UINT nFlags, CPoint point);

	int  			GetDockBottomCount(); 
	
	CFX_DockContainer* CreateNewContainer(CFX_TabPage *pTabPage,CSize size,UINT nID,DWORD dwStyle = WS_CHILD | WS_VISIBLE | CBRS_TOP | WS_CLIPCHILDREN);
	BOOL			m_bActive;
	CRect			m_rtHideHandle;//hide real rect area of handle
	CRect			m_rtHideHdlArea;//hide click valid rect area of handle 
	CRect			m_rtTabBar;//tab bar
	CRect			m_rtTitleBar;//real rect area of tab bar

	CSize			m_OriginalVertSize;
	CSize			m_OriginalHorzSize;
	BOOL			m_bHideHandle;//whether according to HideHandle to be hidden
	BOOL			m_ShowContainer;
	HCURSOR			m_hHandCursor;
	

	CFX_CloseBtn	m_BtnHide;
	CFX_StudBtn		m_BtnStud;

	int				m_nActivePage; //show current tab line number
	BOOL			m_bShowTabText;//whether show TabText
	BOOL			m_bShowTitleText;//whether show TitleText

	BOOL			m_bCanfloat;
	BOOL			m_bShowTitle;
	BOOL			m_bShowFloat;
	CToolTipCtrl	m_ToolTip;
	BOOL			m_bNeedUpdate;
	int				m_nTipCount;

	virtual BOOL	PreTranslateMessage(MSG* pMsg);
	//{{AFX_MSG(CFX_DockContainer)
	afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg LRESULT OnNcHitTest(CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnNcLButtonUp(UINT nHitTest, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
 	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnPaint();
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg LRESULT OnGetObject(WPARAM wParam, LPARAM lParam);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	
private:
	//static BOOL bIsFristPage;
	CFont		m_font;
	CList <CFX_TabPage*,CFX_TabPage*>	m_PtrlPage;//linked list's point of tab
	CFX_DockContainer* m_pFristContainer;
	CPtrList	m_PtrlDPBContext;//linked list's point of CDockContext
	CArray < int, int >		m_arrPagePos;//record positions in history by add Page
	//CList <PAGESTATEINFO*,PAGESTATEINFO*> m_PtrlInfo;
};	//list<CFX_DockContainer*,CFX_DockContainer*> m_PtrlContainer;

/////////////////////////////////////////////////////////////////////////////
// CFX_DockPageContext dockcontext

class CFX_DockPageContext : public CDockContext
{


public:
	friend class CFX_DockContainer;
	void FreeAll();
	//Construction
	CFX_DockPageContext(CFX_ControlBar *pBar,CWnd* pCreateDockWnd) : CDockContext(pBar) 
	{ 
		m_pCreateDockWnd = pCreateDockWnd;
		m_pTgDockPage = NULL;
		m_DockEdgeRect.SetRectEmpty();
		
	}
	~CFX_DockPageContext(void);
	BOOL				m_bisPage;
	CFX_DockContainer*  m_pTgDockPage;
	CWnd*				m_pCreateDockWnd;
	CRect				m_DockEdgeRect;
	// Drag Operations
	virtual void		StartDrag(CPoint pt);
	virtual BOOL		Track();
	virtual void		Move(CPoint pt);
	virtual void		EndDrag(CPoint pt);
	DWORD				CanDock(CPoint pt);
	DWORD				CanDock(CRect rect, DWORD dwDockStyle,CPoint pt, CDockBar** ppDockBar = NULL);
	void				DrawFocusRect();
	CDockBar*			GetDockBar(DWORD dwOverDockStyle,CPoint pt);
	void				DrawDockEdgeRect();
protected:
	CPtrList			m_PtrlDPBar;
	CFX_DockContainer*  CreateNewBar();
	BOOL				isDockPage(CPoint pt);
	CRect				m_addRect;
};




class CFX_MiniDockFrameWnd : public CMiniDockFrameWnd
{
	DECLARE_DYNCREATE(CFX_MiniDockFrameWnd);
public:
	// Construction
//	virtual BOOL Create(CWnd* pParent, DWORD dwBarStyle);
protected:
    //{{AFX_MSG(CFX_ControlBar )
	afx_msg void OnPaint();
    afx_msg void OnClose();
	afx_msg void OnNcLButtonDown(UINT nHitTest, CPoint point);
	afx_msg void OnNcLButtonDblClk(UINT nHitTest, CPoint point);
	afx_msg void OnMove( int x, int y );
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	//afx_msg void OnWindowPosChanging( WINDOWPOS* lpwndpos );
    //}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	BOOL PreTranslateMessage(MSG *pMsg);
};

#endif // !defined(AFX_FX_DOCKCONTAINER_H__INCLUDED_)

//jetman/////////////////////////////////////////////////////////////////////////////
// class CMyDockBar : public CDockBar
// {
// public:	
// 	
// 	// Overrides
// 	// ClassWizard generated virtual function overrides
// 	//{{AFX_VIRTUAL(CChildFrame)
// public:
// 	virtual BOOL PreTranslateMessage(MSG* pMsg);
// 	//}}AFX_VIRTUAL
// 	
// 	// Implementation
// };
