#if !defined(AFX_PDFDISPLAYVIEW_H__DA9FFD51_83DD_46CB_8CA9_F99C7C95A829__INCLUDED_)
#define AFX_PDFDISPLAYVIEW_H__DA9FFD51_83DD_46CB_8CA9_F99C7C95A829__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PDFDisplayView.h : header file
//
#include "FindDlg.h"
/////////////////////////////////////////////////////////////////////////////
// CPDFDisplayView view

enum Tools{
	DRAW_ANNOT,
	HAND_TOOL,
	TEXTSELECT_TOOL ,
	PSI_TOOL,
	ANNOT_TOOL	
};



typedef struct PageToDisplay
{
	int cx;								//the position of horizontal scroll bar
	int cy;								//the position of vertical scroll bar
	int index;							//page index

}PAGETODISPLAY;

class CPDFReaderView;
class CReader_Document;
class CReader_Page;
class CPDFDisplayView : public CView
{
public:
	CPDFDisplayView();					// protected constructor used by dynamic creation
	virtual ~CPDFDisplayView();
	DECLARE_DYNCREATE(CPDFDisplayView)

public:
	FS_BOOL				m_bSelect;		//judge current tool is Text select  or not
	FS_BOOL				m_bHand;		//judge current tool is Hand tool or not
	FS_BOOL				m_bPSI;			//judge current tool is PSI tool or not
	FS_BOOL				m_bAnnotTool;	//judge current tool is annot tool or not
	FS_BOOL				m_bDrawBox;		//judge Draw  pageBox or not
	COLORREF			m_BoxColor;		//different color for different page box 
	CFont*				m_pFreeTextAnnotEditFont;
// Attributes
protected:
	SCROLLINFO			m_Horzsi;
	SCROLLINFO			m_Vertsi;
	FS_INT32			m_nRotate;
	FS_FLOAT			m_fZoom;
	FS_FLOAT			m_fLastZoom;
	
	FS_BOOL				m_bScrollFlag;
	FS_BOOL				m_bRatateChange;
	FS_INT32			m_nLogPixelX;
	FS_INT32			m_nLogPixelY;
	vector<PAGETODISPLAY> m_vecPageToDisplay;

	FS_BOOL				m_bFitPage;
	FS_BOOL				m_bFitHeight;
	FS_BOOL				m_bFitWidth;

	//for search
//	FindInfo m_FindInfo;
	FSPDF_TEXTSELECTION m_pTextSelection;
	FS_BOOL				m_bClick;
	CPoint				m_pLbdown;
	FS_BOOL				m_bLButtonDown;
	CReader_Page*		m_pdfPage;

	CPDFReaderView*		m_pPDFReaderView;
	CReader_Document*	m_pReaderDocument;
	
	//for select
	FS_BOOL				m_bHasChar;
	FS_INT32			m_nStartCharIndex;
	FS_INT32			m_nEndCharIndex;
	FS_BOOL				m_bStarSelect;
	FSCRT_RECTF			m_rCaret;

	//Add Annot
	char*				m_pAnnotType;
	CPoint				m_StartPoint;
	CPoint				m_EndPonit;
	FS_INT32			m_nAnnotCur;
	CPoint				m_AnnotLastPoint;

	//Annot Edit
	CEdit*				m_pEdit;
	FS_BOOL				m_bAnnotIsEdit;
	CString				m_csFreeText;
	HBRUSH				m_brMine ;

	//for annotation tool
	FS_BOOL				m_bDrawAnnot;
	
	//for search text
	FS_INT32			m_nSearchPageIndex;
	CArray<FSCRT_RECTF> m_rSearchPage;	
	FindDlg*			m_pSearchDlg;		//search dialog	
	FS_INT32			m_nSearchFlag;			
	CString				m_strSearch;		//search text

	//for select text
	FS_BOOL				m_bSelecting;
	CArray<FSCRT_RECTF>	m_rSelectPage;
	FS_INT32			m_nSelectPage;
	CPoint              m_ptSelectStart;
	//for psi
	FSCRT_APPHANDLER	m_hAppHandler;
	FSCRT_PSI			m_hPSI;
	FSCRT_RENDERER		m_hRenderer;
	FSCRT_BITMAP		m_hBitmap;
	FSCRT_BITMAPINFO*	m_pBitmapInfo;
	FS_DWORD			m_dInkColor;
	FS_INT32			m_nInkDia;
	FS_FLOAT			m_fOpacity;
	FSCRT_RECTF			m_rPSIViewRect;
	FS_BOOL				m_bDrawing;
	CPoint				m_LastPoint;
	FS_INT32			m_curPsiIndex;

	//for page box
	FSCRT_RECTF			m_rPageArea;
	FS_INT32			m_nCurPageIndex;
	FS_INT32			m_nBoxPage;

	FS_INT32			m_nStartPageIndex ;// the first page to ScrollPos
	FS_INT32			m_nEndPageIndex;
	
	//for renderoption
	FS_BOOL				m_bRenderOption;
	FS_INT32 			m_nTextSelectPage;	

	FS_INT32			m_bSupportUnicode;
	FSCRT_CALLBACK_TIMER m_lpTimerFunc;

public:
	//MFC view
	FS_BOOL		IsVisiblePage(FS_INT32 index);
	FS_INT32	GetCurVisiblePageIndex();
	VOID		ReleasePageTemData(FS_INT32 iPageStart, FS_INT32 iPgaeEnd);
	FS_INT32	GetRotate();
	CPDFReaderView* GetPDFReaderView();
	FS_FLOAT	GetScale();
	void		SetPDFReaderView(CPDFReaderView* pPDFReaderView);
	void		InitScrollSize(int nLogPixelX, int nLogPixelY);
	void		SetVisiblePageByScrollPos(int pose = 0);
	void		SetVisiblePageByIndex(int nIdex);
	void		ResetCurrentPageIndex(){m_nCurPageIndex = m_nStartPageIndex;}
	FS_BOOL		MovePage(CPoint curPoint, CPoint toPoint);
	FS_BOOL		MovePage(short zDelta);
	FS_FLOAT	GetCenterPos(int nPage);
	void		RenderPage(CDC* pDC, int Index, int Width, int Height, int cx, int cy);
	void		RenderPageByGE(CDC* pDC, int Index, int Width, int Height, int cx, int cy);

	CReader_Page* GetPage(CPoint point);
	FS_BOOL		GetPageMatrix(int nPageIndex, FSCRT_MATRIX* matrix);
	FS_BOOL     GetPageMatrixForPrint(int nPageIndex, FSCRT_MATRIX* matrix);
	FS_BOOL		DocToWindow(int nPageIndex, FSCRT_RECTF rcDoc, CRect& rcWindow);
	FS_BOOL		WindowToDoc(int nPageIndex, int window_x, int window_y, FS_FLOAT& doc_x, FS_FLOAT& doc_y);
	FS_BOOL		WindowToDoc(int nPageIndex, CRect rcWindow, FSCRT_RECTF& rcDoc);
	FS_BOOL     WindowToDocForPrint(int nPageIndex, CRect rcWindow, FSCRT_RECTF& rcDoc);
	void		ChangeTool(Tools nIndex);

	//for search
	void		SearchText(CString strFind, BOOL bCase, BOOL bWholeword, int Direction);
	void		GetSearchTextRect();
	void		DrawSearchText(CDC* pDc,FSCRT_RECTF rc);

	//for select
	FS_BOOL		GetCharIndexByPoint(CPoint pt, int& index);
	FS_BOOL		GetStartCharIndexByPoint(CPoint pt, int& index);
	void		GetSelectRect(int starIndex,int endIndex);
	void		CreateCaret(CPoint pt);
	void		DrawSelectText(CDC* pDc,FSCRT_RECTF rc);
	void		DrawCaret(FSCRT_RECTF rc);

	//for psi
	void		InitPSI();
	void		ReleasePSI();
	FS_RESULT	PsiFlush(const FSCRT_RECTF* rect);
	void		SetViewRect(CPoint point);
	void		PsiToAnnotation(CPoint& point);

	//for pagebox
	void		GetBox(FS_INT32 areaType);
	void		DrawBox(CDC* pDc,FSCRT_RECTF rect,COLORREF color = RGB(0,0,255));
	void		GetContentBBox(FS_INT32 mode);
	void		ClearBox();

	VOID		RenderRefresh();		//all views need be refresh after set Gamma in render property
	FS_BOOL		IsInPageRect(CPoint point);

	FS_INT32	CreateTimer(FS_LPVOID,  FS_INT32 uElapse, FSCRT_CALLBACK_TIMER lpTimerFunc);
	void		DestroyTime(FS_INT32 nTimerID);

	void		ShowTextSelectMenu(CPoint point);
	BOOL		IsSupportUnicodeSel();
	void		SetClipboardData(FSCRT_BSTR csText);
	void		KillFormfillerFocus();
	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPDFDisplayView)
protected:
	virtual void OnInitialUpdate();
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);

	afx_msg void OnFilePrint();
	afx_msg void OnZoomIn();
	afx_msg void OnZoomOut();
	afx_msg void OnSelect();
	afx_msg void OnPsi();
	afx_msg void OnAnnotSelect();

	afx_msg void OnAnnotUnderLine();
	afx_msg void OnAnnotFreeText();
	afx_msg void OnAnnotLink();
	afx_msg void OnAnnotNotes();
	afx_msg void OnAnnotHightLight();

	afx_msg void OnAnnotAnnotTextEditKillFocus();
	afx_msg void OnUpdateFileSaveAs(CCmdUI* pCmdUI);

	protected:
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
	//}}AFX_VIRTUAL
	
// Implementation
protected:
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(CPDFDisplayView)
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint point);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnSearch();

	
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnRotationLeft();
	afx_msg void OnRotationRight();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PDFDISPLAYVIEW_H__DA9FFD51_83DD_46CB_8CA9_F99C7C95A829__INCLUDED_)
