
// PDFReaderDoc.cpp : implementation of the CPDFReaderDoc class
//

#include "stdafx.h"
// SHARED_HANDLERS can be defined in an ATL project implementing preview, thumbnail
// and search filter handlers and allows sharing of document code with that project.
#ifndef SHARED_HANDLERS
#include "PDFReader.h"
#endif

#include "PDFReaderDoc.h"
#include "./FrameworkImpl/PDFReaderApp.h"
#include "./FrameworkImpl/PDFReaderDocument.h"

#include <propkey.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CPDFReaderDoc

IMPLEMENT_DYNCREATE(CPDFReaderDoc, CDocument)

BEGIN_MESSAGE_MAP(CPDFReaderDoc, CDocument)
END_MESSAGE_MAP()


// CPDFReaderDoc construction/destruction

CPDFReaderDoc::CPDFReaderDoc()
{
	// TODO: add one-time construction code here
	m_pReaderDocument = NULL;
}

CPDFReaderDoc::~CPDFReaderDoc()
{
	if(m_pReaderDocument)
	{
		theApp.m_pReaderApp->RemoveDocument(m_pReaderDocument);
		IReader_Document* pReaderDocument = theApp.m_pReaderApp->GetCurrentDocument();
		if (m_pReaderDocument == pReaderDocument)
		{
			theApp.m_pReaderApp->SetCurrentDocument(NULL);
		}
		delete m_pReaderDocument;
		m_pReaderDocument = NULL;
	}
}

BOOL CPDFReaderDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}




// CPDFReaderDoc serialization

void CPDFReaderDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

#ifdef SHARED_HANDLERS

// Support for thumbnails
void CPDFReaderDoc::OnDrawThumbnail(CDC& dc, LPRECT lprcBounds)
{
	// Modify this code to draw the document's data
	dc.FillSolidRect(lprcBounds, RGB(255, 255, 255));

	CString strText = _T("TODO: implement thumbnail drawing here");
	LOGFONT lf;

	CFont* pDefaultGUIFont = CFont::FromHandle((HFONT) GetStockObject(DEFAULT_GUI_FONT));
	pDefaultGUIFont->GetLogFont(&lf);
	lf.lfHeight = 36;

	CFont fontDraw;
	fontDraw.CreateFontIndirect(&lf);

	CFont* pOldFont = dc.SelectObject(&fontDraw);
	dc.DrawText(strText, lprcBounds, DT_CENTER | DT_WORDBREAK);
	dc.SelectObject(pOldFont);
}

// Support for Search Handlers
void CPDFReaderDoc::InitializeSearchContent()
{
	CString strSearchContent;
	// Set search contents from document's data. 
	// The content parts should be separated by ";"

	// For example: strSearchContent = _T("point;rectangle;circle;ole object;");
	SetSearchContent(strSearchContent);
}

void CPDFReaderDoc::SetSearchContent(const CString& value)
{
	if (value.IsEmpty())
	{
		RemoveChunk(PKEY_Search_Contents.fmtid, PKEY_Search_Contents.pid);
	}
	else
	{
		CMFCFilterChunkValueImpl *pChunk = NULL;
		ATLTRY(pChunk = new CMFCFilterChunkValueImpl);
		if (pChunk != NULL)
		{
			pChunk->SetTextValue(PKEY_Search_Contents, value, CHUNK_TEXT);
			SetChunkValue(pChunk);
		}
	}
}

#endif // SHARED_HANDLERS

// CPDFReaderDoc diagnostics

#ifdef _DEBUG
void CPDFReaderDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CPDFReaderDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

BOOL CPDFReaderDoc::OnOpenDocument(LPCTSTR lpszPathName)
{
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;

	if(m_pReaderDocument)
	{
		theApp.m_pReaderApp->RemoveDocument(m_pReaderDocument);
		delete m_pReaderDocument;
		m_pReaderDocument = NULL;
	}

	m_csFilePath = lpszPathName;
	m_pReaderDocument = new CReader_Document(theApp.m_pReaderApp);
	BOOL bLoadPDFDocument = m_pReaderDocument->LoadPDFDocument(lpszPathName);
	if (!bLoadPDFDocument)
	{
		return FALSE;
	}

	theApp.m_pReaderApp->AddDocument(m_pReaderDocument);

	return TRUE;
}

CReader_Document* CPDFReaderDoc::GetReaderDocument()
{
	return m_pReaderDocument;
}

void CPDFReaderDoc::OnCloseDocument() 
{
	// TODO: Add your specialized code here and/or call the base class
	CDocument::OnCloseDocument();
}
// CPDFReaderDoc commands

