// Page_Creation.cpp : implementation file
//

#include "stdafx.h"
#include "PDFReader.h"
#include "Page_Creation.h"
#include "afxdialogex.h"


// Page_Creation dialog

IMPLEMENT_DYNAMIC(Page_Creation, CDialogEx)

Page_Creation::Page_Creation(CWnd* pParent /* = NULL*/)
	: CDialogEx(Page_Creation::IDD, pParent)
{

}

Page_Creation::~Page_Creation()
{
}

void Page_Creation::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(Page_Creation, CDialogEx)
END_MESSAGE_MAP()


// Page_Creation message handlers

BOOL Page_Creation::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// TODO: Add extra initialization here
	CReader_Document* pDoc = (CReader_Document*)(theApp.m_pReaderApp->GetCurrentDocument());
	m_cStr = pDoc->GetFilePathStr();
	GetDlgItem(IDC_CREATION_EDIT_FILES)->SetWindowTextW(m_cStr);
	m_hDocument = pDoc->GetDocument();
	
	CFileStatus filestatus;
	CFile::GetStatus(m_cStr, filestatus);
	CString tmp;
	tmp.Format(_T("%0.2f"), filestatus.m_size/1024.0f/1024.0f);
	m_cStr = tmp;
	m_cStr = m_cStr + _T("MB");
	tmp.Format(_T("%d"), filestatus.m_size);
	m_cStr = m_cStr + _T("(") + tmp + _T("Bytes)");
	GetDlgItem(IDC_CREATION_STATIC_FILE_SIZE)->SetWindowTextW(m_cStr);

	GetMetadata("Title", IDC_CREATION_EDIT_TITLE);
	GetMetadata("Author", IDC_CREATION_EDIT_AUTHOR);
	GetMetadata("Subject", IDC_CREATION_EDIT_SUBJECT);
	GetMetadata("Keywords", IDC_CREATION_EDIT_KEYWORDS);
	GetMetadata("Creator", IDC_CREATION_STATIC_CREATOR);
	GetMetadata("Producer", IDC_CREATION_STATIC_PRODUCER);

	GetDateTime("CreationDate", IDC_CREATION_STATIC_CREATED);
	GetDateTime("ModDate", IDC_CREATION_STATIC_MODIFIED);

	CPDFDisplayView* pDisplayView = pDoc->GetPDFDisplayView();
	CReader_Page* pPage = (CReader_Page*)pDoc->GetPage(pDisplayView->GetCurVisiblePageIndex());
	FSCRT_PAGE page = pPage->GetPage();
	float width, heigh;
	FS_RESULT ret = FSPDF_Page_GetSize(page, &width, &heigh);
	tmp.Format(_T("%0.2f"), width/72.0f);
	m_cStr = tmp + _T(" ") + _T("x");
	tmp.Format(_T("%0.2f"), heigh/72.0f);
	m_cStr = m_cStr + tmp + _T(" in");
	GetDlgItem(IDC_CREATION_STATIC_PAGE_SIZE)->SetWindowTextW(m_cStr);

	FS_INT32 count;
	ret = FSPDF_Doc_CountPages(m_hDocument, &count);
	tmp.Format(_T("%d"), count);
	m_cStr = tmp;
	GetDlgItem(IDC_CREATION_STATIC_TOTAL_PAGES)->SetWindowTextW(m_cStr);
	return TRUE; // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}


CString Page_Creation::UTF8TOUTF16(FSCRT_BSTR& utf8)
{
	FS_DWORD lenth = 0;
	FS_RESULT ret = FSCRT_UTF8_ToUTF16LE(&utf8, NULL, &lenth);
	lenth += 1;
	WCHAR* buffer = new WCHAR[lenth];
	memset(buffer, 0, sizeof(WCHAR)*lenth);
	ret = FSCRT_UTF8_ToUTF16LE(&utf8, (FS_WORD*)buffer, &lenth);
	CString wstr = buffer;
	delete []buffer;
	buffer = NULL;
	return wstr;
}

void Page_Creation::GetMetadata(char* key, int nID)
{
	FSCRT_BSTR bstrKey, metadataStr;
	FSCRT_BStr_Init(&bstrKey);
	FSCRT_BStr_Init(&metadataStr);
	FSCRT_BStr_Set(&bstrKey, key, strlen(key));
	FS_RESULT ret = FSPDF_Metadata_GetString(m_hDocument, &bstrKey, &metadataStr);
	m_cStr = UTF8TOUTF16(metadataStr);
	GetDlgItem(nID)->SetWindowTextW(m_cStr);
	FSCRT_BStr_Clear(&bstrKey);
	FSCRT_BStr_Clear(&metadataStr);
}

void Page_Creation::GetDateTime(char* key, int nID)
{
	FSCRT_BSTR bstrKey;
	FSCRT_DATETIMEZONE dt;
	FSCRT_BStr_Init(&bstrKey);
	FSCRT_BStr_Set(&bstrKey, key, strlen(key));
	FS_RESULT ret = FSPDF_Metadata_GetDateTime(m_hDocument, &bstrKey, &dt);
	CString tmp;
	tmp.Format(_T("%d"), dt.year);
	m_cStr = tmp;
	m_cStr.Append(_T("-"));
	tmp.Format(_T("%d"), dt.month);
	m_cStr.Append(tmp);
	m_cStr.Append(_T("-"));
	tmp.Format(_T("%d"), dt.day);
	m_cStr.Append(tmp);
	m_cStr.Append(_T(" "));
	tmp.Format(_T("%d"), dt.hour);
	m_cStr.Append(tmp);
	m_cStr.Append(_T("-"));
	tmp.Format(_T("%d"), dt.minute);
	m_cStr.Append(tmp);
	m_cStr.Append(_T("-"));
	tmp.Format(_T("%d"), dt.second);
	m_cStr.Append(tmp);
	GetDlgItem(nID)->SetWindowTextW(m_cStr);
	FSCRT_BStr_Clear(&bstrKey);
}