// Page_Initial_View.cpp : implementation file
//

#include "stdafx.h"
#include "PDFReader.h"
#include "Page_Initial_View.h"
#include "afxdialogex.h"


// Page_Initial_View dialog

IMPLEMENT_DYNAMIC(Page_Initial_View, CDialogEx)

Page_Initial_View::Page_Initial_View(CWnd* pParent /* = NULL*/)
	: CDialogEx(Page_Initial_View::IDD, pParent)
{

}

Page_Initial_View::~Page_Initial_View()
{
}

void Page_Initial_View::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(Page_Initial_View, CDialogEx)
END_MESSAGE_MAP()


// Page_Initial_View message handlers


BOOL Page_Initial_View::OnInitDialog()
{
	CDialogEx::OnInitDialog();
	CReader_Document* pDoc = (CReader_Document*)(theApp.m_pReaderApp->GetCurrentDocument());
	m_hDocument = pDoc->GetDocument();
	GetUIVisibility("HideToolbar", IDC_STATIC_HIDETOOLBAR);
	GetUIVisibility("HideMenubar", IDC_STATIC_HIDEMEN);
	GetUIVisibility("HideWindowUI", IDC_STATIC_HIDEWIN_UI);
	GetUIVisibility("FitWindow", IDC_STATIC_FITWIDTH);
	GetUIVisibility("CenterWindow", IDC_STATIC_CEN_WIN);
	GetUIVisibility("DisplayDocTitle", IDC_STATIC_DOC_TITLE);

	GetNonFullScreenPageMode();

	GetReadingDirection();

	GetPrintScale();

	GetPrintCopies();

	// TODO: Add extra initialization here

	return TRUE; // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}


void Page_Initial_View::GetUIVisibility(char* key, int nID)
{
	FS_BOOL uiVisible = FALSE;
	FSCRT_BSTR uiItem;
	FSCRT_BStr_Init(&uiItem);
	FSCRT_BStr_Set(&uiItem, (FS_LPCSTR)key, (FS_DWORD)strlen(key));
	FS_RESULT ret = FSPDF_ViewerPref_GetUIVisibility(m_hDocument, &uiItem, &uiVisible);
	if (uiVisible == TRUE)
	{
		GetDlgItem(nID)->SetWindowTextW(_T("exist"));
	}
	else
	{
		GetDlgItem(nID)->SetWindowTextW(_T("Not exist"));
	}
	FSCRT_BStr_Clear(&uiItem);
}


void Page_Initial_View::GetNonFullScreenPageMode(void)
{
	FS_INT32 displayMode;
	FS_RESULT ret = FSPDF_ViewerPref_GetNonFullScreenPageMode(m_hDocument, &displayMode);
	switch (displayMode)
	{
	case FSPDF_DISPLAYMODE_USENONE:
		{
			GetDlgItem(IDC_INI_VIEW_STATIC_PAGE_MODE)->SetWindowTextW(_T("USENONE"));
		}
		break;
	case FSPDF_DISPLAYMODE_USEOUTLINES:
		{
			GetDlgItem(IDC_INI_VIEW_STATIC_PAGE_MODE)->SetWindowTextW(_T("USEOUTLINES"));
		}
		break;
	case FSPDF_DISPLAYMODE_USETHUMBS:
		{
			GetDlgItem(IDC_INI_VIEW_PAGEMODE)->SetWindowTextW(_T("USETHUMBS"));
		}
		break;
	case FSPDF_DISPLAYMODE_USEOC:
		{
			GetDlgItem(IDC_INI_VIEW_PAGEMODE)->SetWindowTextW(_T("USEOC"));
		}
		break;
	}
}


void Page_Initial_View::GetReadingDirection(void)
{
	FS_INT32 direction;
	FS_RESULT ret = FSPDF_ViewerPref_GetReadingDirection(m_hDocument, &direction);
	switch (direction)
	{
	case FSPDF_READDIRECT_L2R:
		{
			GetDlgItem(IDC_INI_VIEW_STATIC_DIRECTION)->SetWindowTextW(_T("left-to-right"));
		}
		break;
	case FSPDF_READDIRECT_R2L:
		{
			GetDlgItem(IDC_INI_VIEW_STATIC_DIRECTION)->SetWindowTextW(_T("right-to-left"));
		}
		break;
	}
}


void Page_Initial_View::GetPrintScale(void)
{
	FSCRT_BSTR printScale;
	FSCRT_BStr_Init(&printScale);
	FS_RESULT ret = FSPDF_ViewerPref_GetPrintScale(m_hDocument, &printScale);
	CString str = UTF8TOUTF16(printScale);
	GetDlgItem(IDC_INI_VIEW_STATIC_PRINT_SCALE)->SetWindowTextW(str);
	FSCRT_BStr_Clear(&printScale);
}

CString Page_Initial_View::UTF8TOUTF16(FSCRT_BSTR& utf8)
{
	FS_DWORD lenth = 0;
	FS_RESULT ret = FSCRT_UTF8_ToUTF16LE(&utf8, NULL, &lenth);
	lenth += 1;
	WCHAR* buffer = new WCHAR[lenth];
	memset(buffer, 0, sizeof(WCHAR)*lenth);
	ret = FSCRT_UTF8_ToUTF16LE(&utf8, (FS_WORD*)buffer, &lenth);
	CString wstr = buffer;
	delete []buffer;
	buffer = NULL;
	return wstr;
}

void Page_Initial_View::GetPrintCopies(void)
{
	FS_INT32 copies;
	FS_RESULT ret = FSPDF_ViewerPref_GetPrintCopies(m_hDocument, &copies);
	CString str;
	str.Format(_T("%d"), copies);
	GetDlgItem(IDC_INI_VIEW_STATIC_PRINT_COPIES)->SetWindowTextW(str);
}

