// Page_Security.cpp : implementation file
//

#include "stdafx.h"
#include "PDFReader.h"
#include "Page_Security.h"
#include "afxdialogex.h"


// Page_Security dialog

IMPLEMENT_DYNAMIC(Page_Security, CDialogEx)

Page_Security::Page_Security(CWnd* pParent /* = NULL*/)
	: CDialogEx(Page_Security::IDD, pParent)
{

}

Page_Security::~Page_Security()
{
}

void Page_Security::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PROPERTYDLG_SEC_COM, m_cBox);
}


BEGIN_MESSAGE_MAP(Page_Security, CDialogEx)
END_MESSAGE_MAP()


// Page_Security message handlers

 
BOOL Page_Security::OnInitDialog()
{
	CDialogEx::OnInitDialog();
	((CButton*)GetDlgItem(IDC_PROPERTYDLG_CHANGE))->EnableWindow(FALSE);
	((CComboBox*)GetDlgItem(IDC_PROPERTYDLG_SEC_COM))->EnableWindow(FALSE);

	// TODO: Add extra initialization here
	CReader_Document* pDoc = (CReader_Document*)(theApp.m_pReaderApp->GetCurrentDocument());
	m_hDocument = pDoc->GetDocument();
	FS_INT32 type;
	FS_RESULT ret = FSPDF_Doc_GetEncryptionType(m_hDocument, &type);
	if (FSPDF_ENCRYPTTYPE_NOENCRYPT == type)
	{
		GetDlgItem(IDC_SECURITY_STATIC_SEC_METHOD)->SetWindowTextW(_T("None"));
	}
	else
	{
		GetDlgItem(IDC_SECURITY_STATIC_SEC_METHOD)->SetWindowTextW(_T("Allowed"));
	}

	ret = FSPDF_Doc_GetPasswordType(m_hDocument, &type);
	if (FSPDF_PASSWORDTYPE_USERPASSWORD == type)
	{
		GetDlgItem(IDC_SECURITY_STATIC_USER_PWD)->SetWindowTextW(_T("Allowed"));
	}
	else
	{
		GetDlgItem(IDC_SECURITY_STATIC_USER_PWD)->SetWindowTextW(_T("None"));
	}
	if(FSPDF_PASSWORDTYPE_OWNERPASSWORD == type)
	{
		GetDlgItem(IDC_SECURITY_STATIC_OWN_PWD)->SetWindowTextW(_T("Allowed"));
	}
	else
	{
		GetDlgItem(IDC_SECURITY_STATIC_OWN_PWD)->SetWindowTextW(_T("None"));
	}

	FS_DWORD permissions;
	ret = FSPDF_Doc_GetUserPermissions(m_hDocument, &permissions);
	if(permissions&FSPDF_PERMISSION_PRINT_HIGH)
	{
		GetDlgItem(IDC_SECURITY_STATIC_PRINT)->SetWindowTextW(_T("High Resolution Print"));
	}
	if (permissions&FSPDF_PERMISSION_PRINT)
	{
		GetDlgItem(IDC_SECURITY_STATIC_PRINT)->SetWindowTextW(_T("Allowed"));
	}
	else
	{
		GetDlgItem(IDC_SECURITY_STATIC_PRINT)->SetWindowTextW(_T("None"));
	}
	if (permissions&FSPDF_PERMISSION_MODIFY)
	{
		GetDlgItem(IDC_SECURITY_STATIC_MOD_DOC)->SetWindowTextW(_T("Allowed"));
	}
	else
	{
		GetDlgItem(IDC_SECURITY_STATIC_MOD_DOC)->SetWindowTextW(_T("None"));
	}
	if (permissions&FSPDF_PERMISSION_EXTRACT)
	{
		GetDlgItem(IDC_SECURITY_STATIC_CON_EXT)->SetWindowTextW(_T("Allowed"));
	}
	else 
	{
		GetDlgItem(IDC_SECURITY_STATIC_CON_EXT)->SetWindowTextW(_T("None"));
	}
	if (permissions&FSPDF_PERMISSION_FILLFORM)
	{
		GetDlgItem(IDC_SECURITY_STATIC_FILL_IN_FOR)->SetWindowTextW(_T("Allowed"));
	}
	else 
	{
		GetDlgItem(IDC_SECURITY_STATIC_FILL_IN_FOR)->SetWindowTextW(_T("None"));
	}
	if (permissions&FSPDF_PERMISSION_ASSEMBLE)
	{
		GetDlgItem(IDC_SECURITY_STATIC_DOC_ASS)->SetWindowTextW(_T("Allowed"));
	}
	else
	{
		GetDlgItem(IDC_SECURITY_STATIC_DOC_ASS)->SetWindowTextW(_T("None"));
	}

	return TRUE; // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}
