// PasswordDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PDFReader.h"
#include "PasswordDlg.h"
#include "afxdialogex.h"
#include "MainFrm.h"
#include "ChildFrm.h"
#include "FrameworkImpl/PDFReaderDocument.h"
#include "PDFReader.h"
#include "FrameworkImpl/PDFReaderApp.h"

// PasswordDlg dialog

IMPLEMENT_DYNAMIC(PasswordDlg, CDialog)

PasswordDlg::PasswordDlg(CWnd* pParent /* = NULL*/)
	: CDialog(PasswordDlg::IDD, pParent)
	, m_csPassword(_T(""))
	, m_pPDFDisplayView(NULL)
{

}

PasswordDlg::~PasswordDlg()
{
}

void PasswordDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_PASSWORD, m_csPassword);
	DDV_MaxChars(pDX, m_csPassword, 20);
}


BEGIN_MESSAGE_MAP(PasswordDlg, CDialog)
	ON_BN_CLICKED(IDOK, &PasswordDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, &PasswordDlg::OnBnClickedCancel)
END_MESSAGE_MAP()


// PasswordDlg message handlers


void PasswordDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	UpdateData();
	CPDFReaderApp* pReaderApp = (CPDFReaderApp*)AfxGetApp();
	if (pReaderApp->m_pReaderApp != NULL)
	{
		CReader_Document* pReaderDocument = (CReader_Document*)pReaderApp->m_pReaderApp->GetCurrentDocument();
		if (pReaderDocument != NULL)
			pReaderDocument->SetDocPassword(m_csPassword);
	}
	CDialog::OnOK();
}


void PasswordDlg::OnBnClickedCancel()
{
	// TODO: Add your control notification handler code here
	CDialog::OnCancel();
}

void PasswordDlg::ClearPassWord()
{
	m_csPassword = _T("");
	UpdateData(FALSE);
}