// RenderDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RenderDlg.h"
#include "afxdialogex.h"
#include "PDFReader.h"



// RenderDlg dialog

IMPLEMENT_DYNAMIC(RenderDlg, CDialog)

RenderDlg::RenderDlg(CWnd* pParent /* = NULL*/)
	: CDialog(RenderDlg::IDD, pParent)
{
	m_bSetDitherBits = FALSE;
	m_nStrBits = _T("");
	m_pPDFDisplayView = NULL;
	m_bSetGamma = FALSE;
	m_bSetClipRect = FALSE;
	m_bSetFlags = FALSE;
	m_nStrGamma = _T("");
	m_bLCDTEXT = FALSE;
	m_bGRAYSCALE = FALSE;
	m_nFlags = 0;
	m_bBGRSTRIPE = FALSE;
	m_bNONATIVETEXT = FALSE;
	m_bUSEANTIALIAS = FALSE;
	m_bTEXTGAMMA = FALSE;
	m_nStrLeft = _T("");
	m_nStrTop = _T("");
	m_nStrRight = _T("");
	m_nStrBottom = _T("");
}

RenderDlg::~RenderDlg()
{
}

void RenderDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_CHECK_SETDITHERBITS, m_bSetDitherBits);
	DDX_Text(pDX, IDC_EDIT_BITS, m_nStrBits);
	DDX_Check(pDX, IDC_CHECK_SETGAMMA, m_bSetGamma);
	DDX_Check(pDX, IDC_CHECK_SETCLIPRECT, m_bSetClipRect);
	DDX_Check(pDX, IDC_CHECK_SETFLAGS, m_bSetFlags);
	DDX_Text(pDX, IDC_EDIT_GAMMA, m_nStrGamma);
	DDX_Check(pDX, IDC_CHECK_LCDTEXT, m_bLCDTEXT);
	DDX_Check(pDX, IDC_CHECK_GRAYSCALE, m_bGRAYSCALE);
	DDX_Check(pDX, IDC_CHECK_BGRSTRIPE, m_bBGRSTRIPE);
	DDX_Check(pDX, IDC_CHECK_NONATIVETEXT, m_bNONATIVETEXT);
	DDX_Check(pDX, IDC_CHECK_USEANTIALIAS, m_bUSEANTIALIAS);
	DDX_Check(pDX, IDC_CHECK_TEXTGAMMA, m_bTEXTGAMMA);
	DDX_Text(pDX, IDC_EDIT_LEFT, m_nStrLeft);
	DDX_Text(pDX, IDC_EDIT_TOP, m_nStrTop);
	DDX_Text(pDX, IDC_EDIT_RIGHT, m_nStrRight);
	DDX_Text(pDX, IDC_EDIT_BOTTOM, m_nStrBottom);
}

BEGIN_MESSAGE_MAP(RenderDlg, CDialog)
//	ON_COMMAND(IDC_BUTTON_OK, OnIsOk)
	ON_BN_CLICKED(IDC_CHECK_SETFLAGS, &RenderDlg::OnBnClickedCheckSetflags)
	ON_BN_CLICKED(IDC_CHECK_SETDITHERBITS, &RenderDlg::OnBnClickedCheckSetditherbits)
	ON_BN_CLICKED(IDC_CHECK_SETGAMMA, &RenderDlg::OnBnClickedCheckSetgamma)
	ON_BN_CLICKED(IDC_CHECK_SETCLIPRECT, &RenderDlg::OnBnClickedCheckSetcliprect)
	ON_BN_CLICKED(IDC_BUTTON_OK, &RenderDlg::OnBnClickedButtonOk)
END_MESSAGE_MAP()


// RenderDlg message handlers
BOOL RenderDlg::OnInitDialog()
{
	m_pPDFDisplayView = (CPDFDisplayView*)(((CChildFrame *)((CMainFrame *)AfxGetMainWnd())->GetActiveFrame())->GetActiveView());
	
	//init Gamma
	m_bSetGamma = ((CPDFReaderApp*)AfxGetApp())->m_bGamma;
	if (m_bSetGamma)
	{
		m_nStrGamma.Format(_T("%f"), ((CPDFReaderApp*)AfxGetApp())->m_nGamma);
	}
	else
	{
		m_nStrGamma = _T("");
	}
	
	//init DitherBits
	m_bSetDitherBits = ((CPDFReaderApp*)AfxGetApp())->m_bBits;
	if (m_bSetDitherBits)
	{
		m_nStrBits.Format(_T("%d"), ((CPDFReaderApp*)AfxGetApp())->m_nBits); 
	}
	else
	{
		m_nStrBits = _T("");
	}

		
	m_bSetClipRect = ((CPDFReaderApp*)AfxGetApp())->m_bClipRect;
	if (m_bSetClipRect)
	{
		m_nStrLeft.Format(_T("%d"), ((CPDFReaderApp*)AfxGetApp())->m_rClip.left);
		m_nStrTop.Format(_T("%d"), ((CPDFReaderApp*)AfxGetApp())->m_rClip.top);
		m_nStrRight.Format(_T("%d"), ((CPDFReaderApp*)AfxGetApp())->m_rClip.right);
		m_nStrBottom.Format(_T("%d"), ((CPDFReaderApp*)AfxGetApp())->m_rClip.bottom);
		//m_pPDFDisplayView->SetClipRect(rect);
	}

	m_bSetFlags	 = ((CPDFReaderApp*)AfxGetApp())->m_bFlags ;
	if (m_bSetFlags)
	{
		m_nFlags = ((CPDFReaderApp*)AfxGetApp())->m_nFlags ;
		if (m_nFlags & FSCRT_RENDERERFLAG_GRAYSCALE)
		{
			m_bGRAYSCALE = TRUE;
		}
		if (m_nFlags & FSCRT_RENDERERFLAG_LCDTEXT)
		{
			m_bLCDTEXT = TRUE;
		}
		if (m_nFlags & FSCRT_RENDERERFLAG_BGRSTRIPE)
		{
			m_bBGRSTRIPE = TRUE;
		}
		if (m_nFlags & FSCRT_RENDERERFLAG_NONATIVETEXT)
		{
			m_bNONATIVETEXT = TRUE;
		}
		if (m_nFlags & FSCRT_RENDERERFLAG_USEANTIALIAS)
		{
			m_bUSEANTIALIAS = TRUE;
		}
		if (m_nFlags & FSCRT_RENDERERFLAG_TEXTGAMMA)
		{
			m_bTEXTGAMMA = TRUE;
		}
	}

	UpdateData(FALSE);
	
	
	OnBnClickedCheckSetditherbits();
	OnBnClickedCheckSetflags();
	OnBnClickedCheckSetcliprect();
	OnBnClickedCheckSetgamma();
	if (m_pPDFDisplayView)
	{
		return TRUE;
	}

	return FALSE;
}

void RenderDlg::OnBnClickedCheckSetflags()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (m_bSetFlags)
	{
		((CButton*)GetDlgItem(IDC_CHECK_LCDTEXT))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_CHECK_USEANTIALIAS))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_CHECK_NONATIVETEXT))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_CHECK_BGRSTRIPE))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_CHECK_GRAYSCALE))->EnableWindow(TRUE);
		((CButton*)GetDlgItem(IDC_CHECK_TEXTGAMMA))->EnableWindow(TRUE);
	}
	else
	{
		((CButton*)GetDlgItem(IDC_CHECK_LCDTEXT))->EnableWindow(FALSE);
		((CButton*)GetDlgItem(IDC_CHECK_USEANTIALIAS))->EnableWindow(FALSE);
		((CButton*)GetDlgItem(IDC_CHECK_NONATIVETEXT))->EnableWindow(FALSE);
		((CButton*)GetDlgItem(IDC_CHECK_BGRSTRIPE))->EnableWindow(FALSE);
		((CButton*)GetDlgItem(IDC_CHECK_GRAYSCALE))->EnableWindow(FALSE);
		((CButton*)GetDlgItem(IDC_CHECK_TEXTGAMMA))->EnableWindow(FALSE);
	}
}

void RenderDlg::OnBnClickedCheckSetditherbits()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (m_bSetDitherBits)
	{
		((CEdit*)GetDlgItem(IDC_EDIT_BITS))->EnableWindow(TRUE);
	}
	else
	{
		((CEdit*)GetDlgItem(IDC_EDIT_BITS))->EnableWindow(FALSE);
	}
}

void RenderDlg::OnBnClickedCheckSetgamma()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (m_bSetGamma)
	{
		((CEdit*)GetDlgItem(IDC_EDIT_GAMMA))->EnableWindow(TRUE);
	}
	else
	{
		((CEdit*)GetDlgItem(IDC_EDIT_GAMMA))->EnableWindow(FALSE);
	}
}

void RenderDlg::OnBnClickedCheckSetcliprect()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (m_bSetClipRect)
	{
		((CEdit*)GetDlgItem(IDC_EDIT_LEFT))->EnableWindow(TRUE);
		((CEdit*)GetDlgItem(IDC_EDIT_RIGHT))->EnableWindow(TRUE);
		((CEdit*)GetDlgItem(IDC_EDIT_TOP))->EnableWindow(TRUE);
		((CEdit*)GetDlgItem(IDC_EDIT_BOTTOM))->EnableWindow(TRUE);
	}
	else
	{
		((CEdit*)GetDlgItem(IDC_EDIT_LEFT))->EnableWindow(FALSE);
		((CEdit*)GetDlgItem(IDC_EDIT_RIGHT))->EnableWindow(FALSE);
		((CEdit*)GetDlgItem(IDC_EDIT_TOP))->EnableWindow(FALSE);
		((CEdit*)GetDlgItem(IDC_EDIT_BOTTOM))->EnableWindow(FALSE);
	}
}

void RenderDlg::OnBnClickedButtonOk()
{
	// TODO: Add your control notification handler code here
	((CPDFReaderApp*)AfxGetApp())->m_bRenderOption = TRUE;
	UpdateData(TRUE);
		
	((CPDFReaderApp*)AfxGetApp())->m_bBits = m_bSetDitherBits;
	if (m_bSetDitherBits)
	{
		((CPDFReaderApp*)AfxGetApp())->m_nBits = (FS_INT32)_tstoi(m_nStrBits);
		//m_pPDFDisplayView->SetDitherBits(bits);
	}
	

	((CPDFReaderApp*)AfxGetApp())->m_bGamma = m_bSetGamma;
	if (m_bSetGamma)
	{
		((CPDFReaderApp*)AfxGetApp())->m_nGamma = (FS_FLOAT)_tstof(m_nStrGamma);
	}
	
	((CPDFReaderApp*)AfxGetApp())->m_bClipRect = m_bSetClipRect;
	if (m_bSetClipRect)
	{
		((CPDFReaderApp*)AfxGetApp())->m_rClip.left = _tstoi(m_nStrLeft);
		((CPDFReaderApp*)AfxGetApp())->m_rClip.top = _tstoi(m_nStrTop);
		((CPDFReaderApp*)AfxGetApp())->m_rClip.right = _tstoi(m_nStrRight);
		((CPDFReaderApp*)AfxGetApp())->m_rClip.bottom = _tstoi(m_nStrBottom);

		if (!(((CPDFReaderApp*)AfxGetApp())->m_rClip.left < ((CPDFReaderApp*)AfxGetApp())->m_rClip.right 
			 && ((CPDFReaderApp*)AfxGetApp())->m_rClip.top < ((CPDFReaderApp*)AfxGetApp())->m_rClip.bottom))
		{
			MessageBox(_T("Clip Rectangle error"), _T("warning"), MB_OK);
			((CPDFReaderApp*)AfxGetApp())->m_bClipRect = FALSE;
		}
	}
	
	((CPDFReaderApp*)AfxGetApp())->m_bFlags = m_bSetFlags;
	if (m_bSetFlags)
	{
		m_nFlags = 0;
		if (m_bGRAYSCALE){m_nFlags |= FSCRT_RENDERERFLAG_GRAYSCALE;}
		if (m_bLCDTEXT){m_nFlags |= FSCRT_RENDERERFLAG_LCDTEXT;}
		if (m_bBGRSTRIPE){m_nFlags |= FSCRT_RENDERERFLAG_BGRSTRIPE;}
		if (m_bNONATIVETEXT){m_nFlags|= FSCRT_RENDERERFLAG_NONATIVETEXT;}
		if (m_bUSEANTIALIAS){m_nFlags|= FSCRT_RENDERERFLAG_USEANTIALIAS;}
		if (m_bTEXTGAMMA){m_nFlags|= FSCRT_RENDERERFLAG_TEXTGAMMA;}
		((CPDFReaderApp*)AfxGetApp())->m_nFlags = m_nFlags;
	}
	m_pPDFDisplayView->RenderRefresh();
}

void RenderDlg::OnOK()
{
	// TODO: Add your specialized code here and/or call the base class
	OnBnClickedButtonOk();
	CDialog::OnOK();
}
