﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Runtime.InteropServices;

namespace PDFReader_Demo_CSharp.Interface.GSDK
{
    class CRTInterface
    {
        public enum retCode
        {
            FSCRT_ERRCODE_INVALIDLICENSE = -10,
            FSCRT_ERRCODE_PASSWORD = -6,
            FSCRT_ERRCODE_ERROR = -1,
            FSCRT_ERRCODE_SUCCESS = 0,          
            FSCRT_ERRCODE_TOBECONTINUED = 1,
            FSCRT_ERRCODE_FINISHED = 2,
        };

        public enum licenseType
        {
            FSCRT_LICENSETYPE_AUTHORIZED = 0,
            FSCRT_LICENSETYPE_EVALUATION = 1,
            FSCRT_LICENSETYPE_INVALID = -10,
            FSCRT_LICENSETYPE_EXPIRED = 2,
        }

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_CreateMgr(bool useDefMgr);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern void FSDK_FinalizeLibrary();

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_UnlockLibrary([MarshalAs(UnmanagedType.LPStr)]string strLicenseID, [MarshalAs(UnmanagedType.LPStr)]string strUnlockCode);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_LicenseGetType(ref int type);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_InitPDFModule();

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_FinalizePDFModule();
       
        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern IntPtr FSDK_OpenFileW([MarshalAs(UnmanagedType.LPWStr)]string strFileName, [MarshalAs(UnmanagedType.LPWStr)]string strFileMode, bool useDef);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern IntPtr FSDK_OpenFileW_Win([MarshalAs(UnmanagedType.LPWStr)]string strFileName);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_CloseFile(IntPtr file);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_SetAppHander();

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_ProgressContinue(IntPtr progress);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_CreateBitmap(int width, int height, int format, IntPtr buffer, int stride, ref IntPtr bitmap);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_ReleaseBitmap(IntPtr bitmap, IntPtr buffer);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_FillBitmapRect(IntPtr bitmap, uint color, int left, int top, int right, int bottom);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_GetBitmapBuffer(IntPtr bitmap, ref IntPtr buffer);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_GetBitmapSize(IntPtr bitmap);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_RenderPageByGE(IntPtr page, int width, int height, int rotate, IntPtr bitmap);

    }
}
