﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace PDFReader_Demo_CSharp.Interface.GSDK.PDF
{
    class DocInterface
    {        
        public enum loadFlag
        {
            FSPDF_LOADFLAG_NOSTREAMCACHES = 1,
        }

        public enum trigger
        {
            /** @brief	A JavaScript action to be performed after opening a document. */
            FSPDF_TRIGGER_DOC_DO = 0,
            /** @brief	A JavaScript action to be performed before closing a document. */
            FSPDF_TRIGGER_DOC_WC = 1,
            /** @brief	A JavaScript action to be performed before saving a document. */
            FSPDF_TRIGGER_DOC_WS = 2,
            /** @brief	A JavaScript action to be performed after saving a document. */
            FSPDF_TRIGGER_DOC_DS = 3,
            /** @brief	A JavaScript action to be performed before printing a document. */
            FSPDF_TRIGGER_DOC_WP = 4,
            /** @brief	A JavaScript action to be performed after printing a document. */
            FSPDF_TRIGGER_DOC_DP = 5,
        }

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_LoadPDFDocument(IntPtr file, [MarshalAs(UnmanagedType.LPStr)]string password, int flag, ref IntPtr document);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_ClosePDFDocument(IntPtr document);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_CountPages(IntPtr document, ref int count);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_GetPage(IntPtr document, int index, ref IntPtr page);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_LoadForm(IntPtr document, ref IntPtr form);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_SetActionHandler(IntPtr document, IntPtr clientData);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_InitiateJavaScript(IntPtr document);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_DoJavaScriptAction(IntPtr document, int trigger);
    }
}
