﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace PDFReader_Demo_CSharp.Interface.GSDK.PDF
{
    class FormFillerInterface
    {
        public enum formFieldType
        {
            FSPDF_FORMFIELDTYPE_UNKNOWN	= 0,	/**< @brief	Unknown type. */
            FSPDF_FORMFIELDTYPE_PUSHBUTTON = 1,	/**< @brief	Push button type. */
            FSPDF_FORMFIELDTYPE_CHECKBOX = 2,	/**< @brief	Check box type. */
            FSPDF_FORMFIELDTYPE_RADIOBUTTON	= 3,	/**< @brief	Radio button type. */
            FSPDF_FORMFIELDTYPE_COMBOBOX = 4,	/**< @brief	Combo box type. */
            FSPDF_FORMFIELDTYPE_LISTBOX	= 5,	/**< @brief	List box type. */
            FSPDF_FORMFIELDTYPE_TEXTFIELD = 6,	/**< @brief	single line or multi-line texts. */
            FSPDF_FORMFIELDTYPE_UNSPECIFIED = FSPDF_FORMFIELDTYPE_UNKNOWN,	/**< @brief	Unspecified type. */
        }

        public enum eventType
        {
             FSCRT_EVENT_KEYDOWN = 1,			/**< @brief	The key command event: key down. */
             FSCRT_EVENT_KEYUP = 2,   			/**< @brief	The key command event: key up. */
             FSCRT_EVENT_CHAR = 3,				/**< @brief	The key command event: char. */
             FSCRT_EVENT_LBUTTONDOWN = 4,		/**< @brief	The mouse command event: the left button of the mouse is down. */
             FSCRT_EVENT_LBUTTONUP = 5,			/**< @brief	The mouse command event: the left button of the mouse is up. */
             FSCRT_EVENT_LBUTTONDBLCLK = 6,				/**< @brief	The mouse command event: the left button of the mouse is double clicked. */
             FSCRT_EVENT_RBUTTONDOWN = 7,						/**< @brief	The mouse command event: the right button of the mouse is down. */
             FSCRT_EVENT_RBUTTONUP = 8,						/**< @brief	The mouse command event: the right button of the mouse is up. */
             FSCRT_EVENT_RBUTTONDBLCLK = 9,			/**< @brief	The mouse command event: the right button of the mouse is double clicked. */
             FSCRT_EVENT_MBUTTONDOWN = 10,						/**< @brief	The mouse command event: the middle button of the mouse is down. */
             FSCRT_EVENT_MBUTTONUP = 11,						/**< @brief	The mouse command event: the middle button of the mouse is up. */
             FSCRT_EVENT_MBUTTONDBLCLK = 12,				/**< @brief	The mouse command event: the middle button of the mouse is double clicked. */
             FSCRT_EVENT_MOUSEMOVE = 13,						/**< @brief	The mouse command event: mouse move. */
             FSCRT_EVENT_MOUSEENTER	= 14,					/**< @brief	The mouse command event: mouse enter. */
             FSCRT_EVENT_MOUSEHOVER	= 15,					/**< @brief	The mouse command event: mouse hover. */
             FSCRT_EVENT_MOUSELEAVE	= 16,					/**< @brief	The mouse command event: mouse leave. */
             FSCRT_EVENT_MOUSEWHEEL	= 17,					/**< @brief	The mouse command event: mouse wheel. */
             FSCRT_EVENT_PAGEUP	= 18,							/**< @brief	The page up event. */
             FSCRT_EVENT_PAGEDOWN = 19,							/**< @brief	The page down event. */
	         FSCRT_EVENT_KILLFOCUS = 20,	
        }

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_BeginFormFiller(IntPtr form, ref IntPtr formFiller, IntPtr clientData);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_EndFormFiller(IntPtr formFiller);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_SetFormFillerHighlightColor(IntPtr formFiller, int fieldType, int color);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_ShowFormFillerHL(IntPtr formFiller, bool show);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_TriggerFormFillerWindowlessMouseEvent(IntPtr formFiller, IntPtr page, float a, float b, float c,
            float d, float e, float f, int eventType, int flag, float pointX, float pointY);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_TriggerFormFillerWindowlessCharEvent(IntPtr formFiller, int eventType, int code, int flag);

    }
}
