﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace PDFReader_Demo_CSharp.Interface.GSDK.PDF
{
    class PageInterface
    {
        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_GetPageSize(IntPtr page, ref float width, ref float height);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_GetPageMatrix(IntPtr page, int x, int y, int width, int height, int rotation
    , ref float a, ref float b, ref float c, ref float d, ref float e, ref float f);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_TransformPageMatrixToRectF(IntPtr page, int pageX, int pageY, int pageWidth, int pageHeight, int rotation, ref float left, ref float top, ref float right, ref float bottom);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_TransformWindowsToDocRectF(IntPtr page, int pageX, int pageY, int pageWidth, int pageHeight, int rotation, ref float left, ref float top, ref float right, ref float bottom);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_TransformPageMatrixToPointF(IntPtr page, int pageX, int pageY, int pageWidth, int pageHeight, int rotation, ref float pointX, ref float pointY);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_GetPageRotation(IntPtr page, ref int rotation);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_GetPageBox(IntPtr page, int pageBoxType, ref float left, ref float top, ref float right, ref float bottom);
       
        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_PageIsHasTransparency(IntPtr page, ref bool bHasTransparency);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_ParsePage(IntPtr page, int flag);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_PageLoadAnnots(IntPtr page);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_PageUnLoadAnnots(IntPtr page);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_PageAddAnnot(IntPtr page, float left, float top, float right, float bottom
            , [MarshalAs(UnmanagedType.LPStr)]string annotType, [MarshalAs(UnmanagedType.LPStr)]string filter, int index, ref IntPtr annot); 

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_SetPageRotation(IntPtr page, int rotation);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_LoadTextPage(IntPtr page, ref IntPtr textPage);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_StartSearch(IntPtr textPage, [MarshalAs(UnmanagedType.LPWStr)]string searchPattern, int flags, int startIndex, ref IntPtr textSearch);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_SearchFindNext(IntPtr textSearch, ref bool isMatch);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_SearchFindPrev(IntPtr textSearch, ref bool isMatch);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_ReleaseTextPage(IntPtr textPage);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_ReleaseTextSearch(IntPtr textSearch);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_GetTextSelection(IntPtr textSearch, ref IntPtr textSelection);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_CopyTextSelecionCharsToCilpBoard(IntPtr textSelection);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_CountTextSelectionPieces(IntPtr textSelection, ref int piecesCount);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_GetTextSelectionPiectRectF(IntPtr textSelection, int pieceIndex, ref float left, ref float top, ref float right, ref float bottom);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_SelectTextCaretRect(IntPtr textPage, float pageX, int charIndex, ref float left, ref float top, ref float right, ref float bottom);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_GetStartCharIndexByPoint(IntPtr textPage, float pageX, int charIndex, int startCharIndex, int endCharIndex, ref int index);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_GetCharIndexAtPos(IntPtr textPage, float x, float y, float tolerance, ref int charIndex);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_TextPageSelectByRange(IntPtr textPage, int start, int count, ref IntPtr textSelection);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_ReleaseTextSelection(IntPtr textSelection);

        [DllImport("FSDKDLL.dll", CallingConvention = CallingConvention.Cdecl)]
        public static extern int FSDK_ClosePage(IntPtr page);
    }
}
